app.controller("agendaViewController", ["$scope", "$rootScope", "$timeout", "$interval", "$state", "REQUEST", agendaViewController]);
function agendaViewController($scope, $rootScope, $timeout, $interval, $state, STCONST) {
    $scope.message = "";
    $scope.hourToDisplay = [];
    $scope.agendaData = [];

    dayName = ["WEBMOB_fhub2_common_Sunday", "WEBMOB_fhub2_common_monday", "WEBMOB_fhub2_common_Tuesday", "WEBMOB_fhub2_common_Wednesday", "WEBMOB_fhub2_common_Thursday", "WEBMOB_fhub2_common_Friday", "WEBMOB_fhub2_common_Saturday"];
    $scope.updateView = updateView;

    $scope.counter = 0;
    var prevRow = -1, prevCol = -1;
    function updateView(mesage) {
        console.log("update Agenda View ");
        prepareAgendaData();
        $interval(function() {$scope.counter++;}, 1000 * 60);

    }

    function prepareAgendaData() {

        $scope.agendaData = [];
        $scope.eventData.forEach(function(value) {
            var date = new Date(value.starts);
            var d=date.getMonth()+1;
            var eventTimeStamp =date.getFullYear()+"/"+d+"/"+ date.getDate();
//            //Dont Add Previous year data
            if ($scope.currentDate.getFullYear() > date.getFullYear()) {
                return;
            }
            // Dont add Previous Month data
            if ($scope.currentDate.getFullYear() === date.getFullYear() && $scope.currentDate.getMonth() > date.getMonth()) {
                return;
            }
            //Dont add previous date data
            if ($scope.currentDate.getDate() > date.getDate() && $scope.currentDate.getFullYear() >= date.getFullYear() && $scope.currentDate.getMonth() >= date.getMonth()) {
                return;
            }

            var agenda;
            var isProfileFilterSelected = false;
            var dayLable = getDayLable(value.starts);
            var allDayEventList = [];
            var eventsList = [];
            var allDayEventName = "";
            var profile = $scope.getProfileData(value.calendar);
            isProfileFilterSelected = profile.isFilterSelected;
            value["isProfileFilterSelectedForEvents"] = isProfileFilterSelected;
            value["avatar"] = profile.avatar;
            if(angular.isDefined(value.allDay) && value.allDay == true) {
                allDayEventName = value.summary;
                if(allDayEventList.indexOf(profile) === -1) {
                    allDayEventList.push(value);
                }
            } else {
                eventsList.push(value);
            }

            $scope.agendaData.forEach(function(agendaItem) {

                if(agendaItem.timeStamp == eventTimeStamp) {
                    agenda = agendaItem;
                }
            });

            if(agenda === undefined) {
                agenda = {timeStamp : eventTimeStamp, allDayEvent : allDayEventList, eventList : eventsList, lable : dayLable, allDayName : allDayEventName, isProfileFilterSelected:isProfileFilterSelected};
                $scope.agendaData.push(agenda);
            } else {
                agenda.lable = dayLable;
                for(var i = 0; i < allDayEventList.length; i++) {
                    if(agenda.allDayEvent.indexOf(allDayEventList[i]) === -1)
                        agenda.allDayEvent.push(allDayEventList[i]);
                }
                
//                var reverseAllDayEventList = [];
//                for (var i = 0; i < agenda.allDayEvent.length; i++) {
//                     reverseAllDayEventList[i] = agenda.allDayEvent[(agenda.allDayEvent.length -1) -i];
//                }
//                agenda.reverseAllDayEvent = reverseAllDayEventList;

                Array.prototype.push.apply(agenda.eventList, eventsList);
            }

        });
        $scope.agendaData = bubbleSort($scope.agendaData);
    }

    $scope.getAgendaDataCount = getAgendaDataCount;
    function getAgendaDataCount() {
        var count = 0;
        if (angular.isDefined($scope.agendaData)) {
            $scope.agendaData.forEach(function (agenda) {
                if (agenda.allDayEvent.length > 0) {
                    agenda.allDayEvent.forEach(function (allDayEvent) {
                        if (angular.isDefined(allDayEvent.isProfileFilterSelectedForEvents) && !allDayEvent.isProfileFilterSelectedForEvents)
                            count++;
                    });
                }
                if (angular.isDefined(agenda.isProfileFilterSelected) && !agenda.isProfileFilterSelected)
                    count++;
            });
        }
        return count;
    }
    $scope.checkAgendaDataFilterStatus = checkAgendaDataFilterStatus;
    function checkAgendaDataFilterStatus(agenda) {
        var showAgendaData = false;
        if (angular.isDefined(agenda)) {
            if (agenda.allDayEvent.length > 0) {
                agenda.allDayEvent.forEach(function (allDayEvent) {
                    if (angular.isDefined(allDayEvent.isProfileFilterSelectedForEvents) && !allDayEvent.isProfileFilterSelectedForEvents)
                        showAgendaData = true;
                });
            }
            if (agenda.eventList.length > 0) {
                agenda.eventList.forEach(function (eventList) {
                    if (angular.isDefined(eventList.isProfileFilterSelectedForEvents) && !eventList.isProfileFilterSelectedForEvents)
                        showAgendaData = true;
                });
            }
            return showAgendaData;
        }
    }
    
    $scope.firstAllDayEvent;
    $scope.getAgendaDataSummery = getAgendaDataSummery;
    function getAgendaDataSummery(allDayEvent){
        var eventSummary = "";
        allDayEvent.forEach(function (event) {
            if (angular.isDefined(event.isProfileFilterSelectedForEvents) && !event.isProfileFilterSelectedForEvents) {
                eventSummary = event.summary;
                $scope.firstAllDayEvent = event;
            }
        });
        return eventSummary;
    }
    
    $scope.getAgendaEventData = getAgendaEventData;
    function getAgendaEventData(allDayEvent){
        var eventData = null;
        allDayEvent.forEach(function (event) {
            if (angular.isDefined(event.isProfileFilterSelectedForEvents) && !event.isProfileFilterSelectedForEvents) {
                eventData = event;
            }
        });
        return eventData;
    }
    
    function getDayLable(timeStamp) {
        function WeekNumber(datevar) {
            datevar = new Date(+datevar);
            datevar.setHours(0,0,0,0);
            datevar.setDate(datevar.getDate() + 4 - (datevar.getDay()||7));
            var yearStart = new Date(datevar.getFullYear(),0,1);
            var weekNo = Math.ceil(( ( (datevar - yearStart) / 86400000) + 1)/7);
            return  [weekNo];
        }


        var dateObj = new Date(timeStamp);
        var today = new Date();
        var tomorrow = new Date();
        tomorrow.setDate(today.getDate() +1);
        
        var lable;
        if(today.getDate() === dateObj.getDate() && today.getMonth() === dateObj.getMonth() && today.getFullYear() === dateObj.getFullYear()) {
            lable = $scope.translation.WEBMOB_fhub2_common_today;
        } else if(tomorrow.getDate() === dateObj.getDate() && tomorrow.getMonth() === dateObj.getMonth() && tomorrow.getFullYear() === dateObj.getFullYear()) {
            lable = $scope.translation.WEBMOB_fhub2_common_tomorrow;
        } else if(WeekNumber(today)[0] === WeekNumber(dateObj)[0] && today.getMonth() === dateObj.getMonth() && today.getFullYear() === dateObj.getFullYear()) {
            lable = $scope.translation[dayName[dateObj.getDay()]] ;
        } else if(WeekNumber(today)[0] !== WeekNumber(dateObj)[0] && today.getFullYear() === dateObj.getFullYear()) {
            lable = $scope.translation[dayName[dateObj.getDay()]] + ", " + $scope.translation[monthName[dateObj.getMonth()]] + " " + dateObj.getDate();
        }else if(today.getFullYear() !== dateObj.getFullYear()) {
            lable = $scope.translation[dayName[dateObj.getDay()]] + ", " + $scope.translation[monthName[dateObj.getMonth()]] + " " + dateObj.getDate() + " " + dateObj.getFullYear();
        }
        return lable;
    }

    $rootScope.$on('updateAgendaView', function(event, arg) { $scope.updateView(arg.text)});
};
