app.controller("calendarViewController", ["$scope", "$rootScope", "$filter", "$timeout", "$interval", "$state", "REQUEST", calendarViewController]);

function calendarViewController($scope, $rootScope, $filter, $timeout, $interval, $state, STCONST) {
    CALVIEWCONST = {
        DAY_COUNT : 7,
        MONDAY : 0,
        SUNDAY : 6
    };

    $scope.rowCount;
    $scope.familyData =  [];
    $scope.weeks =  [];
    $scope.message;
    $scope.calObj;
    $scope.startDayOfMonth;
    $scope.endDayOfMonth;
    $scope.prevSelectedDate;

    $scope.$watch(function () {return $scope.weeks;}, function (newValue, oldValue) {
        // console.log("watch:::weeks is changed = ", oldValue, " to " + newValue);
        $scope.$emit('updateWeeks', newValue);
    }, true);

    $scope.$watch(function () {return document.body.clientHeight;}, function (newValue, oldValue) {
        console.log("watch:::View Size is changed = " + oldValue + " to " + newValue);
        if ($scope.currentScreen === CALCONST.SCREEN_HOME) {
            $scope.setMonthViewHeight($scope.isWeekView);
        }
    }, true);

    $scope.updateView = updateView;
    $scope.nextMonth = nextMonth;
    $scope.prevMonth = prevMonth;
    $scope.nextWeek = nextWeek;
    $scope.prevWeek = prevWeek;
    $scope.onDateSelected = onDateSelected;
    $scope.dateNotInCurrentMonth = dateNotInCurrentMonth;



    function initCal() {
        $scope.weeks =  [];
        var temp = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth(), 1);
        var startDay = temp.getDay() !== 0 ? temp.getDay()-1 : CALVIEWCONST.DAY_COUNT-1;
        temp = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth()+1, 0).getDay();
        var endDay =  temp !== 0  ? temp-1 : CALVIEWCONST.DAY_COUNT-1;

        $scope.startDayOfMonth = startDay;
        $scope.endDayOfMonth = endDay;

        getRowCount(startDay, endDay);

        fillPrevMonthDays(startDay);
        fillNextMonthDays(endDay);
        fillCurrentMonthDays(startDay, endDay);
        
        if (reloadOnNotification){
            console.log(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>", $scope.calObj);
            var date = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth(), $scope.prevSelectedDate.date);
            var tempObj = new Date(date.getFullYear(), date.getMonth(), 1);
            var startDay =  tempObj.getDay() !== 0  ? tempObj.getDay()-1 : CALVIEWCONST.DAY_COUNT-1;

            var totalDay = (date.getDate()-1) + (startDay);

            var row = Math.floor(totalDay/7);
            var col = totalDay%7;
            $rootScope.$broadcast('updateSelection', {'row' : row, 'col' : col});
            reloadOnNotification = false;
        }
    }

    function getRowCount(startDay, endDay) {
        var temp = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth()+1, 0);
        var dayCount = temp.getDate();
        if(startDay + dayCount  <= 35 ) {
            $scope.rowCount = 5;
        } else {
            $scope.rowCount = 6;
        }
    }

    function fillPrevMonthDays(startDayIndex) {
        var firstWeek =  [];
        var temp = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth(), 0);  //set date zero to get previous month last date
        var prevLastDate = temp.getDate();
        var day = null;
        var timeStamp = null;
        var offset = startDayIndex - 1;
        for(var i = 0; i <= startDayIndex-1; i++) {
            var temp = $scope.getTimeStamp((prevLastDate - offset + i), $scope.calObj.getMonth()-1, $scope.calObj.getFullYear());
            timeStamp = temp.split("T")[0];


            date = '{ "date" :' + (prevLastDate - offset + i) + ', '
                + '"selected" :' + false + ', '
                + '"today" : ' + false + ', '
                + '"events" : [],'
                + '"' + timeStamp + '" : [] ' + ','
                + '"timeStamp" : "' + temp + '", '
                + '"class" : "dimmed-date"'
                + '}';

            firstWeek[i] = JSON.parse(date);
        }
        $scope.weeks[0] = firstWeek;
    }

    function fillNextMonthDays(endDayIndex) {
        var lastWeek = [];
        var nextDate = 1;
        var date = null;
        var timeStamp = null;
        for( var i = endDayIndex+1; i < CALVIEWCONST.DAY_COUNT; i++) {
            var temp = $scope.getTimeStamp(nextDate, $scope.calObj.getMonth()+1, $scope.calObj.getFullYear());
            timeStamp = temp.split("T")[0];

            date = '{ "date" :' + nextDate++ +  ','
                + '"selected" :' + false + ','
                + '"today" : ' + false + ','
                + '"events" : [],'
                + '"' + timeStamp + '" : [] ' + ','
                + '"timeStamp" : "' + temp + '", '
                + '"class" : "dimmed-date"'
                + '}';

            lastWeek[i] = JSON.parse(date);
        }
        $scope.weeks[$scope.rowCount-1] = lastWeek;
    }

    function fillCurrentMonthDays(startDay, endDay) {
        var day = 1;
        var timeStamp = null;
        var selected = false;
        var date = null;
        var startIdx, endIdx;
        for (var i = 0; i < $scope.rowCount; i++) {
            week = $scope.weeks[i];
            if (i == 0) {
                startIdx = startDay;
                endIdx = CALVIEWCONST.DAY_COUNT;
            } else if (i == $scope.rowCount - 1) {
                startIdx = 0;
                endIdx = endDay + 1;
            } else {
                week = [];
                startIdx = 0;
                endIdx = CALVIEWCONST.DAY_COUNT;
            }

            for (var j = startIdx; j < endIdx; j++) {

                var temp =  $scope.getTimeStamp(day, $scope.calObj.getMonth(), $scope.calObj.getFullYear());
                timeStamp = temp.split("T")[0];
                if(day === $scope.calObj.getDate()) {
                    selected = true;
                }
                else if(day === 1 && $scope.calObj.getMonth() !== (new Date()).getMonth() && $scope.prevSelectedDate !== undefined && $scope.prevSelectedDate["selected"] === false) {
                    selected = true;
                } else {
                    selected = false;
                }

                date = '{ "date" :' + day + ','
                    + '"selected" :' + selected + ','
                    + '"events" : [],'
                    + '"' + timeStamp + '" : [] ' + ','
                    + '"timeStamp" : "' + temp + '", '
                    + '"class" : ""'
                    + '}';

                week[j] = JSON.parse(date);
                day += 1;

                if(week[j]["selected"] === true) {
                    $scope.prevSelectedDate = week[j];
                    $scope.currentWeek = i;
                }
            }
            $scope.weeks[i] = week;
        }

        $scope.prevSelectedDate = $scope.prevSelectedDate === undefined ?  $scope.prevSelectedDate = week[startIdx] : $scope.prevSelectedDate;
    }
    
    function dateNotInCurrentMonth(index) {
        if(!$scope.isWeekView){
            if (($scope.weeks[0] !== undefined) && $scope.weeks[0][index].class === 'dimmed-date')
                return true;
            return false;
        }
            
        if (($scope.weeks[$scope.currentWeek] !== undefined) && $scope.weeks[$scope.currentWeek][index].class === 'dimmed-date') {
            return true;
        }
        return false;
    }
    
    function fillEventData() {
        $scope.eventData.forEach( function(value) {
            var timeStamp = value["starts"];
            var dateObj = new Date(timeStamp);
            getDateObj(dateObj.getDate(), dateObj.getMonth(), dateObj.getFullYear(), timeStamp, value.calendar);
        });
    }

    function getDateObj(date, month, year, timeStamp, userId) {
        var dateObj = null;
        var row, col;
        if(year === $scope.calObj.getFullYear() && month === $scope.calObj.getMonth()) {
            row = Math.floor((date + $scope.startDayOfMonth - 1)/ CALVIEWCONST.DAY_COUNT);
            col = (date + $scope.startDayOfMonth - 1) % CALVIEWCONST.DAY_COUNT;
            dateObj = $scope.weeks[row][col];
            if(dateObj["events"] && dateObj["events"].length < 20)
                dateObj["events"].push($scope.getEventBallImg(userId));
        } else if(isPrevMonth(year, month)) {
            var prevMonthDays = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth(), 0).getDate();
            row = 0;
            col = ($scope.startDayOfMonth-1)-(prevMonthDays - date);
            dateObj = $scope.weeks[row][col];
            if(dateObj && dateObj["events"] && dateObj["events"].length < 20)
                dateObj["events"].push($scope.getEventBallImg(userId));
        } else if(isNextMonth(year, month)) {
            row = $scope.rowCount-1;
            col = ($scope.endDayOfMonth + date);
            dateObj = $scope.weeks[row][col];
            if(dateObj && dateObj["events"] && dateObj["events"].length < 20)
                dateObj["events"].push($scope.getEventBallImg(userId));
        }else{
//            console.log(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>Ssssssssssssssssssssssssssssssss>>>>>>>>>>>>>>>>>>>>>>>>");
        }

    }

    function isPrevMonth(year, month) {
        var isPrevMonth = false;
        var tempDate = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth()-1, 1);
        if(year == tempDate.getFullYear() && month == tempDate.getMonth()) {
            isPrevMonth = true;
        }
        return isPrevMonth;
    }

    function isNextMonth(year, month) {
        var isNextMonth = false;
        var tempDate = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth()+1, 1);
        if(year == tempDate.getFullYear() && month == tempDate.getMonth()) {
            isNextMonth = true;
        }
        return isNextMonth;
    }


    function nextMonth() {
        $scope.hideAddEventGrid();
        if($scope.calObj === undefined)
            return;

        var nextMonth = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth()+1, 1);
        //if year changed, than get the next year event data
        if($scope.calObj.getFullYear() !== nextMonth.getFullYear()) {
            $scope.prevSelectedDate["selected"] = false;
            $scope.calObj = nextMonth;
            $scope.currentDate =  $scope.calObj;
            $scope.updateCalValue(nextMonth);
            $scope.getCalendarEventData();
            return;
        }
        $scope.calObj = nextMonth;
        $scope.currentDate =  $scope.calObj;
        $scope.updateCalValue(nextMonth);
        $scope.getCalendarEventData();

        $rootScope.$broadcast('update', {'text' : 'Hi There'});
        $rootScope.$broadcast('updateHourView', {'text' : $scope.currentDate});
        $rootScope.$broadcast('updateAgendaView', {'text' : $scope.currentDate});
        //To make first date selected  in next month
        var startDay = nextMonth.getDay() !== 0 ? nextMonth.getDay()-1 : CALVIEWCONST.DAY_COUNT-1;
        setSelected(0, startDay);
    }

    function prevMonth(date) {
        $scope.hideAddEventGrid();
        if($scope.calObj === undefined)
            return;

        date = date === undefined ? 1 : date;
        var prevMonth = new Date($scope.calObj.getFullYear(), $scope.calObj.getMonth()-1, date);
        //if year changed, than get the previous year event data
        if($scope.calObj.getFullYear() !== prevMonth.getFullYear()) {
            $scope.prevSelectedDate["selected"] = false;
            $scope.calObj = prevMonth;
            $scope.currentDate = $scope.calObj;
            $scope.updateCalValue(prevMonth);
            $scope.getCalendarEventData();
            // Time out given because calendar View, hour view and agenda view is getting update after certain time out, we want to set selected after view updated
            if ($scope.isWeekView) { // this needs to be updated only inb case of weekView to setSelected first day of last week.
                $timeout(function () {
                    $scope.currentWeek = $scope.rowCount - 1;
                    setSelected($scope.currentWeek, 0);
                }, 100);
            }
            return;
        }
        $scope.calObj = prevMonth;
        $scope.currentDate =  $scope.calObj;
        $scope.updateCalValue(prevMonth);
        $scope.getCalendarEventData();

        $rootScope.$broadcast('update', {'text' : 'Hi There'});
        $rootScope.$broadcast('updateHourView', {'text' : $scope.currentDate});
        $rootScope.$broadcast('updateAgendaView', {'text' : $scope.currentDate});
        //To make first date selected  in prev month
        var startDay = prevMonth.getDay() !== 0 ? prevMonth.getDay()-1 : CALVIEWCONST.DAY_COUNT-1;
        setSelected(0, startDay);
    }

    function nextWeek() {
        $scope.hideAddEventGrid();
        if($scope.currentWeek < $scope.rowCount-1) {
            $scope.currentWeek = $scope.currentWeek + 1;

            setSelected($scope.currentWeek, 0);
            $scope.currentDate = new Date($scope.currentDate.getFullYear(), $scope.currentDate.getMonth(), $scope.weeks[$scope.currentWeek][0].date);
            $scope.updateCalValue($scope.currentDate);
            $rootScope.$broadcast('updateHourView', {'text' : $scope.currentDate});
            $rootScope.$broadcast('updateAgendaView', {'text' : $scope.currentDate});
        } else { // prepare for new month data
            nextMonth();
            $scope.currentWeek = 0;
        }

    }

    function prevWeek() {
        $scope.hideAddEventGrid();
        var dayPos;
         $scope.currentDate = $scope.calObj;
        //if current week is 2nd row, then get start day to focus first date (1st of the month) to be highlighted
        if ($scope.currentWeek === 1) {
            var temp = new Date($scope.currentDate.getFullYear(), $scope.currentDate.getMonth(), 1);
            var startDay = temp.getDay() !== 0 ? temp.getDay() - 1 : CALVIEWCONST.DAY_COUNT - 1;
            dayPos = startDay;
            $scope.currentWeek = $scope.currentWeek - 1;
            $scope.currentDate = new Date($scope.currentDate.getFullYear(), $scope.currentDate.getMonth(), $scope.weeks[$scope.currentWeek][dayPos].date);
        } else if ($scope.currentWeek === 0) { // if current week is 1st row, show the last row of the prev month
            var date;
            var temp = new Date($scope.currentDate.getFullYear(), $scope.currentDate.getMonth(), 1);
            var startDay = temp.getDay() !== 0 ? temp.getDay() - 1 : CALVIEWCONST.DAY_COUNT - 1;
            if(startDay !== 0) {
                dayPos = 0;
                date = $scope.weeks[$scope.currentWeek][dayPos].date;
            } else {
                temp.setDate(temp.getDate()-CALVIEWCONST.DAY_COUNT);
                date = temp.getDate();
            }
            prevMonth(date);
            $scope.currentWeek = $scope.rowCount - 1;
            return;
        } else {
            dayPos = 0;
            $scope.currentWeek = $scope.currentWeek - 1;
            $scope.currentDate = new Date($scope.currentDate.getFullYear(), $scope.currentDate.getMonth(), $scope.weeks[$scope.currentWeek][dayPos].date);
        }

        $scope.updateCalValue($scope.currentDate);
        $rootScope.$broadcast('updateHourView', {'text': $scope.currentDate});
        $rootScope.$broadcast('updateAgendaView', {'text': $scope.currentDate});
        setSelected($scope.currentWeek, dayPos);
    }

    function goToWeek(date) {
        $scope.calObj = date;

        var tempObj = new Date(date.getFullYear(), date.getMonth(), 1);
        var startDay =  tempObj.getDay() !== 0  ? tempObj.getDay()-1 : CALVIEWCONST.DAY_COUNT-1;

        var totalDay = (date.getDate()-1) + startDay;
        var row = Math.floor(totalDay/7);
        var col = totalDay%7;

        $scope.currentWeek = row;
        setSelected(row, col);

    }

    function setSelected(row, col) {
        $scope.prevSelectedDate["selected"] = false;
        $scope.prevSelectedDate["today"] = false;
        var dayObj = $scope.weeks[row][col];
        dayObj["selected"] = true;
        $scope.prevSelectedDate = dayObj;
    }

    function isToday(date, month, year) {
        var today = new Date();
        return (today.getDate() === date && today.getMonth() === month && today.getFullYear() === year);
    }

    $rootScope.$on('update', function(event, arg) { $scope.updateView(arg.text);});
    $rootScope.$on('updateSelection', function(event, arg) { setSelected(arg.row, arg.col);});
    $rootScope.$on('goToWeek', function(event, arg) {goToWeek(arg.text);});
    $rootScope.$on('updateCalObj', function(event, arg) {$scope.calObj = arg.text;});
    $rootScope.$on('updateSelectionDate', function(event, arg) {
        var date = arg.text;

        var tempObj = new Date(date.getFullYear(), date.getMonth(), 1);
        var startDay =  tempObj.getDay() !== 0  ? tempObj.getDay()-1 : CALVIEWCONST.DAY_COUNT-1;

        var totalDay = (date.getDate()-1) + (startDay);

        var row = Math.floor(totalDay/7);
        var col = totalDay%7;
        setSelected(row, col);
    });

    function updateView(message) {
        if(!$scope.calObj)
            $scope.calObj = new Date();

        if(message && message !== 'Hi There')
            $scope.calObj = message;

        initCal();
        fillEventData();
    }

    function onDateSelected(row, col) {
        $scope.prevSelectedDate["selected"] = false;
        $scope.prevSelectedDate["today"] = false;
        var date = $scope.weeks[row][col];
        date["selected"] = true;
        $scope.prevSelectedDate = date;
        $scope.currentWeek = row;

        var temp = new Date(date["timeStamp"]);
//        temp.setFullYear($scope.calObj.getFullYear());
//        temp.setMonth($scope.calObj.getMonth());
//        temp.setDate(date["date"]);
        $scope.currentDate = temp;

        $scope.updateCalValue(temp);
        $scope.hideAddEventGrid();
        $rootScope.$broadcast('updateHourView', {'text' : $scope.currentDate});
        $rootScope.$broadcast('updateAgendaView', {'text' : $scope.currentDate});

    }

};
