
app.filter('dateFilter', function() {
    return function(items, prevSelectedDate){
        // console.log(items, prevSelectedDate);
        var customArray = [];
        items.forEach(function(event) {
            var start = new Date(event.starts);
            var end = new Date(event.ends);
            var isDate = (start.getDate() === prevSelectedDate.getDate() && start.getMonth() === prevSelectedDate.getMonth() && start.getFullYear() === prevSelectedDate.getFullYear());
//                var isDate = (start.getDate() === prevSelectedDate.getDate() && start.getMonth() === prevSelectedDate.getMonth() && start.getFullYear() === prevSelectedDate.getFullYear());
            //   console.log(start.getDate(), prevSelectedDate.getDate(), isDate);
            isDate && customArray.push(event);
        });
        return customArray ;
    };
});
app.filter('internalAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        if (items == null) {
            return;
        }
        if (!angular.isDefined(items))
            return null;
        items.forEach(function (item) {

            profileData.forEach(function (profile) {
                if (angular.isDefined(profile.email) && angular.isDefined(item.email) && profile.email.toUpperCase() === item.email.toUpperCase()) {
                    customArray.push(profile);
                }
            });
        });
        return customArray;
    }
});
app.filter('acceptedAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        if (items == null) {
            return;
        }
        if (!angular.isDefined(items))
            return null;
        items.forEach(function (item) {

            profileData.forEach(function (profile) {
                if ((angular.isDefined(profile.email)) && (profile.email.toUpperCase() === item.email.toUpperCase()) && item.responseStatus === "accepted") {
                    customArray.push(profile);
                }
            });
        });
        return customArray;
    }
});
app.filter('maybeAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        if (items == null) {
            return;
        }
        if (!angular.isDefined(items))
            return null;
        items.forEach(function (item) {

            profileData.forEach(function (profile) {
                if ((angular.isDefined(profile.email)) && (profile.email.toUpperCase() === item.email.toUpperCase()) && item.responseStatus === "tentative") {
                    customArray.push(profile);
                }
            });
        });
        return customArray;
    }
});
app.filter('declinedAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        if (items == null) {
            return;
        }
        if (!angular.isDefined(items))
            return null;
        items.forEach(function (item) {

            profileData.forEach(function (profile) {
                if ((angular.isDefined(profile.email)) && (profile.email.toUpperCase() === item.email.toUpperCase()) && item.responseStatus === "declined") {
                    customArray.push(profile);
                }
            });
        });
        return customArray;
    }
});
app.filter('noResponseAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        if (items == null) {
            return;
        }
        if (!angular.isDefined(items))
            return null;
        items.forEach(function (item) {

            profileData.forEach(function (profile) {
                if ((angular.isDefined(profile.email)) && (profile.email.toUpperCase() === item.email.toUpperCase()) &&
                    (angular.isUndefined(item.responseStatus) || item.responseStatus === "needsAction")) {
                    customArray.push(profile);
                }
            });
        });
        return customArray;
    }
});

/* ********************************************************************
 * Alphanum Array prototype version
 *  - Much faster than the sort() function version
 *  - Ability to specify case sensitivity at runtime is a bonus
 *
 */
Array.prototype.alphanumSort = function(caseInsensitive) {
    for (var z = 0, t; t = this[z]; z++) {
        this[z] = new Array();
        var x = 0, y = -1, n = 0, i, j;

        while (i = (j = t.charAt(x++)).charCodeAt(0)) {
            var m = (i == 46 || (i >=48 && i <= 57));
            if (m !== n) {
                this[z][++y] = "";
                n = m;
            }
            this[z][y] += j;
        }
    }

    this.sort(function(a, b) {
        for (var x = 0, aa, bb; (aa = a[x]) && (bb = b[x]); x++) {
            if (caseInsensitive) {
                aa = aa.toLowerCase();
                bb = bb.toLowerCase();
            }
            if (aa !== bb) {
                var c = Number(aa), d = Number(bb);
                if (c == aa && d == bb) {
                    return c - d;
                } else return (aa > bb) ? 1 : -1;
            }
        }
        return a.length - b.length;
    });

    for (var z = 0; z < this.length; z++)
        this[z] = this[z].join("");
}

app.filter('externalAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        var flag = false;
        if (items == null) {
            return;
        }
        items.forEach(function (item) {
            profileData.forEach(function (profile) {
                if ((angular.isDefined(profile.email)) && (profile.email.toUpperCase() === item.email.toUpperCase())) {
                    flag = true;
                }
            });

            if (flag === false) {
                customArray.push(item.email);
                showExternalInviteesDivider = true;
            }

            flag = false;
        });
        customArray.alphanumSort();
        return customArray;
    }
});

app.filter('externalAcceptedAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        var flag = false;
        if (items == null) {
            return;
        }
        items.forEach(function (item) {
            profileData.forEach(function (profile) {
                if ((angular.isDefined(profile.email)) && (profile.email.toUpperCase() === item.email.toUpperCase())) {
                    flag = true;
                }
            });

            if (flag === false  && item.responseStatus === "accepted") {
                customArray.push(item.email);
            }

            flag = false;
        });
        customArray.alphanumSort();
        return customArray;
    }
});
app.filter('externalMayBeAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        var flag = false;
        if (items == null) {
            return;
        }
        items.forEach(function (item) {
            profileData.forEach(function (profile) {
                if ((angular.isDefined(profile.email)) && (profile.email.toUpperCase() === item.email.toUpperCase())) {
                    flag = true;
                }
            });

            if (flag === false && item.responseStatus === "tentative") {
                customArray.push(item.email);
            }

            flag = false;
        });
        customArray.alphanumSort();
        return customArray;
    }
});
app.filter('externalDeclinedAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        var flag = false;
        if (items == null) {
            return;
        }
        items.forEach(function (item) {
            profileData.forEach(function (profile) {
                if ((angular.isDefined(profile.email)) && (profile.email.toUpperCase() === item.email.toUpperCase())) {
                    flag = true;
                }
            });

            if (flag === false && item.responseStatus === "declined") {
                customArray.push(item.email);
            }

            flag = false;
        });
        customArray.alphanumSort();
        return customArray;
    }
});

app.filter('externalNoResponseAttendee', function () {
    return function (items, profileData) {
        var customArray = [];
        var flag = false;
        if (items == null) {
            return;
        }
        items.forEach(function (item) {
            profileData.forEach(function (profile) {
                if ((angular.isDefined(profile.email)) && (profile.email.toUpperCase() === item.email.toUpperCase())) {
                    flag = true;
                }
            });

            if (flag === false && item.responseStatus === "needsAction") {
                customArray.push(item.email);
            }

            flag = false;
        });
        customArray.alphanumSort();
        return customArray;
    }
});

