app.controller("hourViewController", ["$scope", "$rootScope", "$timeout", "$interval", "$state", "REQUEST", hourViewController]);
function hourViewController($scope, $rootScope, $timeout, $interval, $state, STCONST) {
    $scope.message = "";
    $scope.hourToDisplay = [];
    $scope.updateView = updateView;
    $scope.getEventItemClass = getEventItemClass;
    $scope.prepareData = prepareData;
    $scope.getAllDayEventClass = getAllDayEventClass;
    $scope.nextDay = nextDay;
    $scope.prevDay = prevDay;
    $scope.enbleAddEventGrid = enbleAddEventGrid;

    function showCurrentHourView() {
        var now = new Date();
        $scope.currentHour = now.getHours();
        var tempHourViewScrollHeight = ($scope.currentHour) * ((192 * window.screen.availWidth) / 1440);
        $timeout(function () {
            $('.event-table-other').scrollTop(tempHourViewScrollHeight);
        }, 0);
    }

    function updateView(message) {
        console.log('update Day View');
        if(message && message !== 'Hi There')
            $scope.currentDate = message;
        initHourView();
    }

    function initHourView() {
        $scope.hourToDisplay = [];
        for(var i = $scope.firstHour; i <= $scope.lastHour; i++) {
            $scope.hourToDisplay.push(i);
        }
        resetAllDayForProfile();
        fillDailyData();
        showCurrentHourView();
    }


    function resetAllDayForProfile() {

        for(var i = 0; i < $scope.profileData.length; i++) {
            $scope.profileData[i].allDayEvent = false;
            $scope.profileData[i].hourEvent = [];
            $scope.profileData[i].allDayEventName = '';
        }
    }

    function getEventItemClass(event) {

        if(!$scope.prevSelectedDate) {
            //     console.log("Returning");
        }

        var start = new Date(event.starts);
        var end = new Date(event.ends);

        var topPos = start.getHours()*60 + start.getMinutes();
        topPos = (topPos/60)*2.02;

        var height = end.getHours()*60 + end.getMinutes();
        height = (height/60)*2.05;

        height = height - topPos;

        var classItem;
        if (isNaN(topPos) || isNaN(height)) {
            classItem = "visibility: hidden";
        } else {
            classItem = "top: "+topPos+"rem; height: "+height+"rem";
        }
        return classItem;
    }


    function fillDailyData() {
        arrayfordisplay.forEach(function (interval) {
            var start = new Date(interval.event.event.starts);
//                var end = new Date(interval.event.event.ends);
            var isDate = (start.getDate() === $scope.currentDate.getDate() && start.getMonth() === $scope.currentDate.getMonth() && start.getFullYear() === $scope.currentDate.getFullYear());
            var obj = getUserDataArray(interval.event.event.calendar);
            if (isDate && interval.event.event.allDay) {
                obj["allDayEvent"] = true;
                obj["allDayEventName"] = interval.event.event.summary;
                obj["allDayEventData"] = interval.event.event;
                return;
            }
            isDate && obj && obj["hourEvent"].push(interval);
        });
    }

    function getUserDataArray(userId) {
        var obj;
        for(var i=0; i < $scope.profileData.length; i++) {
            obj = $scope.profileData[i];
            for(var j=0;  j < obj.calendarId.length; j++) {
                if(obj.calendarId[j] == userId) {
                    return obj;
                }
            }
        }
        //return obj;
    }


    function prepareData(color, event) {
        var eventWidth;
        var marginLeft;
        var space = 0.05;
        if (event.event.event.allDay) {
            return;
        } else {
            eventWidth = event.count;
            marginLeft = event.index;
            event = event.event.event;
            if ( eventWidth < 2)
                space = 0;
        }
        
        var maxEventToBeShown = (16.30 / (($scope.profileData.length - $scope.NoOfProfileFiltered) *  eventWidth));
        if (maxEventToBeShown < space) { // for more than 50 splited event, event width should not be calculated in minus(-)
            space = 0;
        }
        if (!$scope.currentDate) {
            return;
        }

        var eventObj = null;
        var start = new Date(event.heightStarts);
        var end = new Date(event.heightEnds);

        if (!(start.getDate() === $scope.currentDate.getDate() && start.getMonth() === $scope.currentDate.getMonth() && start.getFullYear() === $scope.currentDate.getFullYear())) {
            return;
        }
        var topPos = start.getHours() * 60 + start.getMinutes();
        var height = end.getHours() * 60 + end.getMinutes();
        if (start.getDate() + 1 === end.getDate() && end.getHours() === 0) {
            height = 24 * 60;
        }
        height = height - topPos;

        height = (height / 60) * 2.4;
        topPos = (topPos / 60) * 2.4;

        var classItem;
        if (isNaN(topPos) || isNaN(height)) {
            classItem = "visibility: hidden";
        } else {
            classItem = "margin-left: " + (marginLeft * 16.30) / (($scope.profileData.length - $scope.NoOfProfileFiltered) *  eventWidth) + "rem; top: " + topPos + "rem; height: " + height + "rem; background-color : " + color + ";width : " + (maxEventToBeShown - space) + "rem;";
        }
        return classItem;
    }

    function enbleAddEventGrid(color){
        var classItem;
        if($scope.visibleAddEventGridLayout){
            classItem = "background-color : " + color + ";";
        }
        return classItem;
    }

    function getAllDayEventClass(profile) {
        if(profile.allDayEvent) {
            return " background-color : " + profile.profileColor + "; width :" + 16.30/($scope.profileData.length - $scope.NoOfProfileFiltered) + "rem;";
        }
        return "width :" + 16.30/($scope.profileData.length - $scope.NoOfProfileFiltered) + "rem;";
    }

    function nextDay() {
        var date = new Date($scope.currentDate.getFullYear(), $scope.currentDate.getMonth(), $scope.currentDate.getDate() + 1);
        var tempObj = new Date(date.getFullYear(), date.getMonth(), 1);
        var startDay =  tempObj.getDay() !== 0  ? tempObj.getDay()-1 : CALVIEWCONST.DAY_COUNT-1;

        var totalDay = (date.getDate()-1) + (startDay);

        var row = Math.floor(totalDay/7);
        var col = totalDay%7;

        $scope.updateCalValue(date);
        $scope.hideAddEventGrid();

        $rootScope.$broadcast('update', {'text' : date});
        $rootScope.$broadcast('updateHourView', {'text' : date});
        $rootScope.$broadcast('updateSelection', {'row' : row, 'col' : col});
    }

    function prevDay() {
        var date = new Date($scope.currentDate.getFullYear(), $scope.currentDate.getMonth(), $scope.currentDate.getDate() - 1);
        var tempObj = new Date(date.getFullYear(), date.getMonth(), 1);

        var startDay =  tempObj.getDay() !== 0  ? tempObj.getDay()-1 : CALVIEWCONST.DAY_COUNT-1;

        var totalDay = (date.getDate()-1) + startDay;
        var row = Math.floor(totalDay/7);
        var col = totalDay%7;

        $scope.updateCalValue(date);
        $scope.hideAddEventGrid();
        $rootScope.$broadcast('update', {'text' : date});
        $rootScope.$broadcast('updateHourView', {'text' : date});
        $rootScope.$broadcast('updateSelection', {'row' : row, 'col' : col});
    }

    $rootScope.$on('updateHourView', function(event, arg) {$scope.updateView(arg.text)});
};
