var app = angular.module("SmartThings", ['ngSanitize', 'ui.router', 'ngMaterial', 'ngAria', 'ngTouch']);//

app.controller("shoppingListController", function ($scope, $state, $filter, $http, $q, imageCache, imageRequest, timeStamp, SHPService, REQUEST, QuickDelete, staticData, $timeout, EmartAPIService, SwipeService) {
    var ENTER_KEYCODE = 13, STATUS_500 = 500, langArr = Object.keys(LANGUAGE_FILE.language);
    var default_category_id = "OTHER";
    var default_master_category_id = "Other";
    var categoryMap = [
        {"Whisk_Category":"FRUITS AND VEGETABLES", "Category_ID":"Fruits_Vegetables"},
        {"Whisk_Category":"MEATS AND SEAFOOD", "Category_ID":"Meats_Seafood"},
        {"Whisk_Category":"BREAD AND BAKERY", "Category_ID":"Bread_Bakery"},
        {"Whisk_Category":"DAIRY AND EGGS", "Category_ID":"Dairy_Eggs_Cheese"},
        {"Whisk_Category":"CONDIMENTS", "Category_ID":"Condiments_Sauces"},
        {"Whisk_Category":"FROZEN", "Category_ID":"Frozen"},
        {"Whisk_Category":"HERBS AND SPICES", "Category_ID":"Seasoning_Spices_Baking"},
        {"Whisk_Category":"BAKING", "Category_ID":"Seasoning_Spices_Baking"},
        {"Whisk_Category":"BREAKFAST FOODS", "Category_ID":"Breakfast_Cereal"},
        {"Whisk_Category":"SNACKS", "Category_ID":"Cookies_Snacks_Candy"},
        {"Whisk_Category":"DRINKS", "Category_ID":"Beverages"},
        {"Whisk_Category":"CANNED FOODS", "Category_ID":"Canned_DryGoods"},
        {"Whisk_Category":"PASTA, RICE AND BEANS", "Category_ID":"Canned_DryGoods"},
        {"Whisk_Category":"PET CARE", "Category_ID":"PetCare"},
        {"Whisk_Category":"HOUSEHOLD", "Category_ID":"Household"},
        {"Whisk_Category":"HEALTH AND BEAUTY", "Category_ID":"PersonalCare"},
        {"Whisk_Category":"BABY CARE", "Category_ID":"BabyCare"},
        {"Whisk_Category":"OTHER", "Category_ID":"Other"}
    ];
    
    if (langArr.indexOf(LANG.toUpperCase()) !== - 1){
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase()];
    } else if (langArr.indexOf(LANG.toUpperCase().substring(0, 2)) !== - 1){
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase().substring(0, 2)];
    } else {
        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
    }
    if (LANG.toUpperCase().indexOf('EN') !== -1){
            $scope.selectedLangEnglish = true;
    }
    if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
        $scope.isAppleDevice = true;
    }

    // to check if input or textara or md-autocomplete is focused
    function isTextInput(node) {
        return ['INPUT', 'TEXTAREA', 'MD-AUTOCOMPLETE-PARENT-SCOPE'].indexOf(node.nodeName) !== -1;
    }

    function isMdAutoCompleteResult(node) {
        return $(node).hasClass('md-virtual-repeat-container') || $(node).parents().hasClass('md-virtual-repeat-container');
    }

    // remove focues on touch anywhere on the screen
    document.addEventListener('touchstart', function (e) {
        if ($scope.isAppleDevice) {
            if (!(isTextInput(e.target) || isMdAutoCompleteResult(e.target)) && isTextInput(document.activeElement)) {
                removeFocus();
            }
        }
    }, false);
    
    var SHOPPINGLIST_SCREEN = {
        HOME: 'HOME',
        DETAIL_SCREEN: 'DETAIL_SCREEN',
        CHANGE_CATEGORY_SCREEN: 'CHANGE_CATEGORY_SCREEN',
        MOVE_TO_OTHER_LIST_SCREEN: 'MOVE_TO_OTHER_LIST_SCREEN',
        FREQUENT_ITEM_SCREEN: 'FREQUENT_ITEM_SCREEN',
        FIND_DEALS_SCREEN: 'FIND_DEALS_SCREEN',
        SETTING_SCREEN : 'SETTING_SCREEN'
    };

    /** Starts to define the default values for FHub 2.0 **/
    $scope.isSupportViewInside = true;
    $scope.isSupportDeals = false;
    $scope.MAX_LIST = 24;
    $scope.MAX_LIST_ITEM = 50;
    $scope.MAX_FOOD_ITEM = 150;     //check for View Inside
    $scope.MAX_CHARACTER_TITLE = 32;//32;
    $scope.MAX_CHARACTER_ITEM = 32;//32;
    /** Ends to define the default values for FHub 2.0 **/

    $scope.QuickDelete = QuickDelete;
    $scope.EmartAPIService = EmartAPIService;
    $scope.isStatic = false;
    $scope.isLocal = false;
    $scope.loadingBar = false;
    $scope.mainLoadingScreen = true;
    $scope.isTransparent = false;
    $scope.backButton = false;
    $scope.bOptionPopUp = false;
    $scope.isSelectedMode = false;
    $scope.HomePage = true;
    $scope.DetailPage = false;
    $scope.ChangeCategoryPage = false;
    $scope.MoveToOtherListPage = false;
    $scope.FrequentItemPage = false;
    $scope.SettingsPage = false;
    $scope.confirmationPopUpVisible = false;
    $scope.showNewlyAddedItem = false;
    $scope.showAddItem = true;
    $scope.userId = "";
    $scope.groupId = "";
    $scope.currentSelectedMode = "";
    $scope.checkResponse = [];
    $scope.selectedMode_option = false;
    $scope.SHOPPINGLIST_OPTIONS = {
        RENAME: $scope.translation.WEBMOB_fhub2_common_rename,
        MOVE_TO_OTHER_LIST: $scope.translation.WEBMOB_fhub2_shopping_list_move_to_other_list,
        SEND_TO_VIEW_INSIDE: $scope.translation.WEBMOB_fhub2_shopping_list_send_to_view_inside,
        CHANGE_CATEGORY: $scope.translation.WEBMOB_fhub2_shopping_list_change_category,
        DELETE: $scope.translation.WEBMOB_fhub2_common_delete,
        // SEND_TO_GROCERIES: $scope.translation.WEBMOB_fhub2_shopping_list_send_to_groceries,
        SETTINGS: $scope.translation.FHUBMOB_fhub2_settings
    };
    $scope.SHOPPINGLIST_OPTIONS_HOME = {
        DELETE_LIST: $scope.translation.WEBMOB_fhub2_shopping_list_delete_list
    };

    $scope.SHOPPINGLIST_OPTIONS_SELECT_PAGE = {
        DELETE: $scope.translation.WEBMOB_fhub2_common_delete,
        MOVE_TO_OTHER_LIST: $scope.translation.WEBMOB_fhub2_shopping_list_move_to_other_list,
        // SEND_TO_GROCERIES: $scope.translation.WEBMOB_fhub2_shopping_list_send_to_groceries,
        SEND_TO_VIEW_INSIDE: $scope.translation.WEBMOB_fhub2_shopping_list_send_to_view_inside,
        CHANGE_CATEGORY: $scope.translation.WEBMOB_fhub2_shopping_list_change_category
    };

    $scope.FREQUENTLIST_OPTIONS = {
        ADD: 'FREQUENTLIST_ADD',
        DELETE: 'FREQUENTLIST_DELETE'
    };

    $scope.Device = {
        FoodList: {"Fridge": []},
        ShoppingList: {}
    };
    $scope.categoryDB = [];
    $scope.FindDealsData = {
        search_terms: [],
        StoreList: [],
        DealsList: []
    };

    $scope.moveListPopupData = {};

    $scope.DefineLocations = [
        {"id": "STORAGE_FRIDGE", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_fridge), "whiskType": "fridge"},
        {"id": "STORAGE_FREEZER", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_freezer), "whiskType": "freezer"},
        {"id": "STORAGE_FLEX_ZONE", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_flex_zone), "whiskType": "flexzone"},
        {"id": "STORAGE_FLEX_ZONE_18K", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_flex_zone_18K), "whiskType": "flexzone", "isExpand": true},
        {"id": "STORAGE_PANTRY", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_pantry), "whiskType": "pantry"}
    ];
    $scope.locations = [];

    $scope.inputData = {
        groupId: "",
        category: decodeHtmlEntity($scope.translation.WEBMOB_fhub2_shopping_list_create_new_title),
        name: "",
        storageType: (angular.isDefined($scope.locations[0]))? $scope.locations[0].id : '',
        selectedCategory: {},
        createCategory: "",
        auto_sendToViewInside: get_auto_sendToViewInside(),
        food_position: $scope.DefineLocations[0].id
    };

    $scope.dialogPopup = {
        show: false,
        dialogPopupTitle: '',
        dialogPopupText: '',
        button1Title: '',
        button1Handler: function () {
            toggleBottomPopUpClass(false);
            $scope.dialogPopup.show = false;
        },
        button2Enabled: false,
        button2Title: '',
        button2Handler: function () {
        }
    };

    $scope.currentScreen = SHOPPINGLIST_SCREEN.HOME;
    $scope.custpopuptextString = "";
    $scope.modifyList = [];
    $scope.events = {BACK_PRESSED: 'onBackPressed', SHOW_OPTION_POPUP: 'showOptionPopup'};
    $scope.eventQueue = [];
    $scope.imageURL_List = [];

    {
        $scope.init = init;
        $scope.updateDeviceData = updateDeviceData;
        $scope.parseLcdSpec = parseLcdSpec;
        $scope.isAllowLocationType = isAllowLocationType;
        $scope.parseFoodData = parseFoodData;
        $scope.addFoodData = addFoodData;
        $scope.updateFoodData = updateFoodData;
        $scope.parseShoppingData = parseShoppingData;
        $scope.parseDeviceData = parseDeviceData;
        $scope.parseStaticData = parseStaticData;
        $scope.requestFailHandler = requestFailHandler;
        $scope.requestResponseHandler = requestResponseHandler;
        $scope.requestProgressHandler = requestProgressHandler;
        $scope.showConnectionFailurePopup = showConnectionFailurePopup;
        $scope.closeConnectionFailurePopup = closeConnectionFailurePopup;
        $scope.goToShopListHome = goToShopListHome;
        $scope.goToDetailPage = goToDetailPage;
        $scope.showDetailScreenForCreateList = showDetailScreenForCreateList;
        $scope.showDetailScreen = showDetailScreen;
        $scope.goToChangeCategoryPage = goToChangeCategoryPage;
        $scope.goToMoveToOtherListPage = goToMoveToOtherListPage;
        $scope.goToFrequentItemPage = goToFrequentItemPage;
        $scope.goToFindDealsPage = goToFindDealsPage;
        $scope.goToSettingsPage = goToSettingsPage;
        $scope.onBackPressed = onBackPressed;
        $scope.closeLoadingBar = closeLoadingBar;
        $scope.dismissLoadingBar = dismissLoadingBar;
        $scope.closeApp = closeApp;
        $scope.getShoppingListFormat = getShoppingListFormat;
        $scope.addShoppingListTitleCommand = addShoppingListTitleCommand;
        $scope.addShoppingListItemCommand = addShoppingListItemCommand;
        $scope.isChecked = isChecked;
        $scope.toggleCheckList = toggleCheckList;
        $scope.showOptionPopup = showOptionPopup;
        $scope.closeOptionPopup = closeOptionPopup;
        $scope.showConfirmationPopUp = showConfirmationPopUp;
        $scope.closeConfirmationPopUp = closeConfirmationPopUp;
        $scope.onCancelConfirmationPopUp = onCancelConfirmationPopUp;
        $scope.onOkConfirmationPopUp = onOkConfirmationPopUp;
        $scope.onCancelConfirmationAddEditPopUp = onCancelConfirmationAddEditPopUp;
        $scope.selectIndexFromOptionMenu = selectIndexFromOptionMenu;
        $scope.longPressHandlerForDelete = longPressHandlerForDelete;
        $scope.selectedModeForDelete = selectedModeForDelete;
        $scope.selectedModeForMoveToOtherList = selectedModeForMoveToOtherList;
        $scope.selectedModeForSendToGroceries = selectedModeForSendToGroceries;
        $scope.selectedModeForSendToViewInside = selectedModeForSendToViewInside;
        $scope.resetSelectedMode = resetSelectedMode;
        $scope.keyupHandler = keyupHandler;
        $scope.sendToViewInsideCommand = sendToViewInsideCommand;
        $scope.isEmpty = isEmpty;
        $scope.isShoplistEmpty = isShoplistEmpty;
        $scope.isCheckedItem = isCheckedItem;
        $scope.isEmart = isEmart;
        $scope.isWoolworth = isWoolworth;
        $scope.isDeals = isDeals;
        $scope.updateItemStatusCommand = updateItemStatusCommand;
        $scope.deleteShoppingList = deleteShoppingList;
        $scope.deleteShoppingListTitleCommand = deleteShoppingListTitleCommand;
        $scope.deleteShoppingListItemCommand = deleteShoppingListItemCommand;
        $scope.deleteShoppingListItemsCommand = deleteShoppingListItemsCommand;
        $scope.decodeHtmlEntity = decodeHtmlEntity;
        $scope.encodeEscape = encodeEscape;
        $scope.decodeUnescape = decodeUnescape;
        $scope.isFocused = isFocused;
        $scope.setSelectedItems = setSelectedItems;
        $scope.deleteSelectedItems = deleteSelectedItems;
        $scope.clearSelectedItems = clearSelectedItems;
        $scope.isCheckedItems = isCheckedItems;
        $scope.toggleSelectAllListCheckBox = toggleSelectAllListCheckBox;
        $scope.isAllCheckBoxSelected = isAllCheckBoxSelected;
        $scope.closeSelectedMode = closeSelectedMode;
        $scope.getImage = getImage;
        $scope.imageURL_Request = imageURL_Request;
        $scope.request_imageURL_List = request_imageURL_List;
        $scope.removeFocus = removeFocus;
        $scope.resizeTextArea = resizeTextArea;
        $scope.clearModifyList = clearModifyList;
        $scope.isAdded = isAdded;
        $scope.getModifyItem = getModifyItem;
        $scope.runEventQueue = runEventQueue;
        $scope.clearEventQueue = clearEventQueue;
        $scope.diffDays = diffDays;
        $scope.showExpiredIcon = showExpiredIcon;
        $scope.displayExpirationDate = displayExpirationDate;

        //Find Deals
        $scope.noStorePopup = false;
        $scope.isExpandStoreList = false;
        $scope.showNoStorePopup = showNoStorePopup;
        $scope.closeNoStorePopup = closeNoStorePopup;
        $scope.goToStoreSettings = goToStoreSettings;
        $scope.set_storeFilter = set_storeFilter;
        $scope.get_storeFilter = get_storeFilter;
        $scope.requestFindDealsCommand = requestFindDealsCommand;
        $scope.parseFindDealsData = parseFindDealsData;
        $scope.toggleExpandStoreList = toggleExpandStoreList;
        $scope.isOutOfFirstLine = isOutOfFirstLine;
        $scope.addFindDealsCommand = addFindDealsCommand;
    }

    $scope.initial_inputData = initial_inputData;
    function initial_inputData() {
        debugMessage('initial_inputData');
        $scope.inputData.groupId = "";
        $scope.inputData.category = decodeHtmlEntity($scope.translation.WEBMOB_fhub2_shopping_list_create_new_title);
        $scope.inputData.name = "";
        $scope.inputData.storageType = (angular.isDefined($scope.locations[0]))? $scope.locations[0].id : '';
        $scope.inputData.selectedCategory = {};
        $scope.inputData.createCategory = "";
        $scope.inputData.auto_sendToViewInside = get_auto_sendToViewInside();
        $scope.inputData.food_position = $scope.DefineLocations[0].id;
    }

    $scope.set_auto_sendToViewInside = set_auto_sendToViewInside;
    function set_auto_sendToViewInside(auto_sendToViewInside) {
        console.log("save auto_sendToViewInside -> ", auto_sendToViewInside);
        setLocalStorageData('auto_sendToViewInside', auto_sendToViewInside);
    }

    $scope.get_auto_sendToViewInside = get_auto_sendToViewInside;
    function get_auto_sendToViewInside() {
        var localStorage_auto_sendToViewInside = getLocalStorageData('auto_sendToViewInside');
        if (angular.isDefined(localStorage_auto_sendToViewInside) && localStorage_auto_sendToViewInside !== null && localStorage_auto_sendToViewInside !== "") {
            return JSON.parse(localStorage_auto_sendToViewInside);
        }
        else {
            return true;
        }
    }

    $scope.isDefinedList = isDefinedList;
    function isDefinedList(groupId) {
        return (angular.isDefined(groupId) && angular.isDefined($scope.Device.ShoppingList[groupId]));
    }

    $scope.getTitle = function (groupId) {
        if (isDefinedList(groupId)) {
            return $scope.Device.ShoppingList[groupId].category;
        }
        else {
            return decodeHtmlEntity($scope.translation.WEBMOB_fhub2_shopping_list_create_new_title);
        }
    };

    $scope.orderByShoppingItem = orderByShoppingItem;
    function orderByShoppingItem() {
        return ['-category_order', '+itemStatus', '-order', '+name'];
    }

    $scope.showSubTitle = function (prevList, curList, index, key) {
        if (angular.isDefined(curList) && angular.isDefined(index) && angular.isDefined(key)) {
            if (!isEmpty(curList[key])) {
                if (index === 0) {
                    return true;
                }
                else if (angular.isDefined(prevList) && !isEmpty(prevList[key]) && prevList[key] !== curList[key]) {
                    return true;
                }
            }
        }
        return false;
    };

    $scope.getSubTitle = function (categoryId) {
        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.FIND_DEALS_SCREEN) {
            return categoryId;
        }
        else {
            //check Category_info
            var category_info = getCategoryInfo(categoryId);
            if (angular.isUndefined(category_info))
                category_info = getCategoryInfo(default_category_id);

            return category_info.displayName;
        }
    };

    $scope.MAX_THUMBNAIL_LIMIT = 5;
    $scope.thumbNail_limitTo = thumbNail_limitTo;
    function thumbNail_limitTo(groupId) {
        if (isDefinedList(groupId) && angular.isDefined($scope.Device.ShoppingList[groupId].items)) {
            return ($scope.Device.ShoppingList[groupId].items.length <= $scope.MAX_THUMBNAIL_LIMIT)? $scope.MAX_THUMBNAIL_LIMIT : $scope.MAX_THUMBNAIL_LIMIT - 1;
        }
    }

    function changeScreen() {
        hideAllScreens();
        switch ($scope.currentScreen) {
            case SHOPPINGLIST_SCREEN.HOME:
                $scope.HomePage = true;
                break;
            case SHOPPINGLIST_SCREEN.DETAIL_SCREEN:
                $scope.DetailPage = true;
                break;
            case SHOPPINGLIST_SCREEN.CHANGE_CATEGORY_SCREEN:
                $scope.ChangeCategoryPage = true;
                break;
            case SHOPPINGLIST_SCREEN.MOVE_TO_OTHER_LIST_SCREEN:
                $scope.MoveToOtherListPage = true;
                break;
            case SHOPPINGLIST_SCREEN.FREQUENT_ITEM_SCREEN:
                $scope.FrequentItemPage = true;
                break;
            case SHOPPINGLIST_SCREEN.FIND_DEALS_SCREEN:
                $scope.FindDealsPage = true;
                break;
            case SHOPPINGLIST_SCREEN.SETTING_SCREEN:
                $scope.SettingsPage = true;
                break;
            default:
                $scope.HomePage = true;
                break;
        }
    }

    function hideAllScreens() {
        $scope.HomePage = false;
        $scope.DetailPage = false;
        $scope.ChangeCategoryPage = false;
        $scope.MoveToOtherListPage = false;
        $scope.FrequentItemPage = false;
        $scope.FindDealsPage = false;
        $scope.SettingsPage = false;
    }

    function init() {
        // Future purpose
    }

    function updateDeviceData(data) {
        SHPService.updateDeviceData($scope, data);
    }

    function parseLcdSpec(data) {
        console.log("parseLcdSpec::: ", data);
        if (angular.isDefined(data)) {
            if (angular.isDefined(data["viewinside"])) {
                var viewinsideSpec = data["viewinside"];
                $scope.isSupportViewInside = (angular.isDefined(viewinsideSpec["installed"])) ? !!viewinsideSpec["installed"] : $scope.isSupportViewInside;
                $scope.MAX_FOOD_ITEM = (angular.isDefined(viewinsideSpec["maxItems"])) ? parseInt(viewinsideSpec["maxItems"]) : $scope.MAX_FOOD_ITEM;
                $scope.MAX_CHARACTER_ITEM = (angular.isDefined(viewinsideSpec["maxChar"])) ? parseInt(viewinsideSpec["maxChar"]) : $scope.MAX_CHARACTER_ITEM;
            }
            if (angular.isDefined(data["shoppinglist"])) {
                var shoppinglistSpec = data["shoppinglist"];
                $scope.MAX_LIST = (angular.isDefined(shoppinglistSpec["maxLists"])) ? parseInt(shoppinglistSpec["maxLists"]) : $scope.MAX_LIST;
                $scope.MAX_LIST_ITEM = (angular.isDefined(shoppinglistSpec["maxItems"])) ? parseInt(shoppinglistSpec["maxItems"]) : $scope.MAX_LIST_ITEM;
                $scope.MAX_CHARACTER_TITLE = (angular.isDefined(shoppinglistSpec["maxChar_list"])) ? parseInt(shoppinglistSpec["maxChar_list"]) : $scope.MAX_CHARACTER_TITLE;
                $scope.MAX_CHARACTER_ITEM = (angular.isDefined(shoppinglistSpec["maxChar_item"])) ? parseInt(shoppinglistSpec["maxChar_item"]) : $scope.MAX_CHARACTER_ITEM;
            }
            if (angular.isDefined(data["deals"])) {
                var dealsSpec = data["deals"];
                $scope.isSupportDeals = (angular.isDefined(dealsSpec["installed"])) ? !!dealsSpec["installed"] : $scope.isSupportDeals;
            }
        }
    }

    function isAllowLocationType(storageType) {
        if (angular.isDefined(storageType) && storageType !== null && storageType !== "") {
            return (storageType === "STORAGE_FRIDGE" || storageType === "STORAGE_FREEZER" || storageType === "STORAGE_PANTRY" ||
                storageType === "STORAGE_FLEX_ZONE" || storageType === "STORAGE_FLEX_ZONE_18K" || storageType === "STORAGE_TAG");
        }
        return false;
    }

    function parseFoodData(device) {
        debugMessage('parseFoodData');
        $scope.Device.FoodList = { //reinitialize foodlist
            "Fridge": []
        };
        if (angular.isDefined(device["FoodList"])) {
            device["FoodList"].forEach(function (food) {
                addFoodData(food);
            });
        }
        dismissLoadingBar(REQUEST.GET_FOOD_LIST);
    }

    function addFoodData(item) {
        if (item.storageType !== "STORAGE_TAG") {// Ignore MEMO TAGS
            item.inputDate = timeStamp.convertDate(item.inputDate);
            item.expirationDate = timeStamp.convertDate(item.expirationDate);
            item.name = decodeUnescape(item.name);

            if (isAllowLocationType(item.storageType)) {
                if (item.storageType.indexOf('STORAGE_FLEX_ZONE') !== -1) {     //integrated the flex zone type by StorageModes of GlazeInfo
                    for (var i = 0; i < $scope.locations.length; i++) {
                        if ($scope.locations[i].id.indexOf('STORAGE_FLEX_ZONE') !== -1) {
                            item.storageType = $scope.locations[i].id;
                        }
                    }
                }
            }
            else {
                item.storageType = $scope.DefineLocations[0].id;
            }

            $scope.Device.FoodList.Fridge.push(item);
        }
    }

    function updateFoodData(item) {
        if (item.storageType !== "STORAGE_TAG") {// Ignore MEMO TAGS
            for (var fl = 0; fl < $scope.Device.FoodList.Fridge.length; fl++) {
                if ($scope.Device.FoodList.Fridge[fl].id === item.id) {
                    $scope.Device.FoodList.Fridge[fl] = angular.copy(item);
                    $scope.Device.FoodList.Fridge[fl].expirationDate = timeStamp.convertDate(item.expirationDate);
                    $scope.Device.FoodList.Fridge[fl].name = decodeUnescape(item.name);
                    $scope.Device.FoodList.Fridge[fl].inputDate = timeStamp.convertDate(item.inputDate);

                    if (isAllowLocationType(item.storageType)) {
                        if (item.storageType.indexOf('STORAGE_FLEX_ZONE') !== -1) {     //integrated the flex zone type by StorageModes of GlazeInfo
                            for (var i = 0; i < $scope.locations.length; i++) {
                                if ($scope.locations[i].id.indexOf('STORAGE_FLEX_ZONE') !== -1) {
                                    $scope.Device.FoodList.Fridge[fl].storageType = item.storageType = $scope.locations[i].id;
                                }
                            }
                        }
                    }
                    else {
                        $scope.Device.FoodList.Fridge[fl].storageType = item.storageType = $scope.DefineLocations[0].id;
                    }

                    return true;
                }
            }
        }
        return false;
    }

    $scope.parseCategoryDB = parseCategoryDB;
    $scope.getCategoryInfo = getCategoryInfo;
    function parseCategoryDB(data) {
        if (angular.isDefined(data)) {
            $scope.categoryDB = [];
            data.forEach(function (category) {
                if (angular.isDefined(category.Order) && category.Order !== null && category.Order !== "")
                    category.Order = parseInt(category.Order);
                if (angular.isDefined(category.displayName) && category.displayName !== null && category.displayName !== "")
                    category.displayName = decodeUnescape(category.displayName);
                $scope.categoryDB.push(category);
            });
        }
    }

    $scope.isSelectedSameCategory = function (masterCategory_id) {
        if (angular.isUndefined(masterCategory_id))
            return false;
        var result = $filter('filter')($scope.selectedItems, {category_info: convertToWhisk_Category(masterCategory_id)});
        return result.length === $scope.selectedItems.length;
    };

    $scope.convertToCategory_ID = convertToCategory_ID;
    function convertToCategory_ID(whisk_category_id) {
        //Convert Whisk Category id to Master Category
        for (var i = 0; i < categoryMap.length; i++) {
            var category = categoryMap[i];
            if (whisk_category_id === category.Whisk_Category)
                return category.Category_ID;
        }
        return default_master_category_id;
    }

    $scope.convertToWhisk_Category = convertToWhisk_Category;
    function convertToWhisk_Category(masterCategory_id) {
        //Convert Master Category to Whisk Category id
        for (var i = 0; i < categoryMap.length; i++) {
            var category = categoryMap[i];
            if (masterCategory_id === category.Category_ID)
                return category.Whisk_Category;
        }
        return default_category_id;
    }
    
    function getCategoryInfo(categoryId) {
        if (angular.isDefined(categoryId) && categoryId !== "") {
            var masterCategory_id = convertToCategory_ID(categoryId);
            for (var index = 0; index < $scope.categoryDB.length; index++) {
                var categoryInfo = $scope.categoryDB[index];
                if (categoryInfo.Category_ID === masterCategory_id)
                    return categoryInfo;
            }
        }
        return undefined;
    }

    function parseShoppingData(device) {
        debugMessage("parseShoppingData");
        if (angular.isUndefined(device["ShoppingList"]) || angular.isUndefined($scope.Device.ShoppingList))
            return;

        if (angular.isDefined(device["ShoppingList"])) {
            device["ShoppingList"].forEach(function (deviceShoppingList) {
                deviceShoppingList.order = (angular.isDefined(deviceShoppingList.order))? deviceShoppingList.order : deviceShoppingList.id;
                if (angular.isUndefined(deviceShoppingList.food_position))
                    deviceShoppingList.food_position = "";

                if (angular.isDefined(deviceShoppingList.Deals)) {
                    if (angular.isUndefined(deviceShoppingList.Deals.deals_id))
                        deviceShoppingList.Deals.deals_id = "";
                    if (angular.isUndefined(deviceShoppingList.Deals.price))
                        deviceShoppingList.Deals.price = "";
                    deviceShoppingList.Deals.storeName = decodeUnescape(deviceShoppingList.Deals.storeName);
                    deviceShoppingList.Deals.deals_detail = decodeUnescape(deviceShoppingList.Deals.deals_detail);

                    if (angular.isUndefined(deviceShoppingList.Deals.expiry_date))
                        deviceShoppingList.Deals.expiry_date = "";
                    if (angular.isUndefined(deviceShoppingList.Deals.api_name))
                        deviceShoppingList.Deals.api_name = "";
                    if (angular.isUndefined(deviceShoppingList.Deals.clip_state))
                        deviceShoppingList.Deals.clip_state = "";
                }
                else {
                    deviceShoppingList.Deals = {
                        deals_id: "",
                        price: "",
                        storeName: "",
                        deals_detail: "",
                        expiry_date:"",
                        api_name:"",
                        clip_state:""
                    }
                }

                if (deviceShoppingList.groupId === deviceShoppingList.id) {       //Title Info
                    deviceShoppingList.category = decodeUnescape(deviceShoppingList.category);
                    if (!angular.isDefined($scope.Device.ShoppingList[deviceShoppingList.groupId])) {
                        $scope.Device.ShoppingList[deviceShoppingList.groupId] = angular.copy(deviceShoppingList);
                        $scope.Device.ShoppingList[deviceShoppingList.groupId].items = [];
                        $scope.Device.ShoppingList[deviceShoppingList.groupId].isTemp = false;
                        debugMessage("parseShoppingData:: deviceShoppingList=" + JSON.stringify($scope.Device.ShoppingList[deviceShoppingList.groupId]));
                    } else {
                        deviceShoppingList.items = $scope.Device.ShoppingList[deviceShoppingList.groupId].items;
                        $scope.Device.ShoppingList[deviceShoppingList.groupId] = angular.copy(deviceShoppingList);
                        $scope.Device.ShoppingList[deviceShoppingList.groupId].isTemp = false;
                    }

                    //refresh Title in detail&add Page
                    if ($scope.inputData.groupId === deviceShoppingList.groupId)
                        $scope.inputData.category = $scope.Device.ShoppingList[deviceShoppingList.groupId].category;

                    if ($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME && $scope.isSelectedMode) {
                        selectedModeForDelete();
                    }
                }
                else {      //Item Info
                    if (angular.isDefined(device["event"]) && device["event"] === "Notified") {
                        //if item is moved to other list, delete item before saved list
                        $.each($scope.Device.ShoppingList, function (groupId, items) {
                            if (deviceShoppingList.groupId === groupId)
                                return;
                            var index = $scope.Device.ShoppingList[groupId].items.map(function (item) {
                                return item.id;
                            }).indexOf(deviceShoppingList.id);
                            if (index !== -1) {
                                $scope.Device.ShoppingList[groupId].items.splice(index, 1);

                                if ($scope.currentScreen === SHOPPINGLIST_SCREEN.DETAIL_SCREEN && $scope.isSelectedMode) {
                                    if ($scope.inputData.groupId === groupId) {
                                        if ($scope.Device.ShoppingList[groupId].items.length === 0)
                                            closeSelectedMode();
                                        else
                                            resetSelectedMode();
                                    }
                                }
                            }
                        });
                    }

                    // console.log("deviceShoppingList ", deviceShoppingItem);
                    //Title Info is not defined, create the temp title info.(isTemp = true)
                    if (angular.isUndefined($scope.Device.ShoppingList[deviceShoppingList.groupId])) {
                        $scope.Device.ShoppingList[deviceShoppingList.groupId] = angular.copy(deviceShoppingList);
                        $scope.Device.ShoppingList[deviceShoppingList.groupId].id = deviceShoppingList.groupId;
                        $scope.Device.ShoppingList[deviceShoppingList.groupId].category = decodeHtmlEntity($scope.translation.WEBMOB_fhub2_shopping_list_create_new_title);
                        $scope.Device.ShoppingList[deviceShoppingList.groupId].isDefault = deviceShoppingList.isDefault;
                        $scope.Device.ShoppingList[deviceShoppingList.groupId].items = [];
                        $scope.Device.ShoppingList[deviceShoppingList.groupId].isTemp = true;

                        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME && $scope.isSelectedMode) {
                            selectedModeForDelete();
                        }
                    }

                    //Save Item info.
                    if (angular.isDefined($scope.Device.ShoppingList[deviceShoppingList.groupId])) {
                        deviceShoppingList.name = decodeUnescape(deviceShoppingList.name);
                        deviceShoppingList.recipeName = decodeUnescape(deviceShoppingList.recipeName);
                        if (isEmart(deviceShoppingList)) {
                            $scope.EmartAPIService.EmartSearchRequest(deviceShoppingList.emart_item_id);
                        }

                        if (angular.isDefined(deviceShoppingList.food_position) && isAllowLocationType(deviceShoppingList.food_position)) {
                            if (deviceShoppingList.food_position.indexOf('STORAGE_FLEX_ZONE') !== -1) {
                                //integrated the flex zone type by StorageModes of GlazeInfo
                                for (var i = 0; i < $scope.locations.length; i++) {
                                    if ($scope.locations[i].id.indexOf('STORAGE_FLEX_ZONE') !== -1) {
                                        deviceShoppingList.food_position = $scope.locations[i].id;
                                    }
                                }
                            }
                        }
                        else {
                            deviceShoppingList.food_position = $scope.DefineLocations[0].id;
                        }

                        //check Category_info
                        if (angular.isUndefined(getCategoryInfo(deviceShoppingList.category_info))) {
                            deviceShoppingList.category_info = default_category_id;
                        }
                        deviceShoppingList.master_category_info = convertToCategory_ID(deviceShoppingList.category_info);

                        var index = $scope.Device.ShoppingList[deviceShoppingList.groupId].items.map(function (item) {
                            return item.id;
                        }).indexOf(deviceShoppingList.id);
                        if (index === -1) {
                            $scope.Device.ShoppingList[deviceShoppingList.groupId].items.push(deviceShoppingList);
                            if (deviceShoppingList.imageURL !== null && deviceShoppingList.imageURL !== '') {
                                var img_idx = $scope.imageURL_List.map(function (url) {
                                    return url;
                                }).indexOf(deviceShoppingList.imageURL);
                                if (img_idx === -1)
                                    $scope.imageURL_List.push(deviceShoppingList.imageURL);
                            }
                        }
                        else {

                            var saved_item = $scope.Device.ShoppingList[deviceShoppingList.groupId].items[index];
                            //If same item is already saved, do not update again.
                            if (deviceShoppingList.name === saved_item.name &&
                                deviceShoppingList.itemStatus === saved_item.itemStatus &&
                                deviceShoppingList.imageURL === saved_item.imageURL &&
                                deviceShoppingList.order === saved_item.order &&
                                deviceShoppingList.category_info === saved_item.category_info &&
                                deviceShoppingList.storageType === saved_item.storageType)
                                return;

                            $scope.Device.ShoppingList[deviceShoppingList.groupId].items[index] = angular.copy(deviceShoppingList);

                            var curImgURL = $scope.Device.ShoppingList[deviceShoppingList.groupId].items[index].imageURL;
                            if (curImgURL !== null && curImgURL !== '') {
                                var img_idx = $scope.imageURL_List.map(function (url) {
                                    return url;
                                }).indexOf(curImgURL);
                                if (img_idx === -1)
                                    $scope.imageURL_List.push(curImgURL);
                            }
                        }

                        //refresh textArea size in detail&add Page
                        if ($scope.inputData.groupId === deviceShoppingList.groupId)
                            resizeTextArea(deviceShoppingList.id);

                        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.DETAIL_SCREEN && $scope.isSelectedMode) {
                            if ($scope.inputData.groupId === deviceShoppingList.groupId) {
                                if ($scope.Device.ShoppingList[deviceShoppingList.groupId].items.length === 0)
                                    closeSelectedMode();
                                else
                                    resetSelectedMode();
                            }
                        }
                    }

                }

                orderByCategory(deviceShoppingList.groupId);
            });
        }

        request_imageURL_List();
    }

    $scope.orderByCategory = orderByCategory;
    function orderByCategory(groupId) {
        if (angular.isUndefined($scope.Device.ShoppingList[groupId]))
            return;

        categoryMap.forEach(function (category) {
            // console.log("orderByCategory = ", groupId, $scope.Device.ShoppingList[groupId].items, {'category_info': category.Whisk_Category});
            var filtered = $filter('filter')($scope.Device.ShoppingList[groupId].items, {'master_category_info': category.Category_ID});
            // console.log("orderByCategory = ", filtered);
            var orderBy_id = $filter('orderBy')(filtered, '+id');
            // console.log("orderByCategory = ", orderBy_id);
            if (orderBy_id.length > 0) {
                var category_order = orderBy_id[0].id;

                for (var i = 0; i < orderBy_id.length; i++) {
                    var index = $scope.Device.ShoppingList[groupId].items.map(function (item) {
                        return item.id;
                    }).indexOf(orderBy_id[i].id);
                    if (index !== -1) {
                        $scope.Device.ShoppingList[groupId].items[index].category_order = category_order;
                    }
                }
            }
        });
    }

    function parseDeviceData(device) {

        if (angular.isDefined(device['GlazeInfo']) && angular.isUndefined(device['event'])) {    //Ignore notification of GlazeInfo
            if (angular.isDefined(device['event']) && device['event'] === 'Notified') {
                return;
            }
            $scope.Device.GlazeInfo = angular.copy(device['GlazeInfo']);

            //initial Locations
            if (angular.isDefined($scope.Device.GlazeInfo["StorageModes"])) {
                $scope.locations = [];
                $scope.Device.GlazeInfo["StorageModes"].forEach(function (modes) {
                    var location;
                    if (modes === 'STORAGE_FRIDGE') {
                        location = {"id": "STORAGE_FRIDGE", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_fridge)};
                        $scope.locations.push(location);
                    }
                    else if (modes === 'STORAGE_FREEZER') {
                        location = {"id": "STORAGE_FREEZER", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_freezer)};
                        $scope.locations.push(location);
                    }
                    else if (modes === 'STORAGE_FLEX_ZONE') {
                        location = {"id": "STORAGE_FLEX_ZONE", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_flex_zone)};
                        $scope.locations.push(location);
                    }
                    else if (modes === 'STORAGE_FLEX_ZONE_18K') {
                        location = {"id": "STORAGE_FLEX_ZONE_18K", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_flex_zone_18K)};
                        $scope.locations.push(location);
                    }
                    else if (modes === 'STORAGE_PANTRY') {
                        location = {"id": "STORAGE_PANTRY", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_pantry)};
                        $scope.locations.push(location);
                    }
                });
            }
            else {
                //if it is not supported 'StorageModes', show all locations.
                $scope.locations = [
                    {"id": "STORAGE_FRIDGE", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_fridge)},
                    {"id": "STORAGE_FREEZER", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_freezer)},
                    {"id": "STORAGE_FLEX_ZONE", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_flex_zone)},
                    {"id": "STORAGE_PANTRY", "name": decodeHtmlEntity($scope.translation.WEBMOB_fhub2_food_reminder_pantry)}
                ];
            }
        }

        if (angular.isDefined(device["FoodList"])) {
            if (device['event'] === 'Deleted') {
                device["FoodList"].forEach(function (deviceFoodList) {
                    for (var index = 0; index < $scope.Device.FoodList.Fridge.length; index++) {
                        if ($scope.Device.FoodList.Fridge[index].id === deviceFoodList.id) {
                            $scope.Device.FoodList.Fridge.splice(index, 1);
                            break;
                        }
                    }
                });
                return;
            } else if (device['event'] === 'Created' || device['event'] === 'Notified') {
                device["FoodList"].forEach(function (deviceFood) {
                    if (!updateFoodData(deviceFood)) {
                        addFoodData(deviceFood);
                    }
                });
            }
        }

        if (angular.isDefined(device["CategoryDB"])) {
            parseCategoryDB(device["CategoryDB"]);
        }

        if (angular.isDefined(device["ShoppingList"])) {
            if (angular.isUndefined($scope.Device.ShoppingList))
                return;
            debugMessage("parseDeviceData:: device=" + JSON.stringify(device));
            if (device['event'] === 'Deleted') {
                debugMessage("parseDeviceData:: (device['event'] === 'Deleted')");
                device["ShoppingList"].forEach(function (deviceShoppingList) {
                    if (angular.isDefined(deviceShoppingList.groupId) && angular.isDefined(deviceShoppingList.id) && (deviceShoppingList.groupId === deviceShoppingList.id)) {
                        console.log("Parse Delete ShoppingList(Title)::: list.groupId = " + deviceShoppingList.groupId);
                        if ($scope.inputData.groupId === deviceShoppingList.groupId) {
                            goToShopListHome();
                            $scope.closeConfirmationPopUp();
                        }
                        delete $scope.Device.ShoppingList[deviceShoppingList.groupId];

                        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME && $scope.isSelectedMode) {
                            selectedModeForDelete();
                        }
                    }
                    else if (angular.isDefined(deviceShoppingList.groupId) && angular.isDefined($scope.Device.ShoppingList[deviceShoppingList.groupId])){
                        console.log("Parse Delete ShoppingList(Item)::: list.id = " + deviceShoppingList.id);
                        for (var index = 0; index < $scope.Device.ShoppingList[deviceShoppingList.groupId].items.length; index++) {
                            if ($scope.Device.ShoppingList[deviceShoppingList.groupId].items[index].id === deviceShoppingList.id) {
                                $scope.Device.ShoppingList[deviceShoppingList.groupId].items.splice(index, 1);
                                break;
                            }
                        }

                        //if list is created temporarily, remove list.
                        if ($scope.Device.ShoppingList[deviceShoppingList.groupId].isTemp && $scope.Device.ShoppingList[deviceShoppingList.groupId].items === 0) {
                            if ($scope.inputData.groupId === deviceShoppingList.groupId) {
                                goToShopListHome();
                                $scope.closeConfirmationPopUp();
                            }
                            delete $scope.Device.ShoppingList[deviceShoppingList.groupId];
                        }

                        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.DETAIL_SCREEN && $scope.isSelectedMode) {
                            if ($scope.inputData.groupId === deviceShoppingList.groupId) {
                                console.log('enable selectMode');
                                if ($scope.Device.ShoppingList[deviceShoppingList.groupId].items.length === 0)
                                    closeSelectedMode();
                                else
                                    resetSelectedMode();
                            }
                        }
                    }

                    orderByCategory(deviceShoppingList.groupId);
                });
            }
            else if (device['event'] === 'Created' || device['event'] === 'Notified') {
                debugMessage("parseDeviceData:: (device['event'] === " + device['event']);
                parseShoppingData(device);
            }
        }
    }

    function parseStaticData() {
        // staticData.parseStaticData_FHub2();
        staticData.parseStaticData_FHub3();
    }

    function requestFailHandler(response) {
    	if(response["status"] === STATUS_500 && (response["type"] === "requestResponse" || response["type"] === "requestFailed")) {
            $scope.checkResponse = [];
            $scope.loadingBar = false;
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_common_check_power_and_network, "");
        }
        if (response["status"] === 404 && response["type"] === "requestFailed") {
            console.log("Image Not Found - ", JSON.stringify(response) , response);
        }
    }

    function requestResponseHandler(response) {
        console.log('ShoppingList RequestResponseHandler');
        if (response['requestToken'] === REQUEST.GET_GLAZE_INFO) {
            if (angular.isDefined(response["data"]['GlazeInfo'])) {
                $scope.parseDeviceData(response["data"]);
                dismissLoadingBar(REQUEST.GET_GLAZE_INFO);
            }
        }

        if (response['requestToken'] === REQUEST.GET_IMAGE_LIST) {
            if (angular.isDefined(response["data"])) {
                imageRequest.parseNativeResponse(response["data"]);

                var url_length = $scope.imageURL_List.length;
                if ((url_length > 1 && url_length % 2 === 0) || url_length === 1) {
                    request_imageURL_List();
                }
            }
        }

        if (response['requestToken'] === REQUEST.GET_FOOD_LIST) {
            $scope.parseFoodData(response["data"]);
            dismissLoadingBar(REQUEST.GET_FOOD_LIST);
        }
        if (response['requestToken'] === REQUEST.ADD_FOOD_LIST) {
            // //$scope.loadingBar = false;
            $scope.parseDeviceData(response['data']);
            dismissLoadingBar(REQUEST.ADD_FOOD_LIST);
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_shopping_list_send_to_view_inside_toast, REQUEST.SHOW_TOAST);
        }

        if (response['requestToken'] === REQUEST.GET_CATEGORY_DB) {
            $scope.parseDeviceData(response["data"]);
            dismissLoadingBar(REQUEST.GET_CATEGORY_DB);
            SHPService.loadingFinished();
        }

        if (response['requestToken'].indexOf(REQUEST.SEARCH_FOR_FOOD + '_QUERY_') !== -1) {
            if (angular.isDefined($scope.asyncQuery) && $scope.asyncQuery !== null) {
                $scope.asyncQuery.notify(response);
            }
        }

        if (response['requestToken'] === REQUEST.GET_SHOPPING_LIST) {
            initialLaunch = false;
            $scope.init();
            $scope.parseShoppingData(response["data"]);
            goToShopListHome();
            dismissLoadingBar(REQUEST.GET_SHOPPING_LIST);
            SHPService.loadingFinished();
        }
        else if (response['requestToken'] === REQUEST.ADD_SHOPPING_LIST) {
            // closeAllPopUp();
            console.log(response['data']);
            $scope.parseDeviceData(response['data']);
            dismissLoadingBar(REQUEST.ADD_SHOPPING_LIST);
        }
        else if (response['requestToken'] === REQUEST.EDIT_SHOPPING_LIST) {
            $scope.parseDeviceData(response['data']);
            dismissLoadingBar(REQUEST.EDIT_SHOPPING_LIST);
        }
        else if (response['requestToken'] === "moveShoppinglist") {
            $scope.parseDeviceData(response['data']);
            dismissLoadingBar(REQUEST.EDIT_SHOPPING_LIST);
        }
        else if (response['requestToken'] === "changeCategory") {
            $scope.parseDeviceData(response['data']);
            dismissLoadingBar(REQUEST.EDIT_SHOPPING_LIST);
        }
        else if (response['requestToken'] === REQUEST.DELETE_SHOPPING_LIST) {
            console.log("requestToken = Deleted");
            $scope.parseDeviceData(response['data']);
            dismissLoadingBar(REQUEST.DELETE_SHOPPING_LIST);
        }

        if (response['requestToken'] === REQUEST.GET_STORE_LIST) {
            parseStoreListData(response['data']);
            dismissLoadingBar(REQUEST.GET_STORE_LIST);
        }
        if (response['requestToken'] === REQUEST.FIND_DEALS) {
            parseFindDealsData(response['data']);
            dismissLoadingBar(REQUEST.FIND_DEALS);
        }
        else if (response['requestToken'] === REQUEST.GET_WEEKLY_DEALS) {
            dismissLoadingBar(REQUEST.GET_WEEKLY_DEALS);
        }
        else if (response['requestToken'] === REQUEST.ADD_WEEKLY_DEALS) {
            dismissLoadingBar(REQUEST.ADD_WEEKLY_DEALS);
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_shopping_list_deals_updated, REQUEST.SHOW_TOAST);
        }
        else if (response['requestToken'] === REQUEST.DELETE_WEEKLY_DEALS) {
            dismissLoadingBar(REQUEST.DELETE_WEEKLY_DEALS);
        }
    }

    function requestProgressHandler(response) {

    }

    function showConnectionFailurePopup() {
        dismissLoadingBar('FAIL');
        $scope.dialogPopup.show = true;
        toggleBottomPopUpClass(true);
        $scope.dialogPopup.dialogPopupTitle = $scope.translation.WEBMOB_fhub2_common_connection_failure;
        $scope.dialogPopup.dialogPopupText = $scope.translation.WEBMOB_fhub2_common_check_power_and_network;
        $scope.dialogPopup.button1Title = $scope.translation.WEBMOB_fhub2_common_ok_capital;
        $scope.dialogPopup.button1Handler = function () {
            closeApp();
        };
    }

    function closeConnectionFailurePopup() {
        $scope.dialogPopup.show = false;
        toggleBottomPopUpClass(false);
    }

    function goToShopListHome() {
        console.log("goToShopListHome:::");

        initial_inputData();
        clearModifyList();
        clearEventQueue();
        closeSelectedMode();

        if (angular.isDefined($scope.groupId) && $scope.groupId !== "") {
            //Goto Detail Page from Dashboard.
            var groupId = $scope.groupId;
            $scope.groupId = "";
            showDetailScreen(groupId);
        }
        else {
            $scope.currentScreen = SHOPPINGLIST_SCREEN.HOME;
            changeScreen();
        }
    }

    function goToDetailPage() {
        $scope.currentScreen = SHOPPINGLIST_SCREEN.DETAIL_SCREEN;
        debugMessage('goToDetailPage - category: ' + $scope.inputData.groupId);
        $state.transitionTo('DetailPage');
        changeScreen();
    }

    function showDetailScreenForCreateList() {
        console.log('showDetailScreenForCreateList(Start):::');
        if (isMaximum_ShoppingList()) {
            var savedDefaultList = false;
            var max_list_size = $scope.MAX_LIST;
            $.each($scope.Device.ShoppingList, function (groupId, list) {
                if (angular.isDefined(list.isDefault) && list.isDefault === true) {
                    savedDefaultList = true;
                    return;
                }
            });

            if (savedDefaultList)
                max_list_size++;

            debugMessage('showDetailScreenForCreateList:::max_list_size = ' + max_list_size);
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_shopping_list_add_list_max_lists.replace("#num#", max_list_size.toString()), "");
            return;
        }

        initial_inputData();
        clearModifyList();
        closeSelectedMode();
        clearEventQueue();

        // $scope.inputData.groupId = groupId = "20170522015858237";         //For demo test
        goToDetailPage();

        console.log('showDetailScreenForCreateList:::Focus - addItem');
        $timeout(function () {
            $("#addItem").focus();
        }, 300);
    }

    function showDetailScreen(groupId) {
        //prevent loop goToShopListHome()<->showDetailScreen()
        if (angular.isUndefined(groupId) || (angular.isDefined(groupId) && groupId === ""))
            return;

        if (angular.isUndefined($scope.Device.ShoppingList[groupId])) {
            debugMessage("showDetailScreen Undefined groupId = " + groupId);
            goToShopListHome();
            return;
        }
        else {
            debugMessage("showDetailScreen Defined groupId = " + groupId);
        }

        if ($scope.isSelectedMode) {
            return;
        }
        initial_inputData();
        closeSelectedMode();
        clearModifyList();
        clearEventQueue();
        $scope.inputData.groupId = groupId;

        goToDetailPage();
    }

    function goToChangeCategoryPage() {
        $scope.currentScreen = SHOPPINGLIST_SCREEN.CHANGE_CATEGORY_SCREEN;
        $state.transitionTo('ChangeCategoryPage');
        changeScreen();
    }

    function goToMoveToOtherListPage() {
        $scope.inputData.selectedCategory = {};
        $scope.inputData.createCategory = "";
        $scope.move_shopping_list = $filter('orderShoppingListBy')($scope.Device.ShoppingList, 'isDefault', 'groupId', false, $scope.Device.ShoppingList);
        setSelectedCategory($scope.move_shopping_list, $scope.inputData.groupId);

        $scope.currentScreen = SHOPPINGLIST_SCREEN.MOVE_TO_OTHER_LIST_SCREEN;
        $state.transitionTo('MoveToOtherListPage');
        changeScreen();
    }

    function goToFrequentItemPage(selectedMode) {
        $scope.isSelectedMode = true;
        $scope.currentSelectedMode = selectedMode;
        resetSelectedMode();

        $scope.currentScreen = SHOPPINGLIST_SCREEN.FREQUENT_ITEM_SCREEN;
        $state.transitionTo('FrequentItemPage');
        changeScreen();
    }

    $scope.goToFindDealsPage = goToFindDealsPage;
    function goToFindDealsPage() {
        $scope.isExpandStoreList = false;
        $scope.isSelectedMode = true;
        $scope.currentSelectedMode = 'FindDeals';
        $scope.currentScreen = SHOPPINGLIST_SCREEN.FIND_DEALS_SCREEN;
        $state.transitionTo('FindDealsPage');
        changeScreen();
    }

    function goToSettingsPage() {
        console.log("goToSettingsPage");
        $scope.inputData.auto_sendToViewInside = get_auto_sendToViewInside();
        $scope.currentScreen = SHOPPINGLIST_SCREEN.SETTING_SCREEN;
        $state.transitionTo('SettingsPage');
        changeScreen();
    }

    function onBackPressed() {
        debugMessage("onBackPressed");

        // if ($scope.modifyList.length !== 0 && ($scope.DetailPage && !$scope.isSelectedMode)) {
        //     $scope.eventQueue.push($scope.events.BACK_PRESSED);
        //     removeFocus();
        //     return;
        // } else {
            removeFocus();
        // }

        if ($scope.reNamePopup) {
            closeReNamePopup();
            return;
        }

        if ($scope.productDetailPopup) {
            closeProductDetailPopup();
            return;
        }

        if ($scope.noStorePopup) {
            closeNoStorePopup();
            return;
        }

        if ($scope.createNewListPopUp) {
            closeCreateNewListPopUp();
            return;
        }

        if ($scope.sendToViewInsidePopup) {
            cancelSendToViewInsidePopup();
            return;
        }

        if ($scope.dialogPopup.show) {
            closeApp();
            return;
        }

        if ($scope.confirmationPopUpVisible) {
            closeConfirmationPopUp();
            return;
        }

        if ($scope.bOptionPopUp) {
            $scope.bOptionPopUp = false;
            return;
        }

        if ($scope.isSelectedMode &&
            ($scope.currentScreen === SHOPPINGLIST_SCREEN.MOVE_TO_OTHER_LIST_SCREEN ||
            $scope.currentScreen === SHOPPINGLIST_SCREEN.CHANGE_CATEGORY_SCREEN)) {
            goToDetailPage();
            return;
        }
        else if ($scope.isSelectedMode && $scope.currentScreen === SHOPPINGLIST_SCREEN.FIND_DEALS_SCREEN) {
            closeSelectedMode();
        }
        else if ($scope.isSelectedMode && $scope.currentScreen !== SHOPPINGLIST_SCREEN.HOME) {
            closeSelectedMode();
            return;
        }

        switch ($scope.currentScreen) {
            case SHOPPINGLIST_SCREEN.HOME:
                if ($scope.isSelectedMode) {
                    goToShopListHome();
                } else {
                    closeApp();
                }
                break;
            case SHOPPINGLIST_SCREEN.DETAIL_SCREEN:
                goToShopListHome();
                break;
            case SHOPPINGLIST_SCREEN.MOVE_TO_OTHER_LIST_SCREEN:
            case SHOPPINGLIST_SCREEN.CHANGE_CATEGORY_SCREEN:
            case SHOPPINGLIST_SCREEN.FREQUENT_ITEM_SCREEN:
            case SHOPPINGLIST_SCREEN.FIND_DEALS_SCREEN:
            case SHOPPINGLIST_SCREEN.SETTING_SCREEN:
                if (SHOPPINGLIST_SCREEN.SETTING_SCREEN) {
                    set_auto_sendToViewInside($scope.inputData.auto_sendToViewInside);
                }
                showDetailScreen($scope.inputData.groupId);
                break;
            default:
                goToShopListHome();
                break;
        }
    }

    /**
     * @function
     * @private
     * @name closeLoadingBar
     * @description To close loading bar based on response
     */
    function closeLoadingBar() {
        $timeout(function () {
            $scope.checkResponse = [];
            $scope.loadingBar = false;
            $scope.isTransparent = false;
            SHPService.loadingFinished();
            runEventQueue();
        }, 0);
    }

    function dismissLoadingBar(value) {
        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            if ($scope.checkResponse.length === 0) {
                closeLoadingBar();
            }
            else {
                console.log($scope.checkResponse);
            }
        } else {
            if (value === 'FAIL') {
                $scope.checkResponse = [];
                $scope.loadingBar = false;
                $scope.isTransparent = false;
            }
        }
    }

    function runEventQueue() {
        while (angular.isDefined($scope.eventQueue) && $scope.eventQueue.length !== 0) {
            clearModifyList();
            var task = $scope.eventQueue.shift();
            switch (task) {
                case $scope.events.BACK_PRESSED:
                    onBackPressed();
                    break;
                case $scope.events.SHOW_OPTION_POPUP:
                    showOptionPopup();
                    break;
            }
        }
    }

    function clearEventQueue() {
        if (angular.isDefined($scope.eventQueue) && $scope.eventQueue.length !== 0)
            $scope.eventQueue = [];
    }

    function toggleBottomPopUpClass(popupName) {
        if (popupName) {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivIn";
            $scope.BottomPopupDivCls = "BottomPopupBGIn";
        } else {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivOut";
            $scope.BottomPopupDivCls = "BottomPopupBGOut";
        }
    }

    function closeApp() {
        SHPService.sendNativeCommand(REQUEST.CLOSE_WEB_APP, "", "");
    }

    $scope.$watch(function () {return document.body.clientHeight;}, function (newValue, oldValue) {
        console.log("watch:::View Size is changed = " + oldValue + " to " + newValue);
    }, true);

    function removeFocus() {
        document.activeElement.blur();
        SHPService.sendNativeCommand(REQUEST.CLOSE_KEYPAD, REQUEST.CLOSE_KEYPAD, "");
    }

    $scope.createNewListPopUp = false;
    $scope.showCreateNewListPopUp = showCreateNewListPopUp;
    $scope.closeCreateNewListPopUp = closeCreateNewListPopUp;
    function showCreateNewListPopUp() {
        removeFocus();
        $scope.inputData.createCategory = decodeHtmlEntity($scope.translation.WEBMOB_fhub2_shopping_list_create_new_title);
        $scope.createNewListPopUp = true;

        $timeout(function () {
            console.log('showCreateNewListPopUp:::newlistTitleID_createList-focus, select');
            $("#newlistTitleID_createList").focus();
            document.getElementById('newlistTitleID_createList').setSelectionRange(0, $scope.MAX_CHARACTER_TITLE);
        }, 0);
    }

    function closeCreateNewListPopUp() {
        removeFocus();
        $scope.inputData.createCategory = "";
        $scope.createNewListPopUp = false;
    }

    $scope.checkMoveList = function (list) {
        return (!isMaximum_ShoppingList_item(list[0].groupId, $scope.selectedItems.length) &&
                $scope.inputData.groupId !== list[0].groupId);
    };

    $scope.move_shopping_list = [];
    $scope.isObjectCount = isObjectCount;
    $scope.setSelectedCategory = setSelectedCategory;
    function isObjectCount(obj) {
        if (angular.isDefined(obj))
            return Object.keys(obj).length;
        return 0;
    }

    function setSelectedCategory(lists, notSelectId) {
        if (isObjectCount(lists) === 0) {
            $scope.inputData.selectedCategory = '';
        }
        else {
            Object.keys(lists).forEach(function(key, index, array) {
                if (index === 0) {
                    if (angular.isDefined(notSelectId) && key === notSelectId) {
                        debugMessage("setSelectedCategory(true):::: " + notSelectId + " / " + index + " / " + array[1]);
                        $scope.inputData.selectedCategory = lists[array[1]];
                    }
                    else {
                        debugMessage("setSelectedCategory(false):::: " + notSelectId + " / " + index + " / " + array[0]);
                        $scope.inputData.selectedCategory = lists[array[0]];
                    }
                }
            });
        }
    }

    $scope.sendToViewInsidePopup = false;
    $scope.showSendToViewInsidePopup = showSendToViewInsidePopup;
    $scope.cancelSendToViewInsidePopup = cancelSendToViewInsidePopup;
    function showSendToViewInsidePopup() {
        debugMessage("showSendToViewInsidePopup");
        if (isMaximumFoodList($scope.selectedItems.length)) {
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_food_reminder_send_max_items.replace("#num#", $scope.MAX_FOOD_ITEM.toString()), REQUEST.SHOW_TOAST);
            return;
        }
        $scope.inputData.storageType = (angular.isDefined($scope.locations[0]))? $scope.locations[0].id : '';
        $scope.sendToViewInsidePopup = true;
    }

    function cancelSendToViewInsidePopup() {
        $scope.inputData.storageType = (angular.isDefined($scope.locations[0]))? $scope.locations[0].id : '';
        debugMessage('onBackPressed called cancelSendToViewInsidePopup');
        $scope.sendToViewInsidePopup = false;
    }

    $scope.bindTouchEventForTextArea = bindTouchEventForTextArea;
    function bindTouchEventForTextArea() {
        if ($scope.isAppleDevice) {
            console.log('^_______________^',$('textarea'));
            $('textarea').bind({
                touchend: function (event) {
                    console.log("touchend = ", event);
                    event.preventDefault();
                }
            });
        }
    }

    $scope.$on('ngRepeatFinishedForItems', function () {
        console.log('ngRepeatFinishedForItems', $scope.inputData.groupId);
        if (angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId])) {
            $scope.Device.ShoppingList[$scope.inputData.groupId].items.forEach(function (item) {
                resizeTextArea(item.id);
            });
        }
        bindTouchEventForTextArea();
    });

    /** Starts Check For the modified input fields **/
    function clearModifyList() {
        $scope.modifyList = [];
    }

    function isAdded(item) {
        for (var i = 0; i < $scope.modifyList.length; i++) {
            if ($scope.modifyList[i].id === item.id) {
                return true;
            }
        }
        return false;
    }

    function addModifyItem(item) {
        // console.log("addModifyItem");
        if (!isAdded(item))
            $scope.modifyList.push(item);
    }

    function removeModifyItem(item) {
        $scope.modifyList.forEach(function (modifyItem, index) {
            if (modifyItem.id === item.id)
                $scope.modifyList.splice(index, 1);
        });
    }

    function getModifyItem(id) {
        for (var i = 0; i < $scope.modifyList.length; i++) {
            if ($scope.modifyList[i].id === id)
                return $scope.modifyList[i];
        }
        return undefined;
    }

    /** Ends Check For the modified input fields **/

    $scope.moveScroll = moveScroll;
    function moveScroll(elementId) {
        if (angular.isUndefined(elementId) || angular.isUndefined($('#' + elementId)) || window.navigator.platform === 'iPhone') {
            console.log("moveScroll::: isUndefined itemId = " + elementId);
            return;
        }
        console.log("moveScroll::: isDefined itemId = " + elementId);

        var position = 0;
        if (elementId.indexOf('list_') !== -1) {
            var initTopPosition = $('.scroll_area').offset().top;
            console.log('screen View Height = ' + document.body.clientHeight);
            console.log('initTopPosition = ' + initTopPosition);
            if (angular.isDefined($('#' + elementId).offset()) && angular.isDefined($('#' + elementId).offset().top)) {
                console.log("$('#'" + elementId + ").offset().top = " + $('#' + elementId).offset().top);
                console.log("scrollTop = " + ($('#' + elementId).offset().top - initTopPosition));
                position = $('#' + elementId).offset().top - initTopPosition;
                // position = initTopPosition;
                // position = $('#' + elementId).offset().top / 2;
            }
        }
        else {
            return;
        }

        $timeout(function () {
            $('body').animate({
                    scrollTop: position
                },
                'slow');
        }, 10);
    }

    $scope.checkElement = checkElement;
    function checkElement(element, maxCharacter) {
        if (angular.isDefined(element)) {
            var previewItem = getModifyItem(element.id);
            if (angular.isDefined(previewItem) && element.value.length > maxCharacter) {
                if (element.id === 'addItem')
                    $scope.inputData.name = element.value = previewItem.prevText;
                // else if (element.id.indexOf('list_') !== -1) {
                //     var itemId = element.id.split("_")[1];
                //     var index = $scope.Device.ShoppingList[$scope.inputData.groupId].items.map(function (item) {return item.id;}).indexOf(itemId);
                //     $scope.Device.ShoppingList[$scope.inputData.groupId][index] = element.value = previewItem.prevText;
                // }
                // else if (element.id === 'newlistTitleID')
                //     $scope.inputData.category = element.value = previewItem.prevText;
                // else if (event.target.id === 'newlistTitleID_createList') {
                //     $scope.inputData.createCategory = element.value = previewItem.prevText;
                // }

                SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_common_max_characters, "");
            }
        }
    }

    $scope.clearText = clearText;
    function clearText(element_id) {
        if ($scope.createNewListPopUp) {
            $scope.inputData.createCategory = "";
        }
        else if ($scope.reNamePopup) {
            $scope.inputData.category = "";
        }
        else if ($scope.currentScreen === SHOPPINGLIST_SCREEN.DETAIL_SCREEN) {
            $scope.inputData.name = "";
        }

        $timeout(function () {
            if (angular.isDefined(element_id) && element_id !== null) {
                var element = $('#' + element_id);
                if (angular.isDefined(element) && element !== null) {
                    element.focus();
                }
            }
        }, 0);
    }

    $scope.changeHandler = changeHandler;
    function changeHandler(element_id ,ngModel, max_character) {
        console.log("changeHandler:::", element_id, ngModel, max_character);

        if (element_id.indexOf('list_') !== -1)
            resizeTextArea(element_id.split('list_')[1]);

        if (angular.isUndefined(ngModel) || (angular.isDefined(ngModel) && ngModel.length > max_character)) {
            removeFocus();
        }

        var previewItem = getModifyItem(element_id);
        if (angular.isDefined(previewItem) && ngModel.length <= max_character) {
            previewItem.prevText = ngModel;
        }
    }

    $scope.focusHandler = focusHandler;
    function focusHandler(event) {
        debugMessage("****focusHandler****");
        if ($scope.loadingBar) {
            // document.getElementById(event.target.id).blur();
            console.log("focusHandler::: Remove Focused  id = " + event.target.id);
            removeFocus();
            return;
        }

        if (angular.isDefined(event.target.id) && event.target.id.indexOf('addItem') !== -1) {
            $(".md-scroll-mask").css({'display': 'block'});
            $("md-virtual-repeat-container").css({'display': 'block'});
        }

        // debugMessage("****focusHandler::: data = " + event.target.value);
        // console.log(event);
        debugMessage("****focusHandler::: event.target.id = " + event.target.id);
        if (angular.isDefined(event.target.id) && event.target.id !== '' && !getModifyItem(event.target.id)) {
            var item = {
                id: event.target.id,
                value: angular.isDefined(event.target.value) ? event.target.value : "",
                prevText: angular.isDefined(event.target.value) ? event.target.value : ""
            };

            addModifyItem(item);
            moveScroll(event.target.id);
            if (event.target.id === 'newlistTitleID_createList') {
                $timeout(function () {
                    console.log("~~~~~~~~~~~focusHandler($timeout)::: View Size = " + document.body.clientHeight);
                    $("body").height(document.body.clientHeight);
                }, 1000);
            } else if (event.target.id.indexOf('list_') !== -1 && $scope.isAppleDevice) {
                $timeout(function () {
                    var len = document.getElementById(event.target.id).value.length;
                    document.getElementById(event.target.id).setSelectionRange(len, len);
                }, 0);
            }
        }
        console.log($scope.modifyList);
        console.log("***************************");
    }

    $scope.blurHandler = blurHandler;
    function blurHandler(event, max_character, updateItem) {
        console.log("####blurHandler::: event.target.id = ", event.target.id, " / data = ", event.target.value, " / keyCode = ", event.keyCode);
        var previewItem = getModifyItem(event.target.id);
        event.stopPropagation();
        event.preventDefault();

        if ($scope.loadingBar) {
            if (angular.isDefined(previewItem))
                removeModifyItem(previewItem);
            if (angular.isDefined(event.target.id) && event.target.id === 'addItem') {
                event.target.value = "";
            }
            return;
        }

        if (angular.isDefined(event.target.id) && event.target.id.indexOf('addItem') !== -1) {
            $(".md-scroll-mask").css({'display': 'none'});
            $("md-virtual-repeat-container").css({'display': 'none'});
        }

        if (angular.isDefined(event.target.value) && angular.isDefined(previewItem) && previewItem.id === event.target.id) {
            //Check Max Character
            if (previewItem.value !== event.target.value) {
                if (angular.isDefined(max_character) && event.target.value.length > max_character && (event.keyCode !== ENTER_KEYCODE && event.keyCode !== 8)) {
                    event.preventDefault();
                    $timeout(function () {
                        removeFocus();
                    }, 0);
                    console.log("blurHandler:::Check Max Character - prevTest = ", previewItem.prevText);
                    event.target.value = previewItem.prevText;
                    if (angular.isDefined(event.target.id)) {
                        if (angular.isDefined(updateItem) && event.target.id === 'list_' + updateItem.id) {
                            updateItem.name = event.target.value;
                            resizeTextArea(updateItem.id);
                        }
                        if (event.target.id === 'listTitle') {
                            $scope.inputData.category = event.target.value;
                        }
                        else if (event.target.id === 'newlistTitleID_createList') {
                            $scope.inputData.createCategory = event.target.value;
                        }
                        else if (event.target.id === 'addItem') {
                            $scope.inputData.name = event.target.value;
                        }
                    }
                    SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_common_max_characters, "");
                }
            }

            //Save contents(Edit Item)
            if (previewItem.value !== event.target.value) {
                if (angular.isDefined(updateItem) && event.target.id === 'list_' + updateItem.id) {
                    if (/*isEmpty(updateItem.imageURL) &&*/ isEmptyString(event.target.value)) {
                        //if all fields are empty, remove item.
                        deleteShoppingListItemCommand(updateItem);
                    }
                    else {
                        //Updated the item of list
                        editShoppingListItemCommand(updateItem);
                    }
                }
            }

            if (event.target.id === 'newlistTitleID_createList') {
                $timeout(function () {
                    console.log("~~~~~~~~~~~blurHandler($timeout)::: View Size = " + document.body.clientHeight);
                    $("body").height(document.body.clientHeight);
                }, 1000);
            }
            removeModifyItem(previewItem);
        }
        // console.log($scope.modifyList);
        console.log("#############################");
    }

    function resizeTextArea(id) {
        $(document).ready(function () {
            try {
                console.log("resizeTextArea::: id = ", id);
                var element = document.getElementById('list_' + id);
                var ele = $('#list_' + id);
                if (angular.isDefined(element) && angular.isDefined(ele)) {
                    console.log('resizeTextArea::: scrollHeight = ', element.scrollHeight, "scrollTop = ", element.scrollTop, "clientHeight = ", element.clientHeight, "offsetHeight = ", element.offsetHeight);
                    console.log('resizeTextArea::: scrollHeight - scrollTop = ', element.scrollHeight - element.scrollTop);
                    var wrap_scrollWidth = element.scrollWidth;
                    ele.addClass('nowrap');
                    var nowrap_clientWidth = element.scrollWidth;
                    ele.removeClass('nowrap');

                    console.log(nowrap_clientWidth, wrap_scrollWidth);
                    if (nowrap_clientWidth <= wrap_scrollWidth) {   //1 line
                        console.log('resizeTextArea::: min-height = ' + ele.css('min-height'));
                        element.style.height = ele.css('min-height');
                        console.log('resizeTextArea::: isMultiLine = ' + false);
                    }
                    else {
                        element.style.height = 'auto';
                        element.style.height = element.scrollHeight + 'px';
                        console.log('resizeTextArea::: isMultiLine = ' + true);
                    }
                }
                else {
                    // console.log('resizeTextArea::: Undefined id = ' + id);
                }
            } catch (err) {
                console.log('resizeTextArea::: id = ' + id, err);
            }
        });
    }

    function keyupHandler(event, max_character, type) {
        console.log("keyupHandler ("+ type +"):::", event.target.value, event.target.value.length, ' /keyCode: ' + event.keyCode);
        if (angular.isUndefined(event))
            return;

        if (event.target.id === 'addItem')
            $scope.inputData.name = event.target.value;
        else if (event.target.id === 'listTitle')
            $scope.inputData.category = event.target.value;
        else if (event.target.id === 'newlistTitleID_createList')
            $scope.inputData.createCategory = event.target.value;
        else if (event.target.id.indexOf('list_') !== -1) {
            resizeTextArea(event.target.id.split('list_')[1]);
        }

        if (event.target.value.length > max_character && (event.keyCode !== ENTER_KEYCODE && event.keyCode !== 8)) {
            removeFocus();
        }

        var previewItem = getModifyItem(event.target.id);
        if (angular.isDefined(previewItem) && event.target.value.length <= max_character && (event.keyCode !== ENTER_KEYCODE && event.keyCode !== 8)) {
            previewItem.prevText = event.target.value;
        }

        if (event.keyCode === ENTER_KEYCODE) {
            event.target.value = event.target.value.replace(/\n/g, '').trim();
            removeFocus();

            if(event.target.id === 'addItem' && !isEmptyString($scope.inputData.name))
                addShoppingListItemCommand();
        }
    }

    function getShoppingListFormat(item) {
        if (angular.isUndefined(item.groupId) || angular.isUndefined(item.id)) {
            console.log('getShoppingListItemPayload::: Undefined group or id');
            return;
        }

        var deals = {
            deals_id: "",
            price: "",
            storeName: "",
            deals_detail: "",
            expiry_date:"",
            api_name:"",
            clip_state:""
        };
        if (angular.isDefined(item.Deals)) {
            deals.deals_id = (angular.isDefined(item.Deals.deals_id))? item.Deals.deals_id : "";
            deals.price = (angular.isDefined(item.Deals.price))? item.Deals.price : "";
            deals.storeName = encodeEscape(item.Deals.storeName);
            deals.deals_detail = encodeEscape(item.Deals.deals_detail);
            deals.expiry_date = (angular.isDefined(item.Deals.expiry_date))? item.Deals.expiry_date : "";
            deals.api_name = (angular.isDefined(item.Deals.api_name))? item.Deals.api_name : "";
            deals.clip_state = (angular.isDefined(item.Deals.clip_state))? item.Deals.clip_state : "";
        }

        return {
            userId: (angular.isDefined($scope.userId))? $scope.userId : "",
            groupId: item.groupId,
            id: item.id,
            category: encodeEscape(item.category),
            isDefault: (angular.isDefined(item.isDefault))? item.isDefault : false,
            category_info: (angular.isDefined(item.category_info))? item.category_info : "",
            name: encodeEscape(item.name),
            imageURL: (angular.isDefined(item.imageURL))? item.imageURL : "",
            itemStatus: (angular.isDefined(item.itemStatus))? item.itemStatus : "1",
            storageType: timeStamp.getDateFormat(new Date(),'yyyy-MM-ddTHH:mm:ss', 'UTC'),
            order: (angular.isDefined(item.order))? item.order : item.id,
            recipeName: (angular.isDefined(item.recipeName))? item.recipeName : "",
            data_type: (angular.isDefined(item.data_type))? item.data_type : "",
            emart_item_id: (angular.isDefined(item.emart_item_id))? item.emart_item_id : "",
            emart_min_qty: (angular.isDefined(item.emart_min_qty))? item.emart_min_qty : "",
            site_no: (angular.isDefined(item.site_no))? item.site_no : "",
            food_position: (angular.isDefined(item.food_position))? item.food_position : $scope.locations[0].id,
            Deals: deals,
            quantity: (angular.isDefined(item.quantity)) ? item.quantity : 1,
            quantityUnit: (angular.isDefined(item.quantityUnit)) ? item.quantityUnit : "",
            isAdded: false
        };
    }

    function addShoppingListTitleCommand(groupId, category, sendPush) {
        if (angular.isUndefined(groupId) || groupId === "")
            return;

        console.log('addShoppingListTitleCommand::: category= ' + category);
        if (angular.isUndefined(category) || category.trim() === "")
            category = decodeHtmlEntity($scope.translation.WEBMOB_fhub2_shopping_list_create_new_title);
        else if (category.trim().length > $scope.MAX_CHARACTER_TITLE)
            category = category.trim().substr(0, $scope.MAX_CHARACTER_TITLE);
        else
            category = category.trim();

        var title_info = {
            groupId: groupId,
            id: groupId,
            category: category,
            order: groupId,
            food_position: ""
        };

        var payload = {
            "ShoppingList": [
                getShoppingListFormat(title_info)
            ],
            sendPush : (angular.isDefined(sendPush) && sendPush !== null)? sendPush : true
        };

        console.log("ShoppingList payload ", payload);
        $scope.isTransparent = true;        //for Transparent dim screen.
        $scope.checkResponse.push(REQUEST.ADD_SHOPPING_LIST);
        SHPService.sendNativeCommand(REQUEST.ADD_SHOPPING_LIST, payload, REQUEST.ADD_SHOPPING_LIST);

        return title_info;
    }

    function addShoppingListItemCommand(selectedItems) {
        console.log("addShoppingListItemCommand:::name = " + $scope.inputData.name);
        removeFocus();
        checkElement($('#addItem')[0], $scope.MAX_CHARACTER_ITEM);
        if (angular.isUndefined(selectedItems) && $scope.inputData.name.trim().length === 0)
            return;
        else if (angular.isUndefined(selectedItems)) {
            selectedItems = [$scope.inputData];
        }

        if (angular.isUndefined($scope.inputData.groupId) || $scope.inputData.groupId === "") {
            $scope.inputData.groupId = timeStamp.getDateFormat(new Date(), 'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");
            addShoppingListTitleCommand($scope.inputData.groupId, $scope.inputData.category, false);
        }

        else if ($scope.inputData.groupId !== "" && angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId])) {
            if (isMaximum_ShoppingList_item($scope.inputData.groupId, 1)) {
                SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_shopping_list_add_max_items.replace("#num#", $scope.MAX_LIST_ITEM.toString()), REQUEST.SHOW_TOAST);
                return;
            }
        }

        var isDefault = false;
        if(angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId]) && angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId].isDefault)) {
            console.log('addShoppingListItemCommand::: isDefault = ' + $scope.Device.ShoppingList[$scope.inputData.groupId].isDefault);
            isDefault = $scope.Device.ShoppingList[$scope.inputData.groupId].isDefault;
        }

        var payload_ShoppingList = {"ShoppingList": []};
        selectedItems.forEach(function (item) {
            //prevented that id is duplicated with groupId.
            var currentLocalDate = new Date();
            currentLocalDate.setTime(currentLocalDate.getTime() + 1);
            var id = timeStamp.getDateFormat(currentLocalDate,'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");

            if (item.name.trim().length > $scope.MAX_CHARACTER_ITEM)
                item.name = item.name.trim().substr(0, $scope.MAX_CHARACTER_ITEM);
            else
                item.name = item.name.trim();

            item.groupId = $scope.inputData.groupId;
            item.id = id;
            item.category = "";
            item.isDefault = isDefault;
            item.order = id;

            var payload = getShoppingListFormat(item);
            payload_ShoppingList.ShoppingList.push(payload);
        });

        // console.log("addShoppingListItemCommand:::" + JSON.stringify(payload));
        $scope.isTransparent = true;        //for Transparent dim screen.
        $scope.checkResponse.push(REQUEST.ADD_SHOPPING_LIST);
        SHPService.sendNativeCommand(REQUEST.ADD_SHOPPING_LIST, payload_ShoppingList, REQUEST.ADD_SHOPPING_LIST);
        SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, decodeHtmlEntity($scope.translation.WEBMOB_fhub2_common_added_to_string.replace("#string1#", $scope.getSubTitle($scope.inputData.category_info))), REQUEST.SHOW_TOAST);


        $scope.inputData.category = "";
        $scope.inputData.name = "";
        $scope.inputData.category_info = "";
        $scope.inputData.food_position = "";
        $scope.inputData.imageURL = "";
    }

    function editShoppingListTitleCommand(list, editCategory) {
        if (angular.isUndefined(list))
            return;

        if (angular.isUndefined(editCategory) || editCategory.trim() === "")
            editCategory = decodeHtmlEntity($scope.translation.WEBMOB_fhub2_shopping_list_create_new_title);
        else if (editCategory.trim().length > $scope.MAX_CHARACTER_TITLE)
            editCategory = editCategory.trim().substr(0, $scope.MAX_CHARACTER_TITLE);
        else
            editCategory = editCategory.trim();

        list.category = editCategory;
        list.food_position = "";
        list.data_type = "";        //If title is modified, have to reset Deals info.
        list.Deals = undefined;     //If title is modified, have to reset Deals info.

        var payload = {
            "ShoppingList": [
                getShoppingListFormat(list)
            ]
        };

        $scope.isTransparent = true;        //for Transparent dim screen.
        $scope.checkResponse.push(REQUEST.EDIT_SHOPPING_LIST);
        SHPService.sendNativeCommand(REQUEST.EDIT_SHOPPING_LIST, payload, REQUEST.EDIT_SHOPPING_LIST);
        closeReNamePopup();
    }

    function editShoppingListItemCommand(item) {
        if (angular.isUndefined(item))
            return;

        console.log("editShoppingListItemCommand::: item.id = " + item.id);
        if (item.name.trim().length > $scope.MAX_CHARACTER_ITEM)
            item.name = item.name.trim().substr(0, $scope.MAX_CHARACTER_ITEM);
        else
            item.name = item.name.trim();

        var payload = {
            ShoppingList: [
                getShoppingListFormat(item)
            ]
        };

        console.log("editShoppingListTitleCommand:::" + JSON.stringify(payload));
        // Request for itemsStatus to be updated on Edit page
        $scope.isTransparent = true;        //for Transparent dim screen.
        $scope.checkResponse.push(REQUEST.EDIT_SHOPPING_LIST);
        SHPService.sendNativeCommand(REQUEST.EDIT_SHOPPING_LIST, payload, REQUEST.EDIT_SHOPPING_LIST);
    }

    function isCheckedItem(item) {
        if (item.itemStatus.toString() === "1")
            return false;
        else if (item.itemStatus.toString() === "2")
            return true;
        else
            return false;
    }

    $scope.toggleTickMark = function (item) {
        removeFocus();
        $timeout(function () {
            updateItemStatusCommand(item);

            if (isCheckedItem(item) && get_auto_sendToViewInside()) {
                var location_id;
                if(angular.isDefined(item.food_position) && item.food_position !== "") {
                    location_id = item.food_position;
                }
                else {
                    location_id = $scope.DefineLocations[0].id;    //STORAGE_FRIDGE
                }
                sendToViewInsideCommand(location_id, [item]);
            }
        },0);
    };

    function updateItemStatusCommand(item) {
        if (angular.isUndefined(item))
            return;

        console.log("updateItemStatusCommand::: itemStatus = " + item.itemStatus);

        item.itemStatus = (isCheckedItem(item)) ? "1" : "2";        //change check status(1: unchecked, 2: checked)
        item.order = timeStamp.getDateFormat(new Date(), 'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");
        var payload = {
            "ShoppingList": [
                getShoppingListFormat(item)
            ]
        };

        // Request for itemsStatus to be updated on Edit page
        $scope.isTransparent = true;        //for Transparent dim screen.
        $scope.checkResponse.push(REQUEST.EDIT_SHOPPING_LIST);
        SHPService.sendNativeCommand(REQUEST.EDIT_SHOPPING_LIST, payload, REQUEST.EDIT_SHOPPING_LIST);
    }

    $scope.changeCategoryCommand = changeCategoryCommand;
    function changeCategoryCommand(category) {
        console.log("changeCategoryCommand::: category = ", category);
        var payload = {"ShoppingList": []};

        var category_id = "";
        if(angular.isDefined(category) && angular.isDefined(category.Category_ID)) {
            console.log('changeCategoryCommand::: category.Category_ID = ' + category.Category_ID);
            category_id = convertToWhisk_Category(category.Category_ID);
        }
        else {
            category_id = default_category_id;
        }

        $scope.selectedItems.forEach(function (item) {
            item.category_info = category_id;

            var moveItem = getShoppingListFormat(item);
            payload["ShoppingList"].push(moveItem);
        });

        $scope.checkResponse.push(REQUEST.EDIT_SHOPPING_LIST);
        SHPService.sendNativeCommand(REQUEST.EDIT_SHOPPING_LIST, payload, "changeCategory");
        debugMessage('closeSelectedMode called changeCategoryCommand');
        closeSelectedMode();
    }

    /** start Delete ShoppingList Command Functions **/
    function deleteShoppingList() {
        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME)
            deleteShoppingListTitleCommand();
        else
            deleteShoppingListItemsCommand();
        debugMessage('closeSelectedMode called deleteShoppingList');
        closeConfirmationPopUp();
        closeSelectedMode();
    }

    function deleteShoppingListTitleCommand() {
        var ShoppingListPage_payload = "/foodmanager/shoppinglist/?id=";
        var ShoppingListItem_payload = "/foodmanager/shoppinglist/?id=";
        var DealsItem_payload = "/foodmanager/deals/?id=";

        var list_ids = "";
        var item_ids = "";
        var deals_ids = "";
        $scope.selectedItems.forEach(function (deleteList) {
            if (angular.isDefined(deleteList.groupId) && deleteList.groupId !== '') {
                list_ids += deleteList.groupId + ",";

                if (angular.isDefined($scope.Device.ShoppingList[deleteList.groupId]) &&
                    angular.isDefined($scope.Device.ShoppingList[deleteList.groupId].items)) {
                    var listData = $scope.Device.ShoppingList[deleteList.groupId];
                    for (var itemIdx = 0; itemIdx < listData.items.length; itemIdx++) {
                        var delete_item = listData.items[itemIdx];
                        if (angular.isDefined(delete_item.id) && delete_item.id !== '')
                            item_ids += delete_item.id + ",";
                        if (isDeals(delete_item) && angular.isDefined(delete_item.Deals.deals_id) && delete_item.Deals.deals_id !== '')
                            deals_ids += delete_item.Deals.deals_id + ",";
                    }
                }
            }
        });

        if (deals_ids !== "") {
            $scope.checkResponse.push(REQUEST.DELETE_WEEKLY_DEALS);
            // console.log("DELETE_WEEKLY_DEALS = " + DealsItem_payload + deals_ids.slice(0, -1));
            SHPService.sendNativeCommand(REQUEST.DELETE_WEEKLY_DEALS, DealsItem_payload + deals_ids.slice(0, -1) + '&sendPush=false', REQUEST.DELETE_WEEKLY_DEALS);
        }

        if (item_ids !== "") {
            $scope.checkResponse.push(REQUEST.DELETE_SHOPPING_LIST);
            // console.log("DELETE_SHOPPING_LIST_ITEM = " + ShoppingListItem_payload + item_ids.slice(0, -1));
            SHPService.sendNativeCommand(REQUEST.DELETE_SHOPPING_LIST, ShoppingListItem_payload + item_ids.slice(0, -1) + '&sendPush=false', REQUEST.DELETE_SHOPPING_LIST);
        }

        if (list_ids !== "") {
            $scope.checkResponse.push(REQUEST.DELETE_SHOPPING_LIST);
            // console.log("DELETE_SHOPPING_LIST_PAGE = " + ShoppingListPage_payload + list_ids.slice(0, -1));
            SHPService.sendNativeCommand(REQUEST.DELETE_SHOPPING_LIST, ShoppingListPage_payload + list_ids.slice(0, -1) + '&sendPush=true', REQUEST.DELETE_SHOPPING_LIST);
        }

        closeConfirmationPopUp();
        goToShopListHome();
    }

    function deleteShoppingListItemCommand(item) {
        if (angular.isUndefined(item))
            return;


        if (isDeals(item) && angular.isDefined(item.Deals.deals_id) && item.Deals.deals_id !== '') {
            var DealsItem_payload = "/foodmanager/deals/?id=" + item.Deals.deals_id;
            $scope.isTransparent = true;        //for Transparent dim screen.
            $scope.checkResponse.push(REQUEST.DELETE_WEEKLY_DEALS);
            console.log("delete weeklyDeals items ", DealsItem_payload);
            SHPService.sendNativeCommand(REQUEST.DELETE_WEEKLY_DEALS, DealsItem_payload + '&sendPush=false', REQUEST.DELETE_WEEKLY_DEALS);
        }

        if (angular.isDefined(item.id) && item.id !== '') {
            var ShoppingListItem_payload = "/foodmanager/shoppinglistitem/?id=" + item.id;

            $scope.isTransparent = true;        //for Transparent dim screen.
            $scope.checkResponse.push(REQUEST.DELETE_SHOPPING_LIST);
            console.log("delete shoppinglist items ", ShoppingListItem_payload);
            SHPService.sendNativeCommand(REQUEST.DELETE_SHOPPING_LIST, ShoppingListItem_payload + '&sendPush=true', REQUEST.DELETE_SHOPPING_LIST);
        }
    }

    function deleteShoppingListItemsCommand() {
        var payload = "/foodmanager/shoppinglistitem/?id=";
        var Deals_payload = "/foodmanager/deals/?id=";
        var deals_ids = "";

        $scope.selectedItems.forEach(function (deleteItem){
            if (angular.isDefined(deleteItem.id) && deleteItem.id !== '')
                payload += deleteItem.id + ",";
            if (isDeals(deleteItem) && angular.isDefined(deleteItem.Deals.deals_id) && deleteItem.Deals.deals_id !== '')
                deals_ids += deleteItem.Deals.deals_id + ",";
        });

        if (deals_ids !== "") {
            $scope.checkResponse.push(REQUEST.DELETE_WEEKLY_DEALS);
            // console.log("DELETE_WEEKLY_DEALS = " + DealsItem_payload + deals_ids.slice(0, -1));
            SHPService.sendNativeCommand(REQUEST.DELETE_WEEKLY_DEALS, Deals_payload + deals_ids.slice(0, -1) + '&sendPush=false', REQUEST.DELETE_WEEKLY_DEALS);
        }

        $scope.checkResponse.push(REQUEST.DELETE_SHOPPING_LIST);
        SHPService.sendNativeCommand(REQUEST.DELETE_SHOPPING_LIST, payload.slice(0,-1) + '&sendPush=true', REQUEST.DELETE_SHOPPING_LIST);
    }
    /** end Delete ShoppingList Command Functions **/

    function isEmart(item) {
        if (angular.isDefined(item.data_type)) {
            if (item.data_type === 'emart')
                return true;
        }
        return false;
    }

    function isWoolworth(item) {
        if (angular.isDefined(item.data_type)) {
            if (item.data_type === 'woolworths')
                return true;
        }
        return false;
    }

    function isDeals(item) {
        if (angular.isDefined(item.data_type)) {
            if (item.data_type === 'deals')
                return true;
        }
        return false;
    }

    $scope.isEmptyString = isEmptyString;
    function isEmptyString(str) {
        if (!angular.isDefined(str) || angular.isUndefined(str))
            return true;
        //debugMessage('isEmptyString:::isEmptyString = ' + str + " / return = " + str.trim() === '');
        // console.log('isEmptyString:::isEmptyString = ' + str + " / result = " + str.trim() === '');
        return str.trim() === '';
    }

    function isEmpty(obj) {
        if (angular.isUndefined(obj))
            return true;
        return Object.keys(obj).length === 0;
    }

    $scope.isScreenScrollable = isScreenScrollable;
    function isScreenScrollable() {
        try {
            if ($scope.loadingBar || $scope.bOptionPopUp ||
                $scope.dialogPopup.show || $scope.confirmationPopUpVisible ||
                $scope.sendToViewInsidePopup || $scope.createNewListPopUp || $scope.reNamePopup || $scope.productDetailPopup) {
                return false;
            }
            else {
                return true;
            }
        } catch(err) {
            debugMessage("[ERR]isScreenScrollable:::", err);
            return true;
        }
    }

    function closeOptionPopup() {
        $scope.bOptionPopUp = false;
    }

    function showOptionPopup() {
        // if ($scope.modifyList.length !== 0) {
        //     $scope.eventQueue.push($scope.events.SHOW_OPTION_POPUP);
            removeFocus();
        //     return;
        // }

        $scope.bOptionPopUp = true;
    }

    $scope.reNamePopup = false;
    $scope.showReNamePopup = showReNamePopup;
    $scope.closeReNamePopup = closeReNamePopup;
    $scope.saveListTitle = saveListTitle;

    function showReNamePopup(groupId) {
        if (isDefinedList(groupId) && $scope.Device.ShoppingList[groupId].isDefault)
            return;
        $scope.reNamePopup = true;
        $scope.inputData.category = $scope.getTitle(groupId);

        $timeout(function () {
            console.log('showReNamePopup:::listTitle-focus, select');
            $("#listTitle").focus();
            document.getElementById('listTitle').setSelectionRange(0, $scope.inputData.category.length);
        }, 0);
    }
    function closeReNamePopup() {
        removeFocus();
        $scope.reNamePopup = false;
    }

    function saveListTitle(groupId, category) {
        if (angular.isUndefined(groupId) || groupId === null || groupId === "") {
            $scope.inputData.groupId = groupId = timeStamp.getDateFormat(new Date(), 'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");
            addShoppingListTitleCommand(groupId, category, true);
        }
        else if (isDefinedList(groupId)) {
            editShoppingListTitleCommand($scope.Device.ShoppingList[groupId], category);
        }
        closeReNamePopup();
    }

    /**
     * @function
     * @private
     * @name diffDays
     * @param
     * @description
     **/
    function diffDays(inputDate, expireDte) {
        if (angular.isUndefined(inputDate) || inputDate === "" ||
            angular.isUndefined(expireDte) || expireDte === "")
            return -999;

        //initial time for compare date.
        var inputDay = angular.copy(timeStamp.convertDate(inputDate));
        var expireDay = angular.copy(timeStamp.convertDate(expireDte));

        inputDay.setHours(0);
        inputDay.setMinutes(0);
        inputDay.setSeconds(0);
        inputDay.setMilliseconds(0);
        expireDay.setHours(0);
        expireDay.setMinutes(0);
        expireDay.setSeconds(0);
        expireDay.setMilliseconds(0);

        var timeDiff = expireDay.getTime() - inputDay.getTime();
        return Math.ceil(timeDiff / (1000 * 3600 * 24));
    }

    function showExpiredIcon(item) {
        if (angular.isDefined(item.Deals) && angular.isDefined(item.Deals.expiry_date) &&
            item.Deals.expiry_date !== null && item.Deals.expiry_date !== "") {
            try {
                //UTC: 2018-01-30, Local: 2018/01/30, 01-30-2018, 01/30/2018
                var expirationDate = item.Deals.expiry_date.split("-").join("/");   //replace all '-' to '/'
                return diffDays(new Date(), new Date(expirationDate)) < 0;
            } catch (err) {
                console.log("showExpiredIcon::: ", item.Deals.expiry_date, err);
                return false;
            }
        }
        return false;
    }
    
    $scope.getSubText = function(item_deals) {
        var output = "#storeName# | #price#, #expiry_date#";
        try {
            if (angular.isDefined(item_deals.storeName) && item_deals.storeName !== null && item_deals.storeName !== "") {
                output = output.replace('#storeName#', item_deals.storeName);
            }
            else {
                output = output.replace('#storeName#', '');
                output = output.replace(' | ', '');
            }

            if (angular.isDefined(item_deals.price) && item_deals.price !== null && item_deals.price !== "") {
                output = output.replace('#price#', item_deals.price);
            }
            else {
                output = output.replace('#price#', '');
                output = output.replace(', ', '');
            }

            if (displayExpirationDate(item_deals.expiry_date) !== "") {
                output = output.replace('#expiry_date#', displayExpirationDate(item_deals.expiry_date));
            }
            else {
                output = output.replace('#expiry_date#', '');
                output = output.replace(', ', '');
            }
        } catch (err) {
            console.log("getSubText:::", err);
            return "";
        }

        return output;
    };
    
    function displayExpirationDate(expirationDate) {
        if (angular.isDefined(expirationDate) && expirationDate !== null && expirationDate !== "") {
            try {
                //UTC: 2018-01-30, Local: 2018/01/30, 01-30-2018, 01/30/2018
                expirationDate = expirationDate.split("-").join("/");   //replace all '-' to '/'
                var date_str = timeStamp.displayDate(new Date(expirationDate), $scope.dateFormat);
                return $scope.translation.WEBMOB_fhub2_shopping_list_use_by.replace("#date#", date_str);
            } catch (err) {
                console.log("displayExpirationDate:::", expirationDate, err);
                return "";
            }
        }
        return "";
    }

    $scope.productDetailPopup = false;
    $scope.productDetail_item = {};
    $scope.showProductDetailPopup = showProductDetailPopup;
    function showProductDetailPopup(item) {
        if ($scope.isSelectedMode)
            return;
        if (angular.isDefined(item)) {
            console.log("showProductDetailPopup", item);

            if (isDeals(item)) {
                $scope.productDetail_item = {
                    data_type: item.data_type,
                    // Deals: item.Deals,
                    name: item.name,
                    isExpired: showExpiredIcon(item),
                    storeName: item.Deals.storeName,
                    benefitGrp1: [],
                    benefitGrp2: [],
                    imageURL_List: [item.imageURL],
                    price: item.Deals.price,
                    expiry_date: displayExpirationDate(item.Deals.expiry_date),
                    detail: item.Deals.deals_detail
                };
            }
            else if (isEmart(item)) {
                var emart_item = $scope.EmartAPIService.getEmartItem(item.emart_item_id);
                var item_price = "";
                var imageURL_List = [item.imageURL];
                var benefitGrp1 = [];
                var benefitGrp2 = [];

                console.log("showProductDetailPopup emart = ", emart_item);

                if (angular.isDefined(emart_item) && emart_item !== null && emart_item !== '') {
                    if (angular.isDefined(emart_item.displayPrc) && emart_item.displayPrc !== null && emart_item.displayPrc !== '')
                        item_price = $scope.translation.WEBMOB_fhub2_shopping_list_product_detail_KRW.replace('#num#', emart_item.displayPrc);

                    if (angular.isDefined(emart_item.itemImgUrlList) && emart_item.itemImgUrlList !== null && emart_item.itemImgUrlList.length > 0) {
                        imageURL_List = emart_item.itemImgUrlList;
                        imageURL_List.forEach(function (url) {
                            imageRequest.nativeRequest(url);
                        });
                    }

                    if (angular.isDefined(emart_item.benefitGrp1) && emart_item.benefitGrp1 !== null && emart_item.benefitGrp1.length > 0) {
                        benefitGrp1 = emart_item.benefitGrp1;
                        benefitGrp1.forEach(function (badge_info) {
                            if (badge_info !== null && angular.isDefined(badge_info.type) && badge_info.type !== null && badge_info.type !== '') {
                                var url = EmartAPIService.getBenefitGrp_img_url('1', badge_info.type);
                                imageRequest.nativeRequest(url);

                                switch (badge_info.type) {
                                    case "A0":      //discount
                                        badge_info.txt = "<span class='type1'>" + badge_info.txt + "</span>" +
                                            "<span class='type2'>%</span>" +
                                            "<span class='type3'>" + $scope.translation.WEBMOB_fhub2_shopping_list_product_detail_benefit_discount + "</span>";
                                        break;
                                    case "B0":      //sale
                                        badge_info.txt = $scope.translation.WEBMOB_fhub2_shopping_list_product_detail_benefit_sale.replace("#num#", badge_info.txt);
                                        break;
                                    case "C0":      //coupon
                                        badge_info.txt = "<span class='type1'>" + badge_info.txt + "</span>" +
                                            "<span class='type2'>%</span>" +
                                            "<span class='type3'>" + $scope.translation.WEBMOB_fhub2_shopping_list_product_detail_benefit_coupon + "</span>";
                                        break;
                                    case "10":      //N+1
                                        break;
                                    case "11":      //1+1
                                        break;
                                    case "60":      //the more the better
                                        break;
                                    case "30":      //freebie
                                        break;
                                    default:
                                        break;
                                }
                            }
                        });
                    }

                    if (angular.isDefined(emart_item.benefitGrp2) && emart_item.benefitGrp2 !== null && emart_item.benefitGrp2.length > 0) {
                        benefitGrp2 = emart_item.benefitGrp2;
                        benefitGrp2.forEach(function (badge_info) {
                            if (badge_info !== null && angular.isDefined(badge_info.type) && badge_info.type !== null && badge_info.type !== '') {
                                var url = EmartAPIService.getBenefitGrp_img_url('2', badge_info.type);
                                imageRequest.nativeRequest(url);
                            }
                        });
                    }
                }

                $scope.productDetail_item = {
                    data_type: item.data_type,
                    name: item.name,
                    isExpired: false,
                    storeName: "",
                    benefitGrp1: benefitGrp1,
                    benefitGrp2: benefitGrp2,
                    imageURL_List: imageURL_List,
                    price: "",              //item_price, -> 20180319 Spec-out
                    expiry_date: "",
                    detail: ""
                };
            }

            $scope.productDetailPopup = true;
        }
    }

    $scope.closeProductDetailPopup = closeProductDetailPopup;
    function closeProductDetailPopup() {
        $scope.productDetailPopup = false;
    }

    $scope.SwipeService = SwipeService;
    $scope.$on('ngRepeatProductImages', function () {
        console.log('ngRepeatProductImages', $scope.productDetail_item);

        $scope.currentSwiperIndex = 0;
        SwipeService.bind('swiper_area');
        SwipeService.slideTo(0, false);
    });

    $scope.currentSwiperIndex = 0;
    $scope.$on('refreshSwiperIndex', function () {
        $timeout(function () {
            $scope.currentSwiperIndex = SwipeService.getActiveIndex();
        }, 0);
    });

    $scope.getSwipeListLength = getSwipeListLength;
    function getSwipeListLength() {
        return $scope.productDetail_item.imageURL_List.length;
    }

    function closeConfirmationPopUp() {
        $scope.confirmationPopUpVisible = false;
    }

    function showConfirmationPopUp(option) {
        switch (option) {
            case $scope.SHOPPINGLIST_OPTIONS_HOME.DELETE_LIST://Delete List
            case $scope.SHOPPINGLIST_OPTIONS.DELETE://Delete Items
                if ($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME) {
                    $scope.confirmationPopUpTitle = "";
                    if ($scope.selectedItems.length === 1)
                        $scope.confirmationPopupText = $scope.translation.WEBMOB_fhub2_common_delete_list_popup_msg;
                    else
                        $scope.confirmationPopupText = $scope.translation.WEBMOB_fhub2_common_delete_lists_popup_msg.replace('#num#', $scope.selectedItems.length.toString());
                }
                else if ($scope.currentScreen === SHOPPINGLIST_SCREEN.DETAIL_SCREEN) {
                    $scope.confirmationPopUpTitle = "";
                    if ($scope.selectedItems.length === 1)
                        $scope.confirmationPopupText = $scope.translation.WEBMOB_fhub2_common_delete_item_popup_msg;
                    else
                        $scope.confirmationPopupText = $scope.translation.WEBMOB_fhub2_common_delete_items_popup_msg.replace('#num#', $scope.selectedItems.length.toString());
                }
                break;
            default:
                //do nothing
                break;
        }
        $scope.confirmationPopUpVisible = true;
    }

    function onCancelConfirmationPopUp() {
        closeConfirmationPopUp();
    }

    function onOkConfirmationPopUp(option) {
        switch (option) {
            case $scope.SHOPPINGLIST_OPTIONS_HOME.DELETE_LIST:
            case $scope.SHOPPINGLIST_OPTIONS.DELETE:
                deleteShoppingList();
                break;
            default:
                //do nothing
                break;
        }
        closeConfirmationPopUp();
    }

    function onCancelConfirmationAddEditPopUp() {
        closeConfirmationPopUp();
    }

    function selectIndexFromOptionMenu(selectOption) {
        switch(selectOption) {
            case $scope.SHOPPINGLIST_OPTIONS.RENAME:
                showReNamePopup($scope.inputData.groupId);
                break;
            case $scope.SHOPPINGLIST_OPTIONS_HOME.DELETE_LIST:
            case $scope.SHOPPINGLIST_OPTIONS.DELETE:
                selectedModeForDelete();
                break;
            case $scope.SHOPPINGLIST_OPTIONS.MOVE_TO_OTHER_LIST:
                selectedModeForMoveToOtherList();
                break;
            case $scope.SHOPPINGLIST_OPTIONS.SEND_TO_GROCERIES:
                selectedModeForSendToGroceries();
                break;
            case $scope.SHOPPINGLIST_OPTIONS.SEND_TO_VIEW_INSIDE:
                selectedModeForSendToViewInside();
                break;
            case $scope.SHOPPINGLIST_OPTIONS.CHANGE_CATEGORY:
                selectedModeForChangeCategory();
                break;
            case $scope.SHOPPINGLIST_OPTIONS.SETTINGS:
                //go to Settings page
                goToSettingsPage();
                break;
            default:
                break;
        }
        clearModifyList();
        closeOptionPopup();
    }

    /* Start SelectedMode functions */
    function longPressHandlerForDelete(item) {
        debugMessage("longPressHandlerForDelete:::"+$scope.currentSelectedMode);
        removeFocus();
        clearModifyList();

        if ($scope.currentSelectedMode === "") {
            $scope.selectedMode_option = true;
            selectedModeForDelete();
            if (angular.isDefined(item))
                setSelectedItems(item);
            else
                console.log('longPressHandlerForDelete::::item is undefined');
        }
    }

    function selectedModeForDelete() {
        debugMessage("selectedModeForDelete:::");
        closeConfirmationPopUp();
        clearSelectedItems();

        $scope.isSelectedMode = true;
        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME)
            $scope.currentSelectedMode = $scope.SHOPPINGLIST_OPTIONS_HOME.DELETE_LIST;
        else
            $scope.currentSelectedMode = $scope.SHOPPINGLIST_OPTIONS.DELETE;

        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.DETAIL_SCREEN)
            resetSelectedMode();
    }

    function selectedModeForMoveToOtherList() {
        debugMessage("selectedModeForMoveToOtherList:::");
        if ($scope.isSelectedMode) {        //if selectedMode is already actived, send requestCommand.
            goToMoveToOtherListPage();
            return;
        }
        $scope.isSelectedMode = true;
        $scope.currentSelectedMode = $scope.SHOPPINGLIST_OPTIONS.MOVE_TO_OTHER_LIST;

        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.DETAIL_SCREEN)
            resetSelectedMode();
    }

    function selectedModeForSendToGroceries() {
        debugMessage("selectedModeForSendToGroceries:::");
        if ($scope.isSelectedMode) {        //if selectedMode is already actived, send requestCommand.
            return;
        }
        $scope.isSelectedMode = true;
        $scope.currentSelectedMode = $scope.SHOPPINGLIST_OPTIONS.SEND_TO_GROCERIES;

        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.DETAIL_SCREEN)
            resetSelectedMode();
    }

    function selectedModeForSendToViewInside() {
        debugMessage("selectedModeForSendToViewInside:::");
        if ($scope.isSelectedMode) {        //if selectedMode is already actived, send requestCommand.
            showSendToViewInsidePopup();
            return;
        }
        $scope.isSelectedMode = true;
        $scope.currentSelectedMode = $scope.SHOPPINGLIST_OPTIONS.SEND_TO_VIEW_INSIDE;

        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.DETAIL_SCREEN)
            resetSelectedMode();
    }

    function selectedModeForChangeCategory() {
        debugMessage("selectedModeForChangeCategory:::");
        if ($scope.isSelectedMode) {        //if selectedMode is already actived, send requestCommand.
            goToChangeCategoryPage();
            return;
        }
        $scope.isSelectedMode = true;
        $scope.currentSelectedMode = $scope.SHOPPINGLIST_OPTIONS.CHANGE_CATEGORY;
    }

    function resetSelectedMode() {
        debugMessage("resetSelectedMode:::curList: " + $scope.inputData.groupId);
        $scope.isSelectedMode = true;
        $scope.sendToViewInsidePopup = false;
        $scope.createNewListPopUp = false;
        closeConfirmationPopUp();
        clearSelectedItems();
        clearEventQueue();
        $scope.inputData.name = "";
    }
    /* End SelectedMode Functions */

    $scope.isMaximum_ShoppingList = isMaximum_ShoppingList;
    $scope.isShoppingListItemEmpty = isShoppingListItemEmpty;
    $scope.isMaximum_ShoppingList_item = isMaximum_ShoppingList_item;
    function isMaximum_ShoppingList() {
        var savedDefaultList = false;
        var max_list_size = $scope.MAX_LIST;
        $.each($scope.Device.ShoppingList, function (groupId, list) {
           if (angular.isDefined(list.isDefault) && list.isDefault === true) {
               savedDefaultList = true;
               return;
           }
        });

        if (savedDefaultList)
            max_list_size++;

        debugMessage('isMaximum_ShoppingList:::max_list_size = ' + max_list_size);
        return (Object.keys($scope.Device.ShoppingList).length >= max_list_size);
    }

    function isShoppingListItemEmpty(id) {
        if (angular.isDefined($scope.Device.ShoppingList[id]) && angular.isDefined($scope.Device.ShoppingList[id].items)) {
            if ($scope.Device.ShoppingList[id].items.length === 0)
                return true;
            else
                return false;
        }
        return true;
    }

    function isMaximum_ShoppingList_item(groupId, addItemCount) {
        if (angular.isDefined($scope.Device.ShoppingList[groupId]) && groupId !== '')
            return (($scope.Device.ShoppingList[groupId].items.length + addItemCount) > $scope.MAX_LIST_ITEM);
        else
            return addItemCount > $scope.MAX_LIST_ITEM;
    }

    $scope.moveShoppingList = moveShoppingList;
    $scope.moveShoppingListFromCreateNewListPopup = moveShoppingListFromCreateNewListPopup;
    $scope.moveShoppingListCommand = moveShoppingListCommand;
    function moveShoppingList(moveListPopupData) {
        debugMessage("moveShoppingList::: "+ moveListPopupData);
        var moveToGroupId = moveListPopupData.groupId;

        if (isMaximum_ShoppingList_item(moveToGroupId, $scope.selectedItems.length)) {
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_shopping_list_send_max_items.replace("#num#", $scope.MAX_LIST_ITEM.toString()), "");
            return;
        }

        moveShoppingListCommand(moveToGroupId);
    }

    function moveShoppingListFromCreateNewListPopup(createCategory) {
        var newGroupId = timeStamp.getDateFormat(new Date(),'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");

        if (isMaximum_ShoppingList()) {
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_shopping_list_send_list_max_lists.replace("#num#", $scope.MAX_LIST.toString()), "");
            return;
        }

        if ($scope.selectedItems.length > $scope.MAX_LIST_ITEM) {
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_shopping_list_send_max_items.replace("#num#", $scope.MAX_LIST_ITEM.toString()), "");
            return;
        }

        var title_info = addShoppingListTitleCommand(newGroupId, createCategory, false);
        moveShoppingListCommand(newGroupId, title_info);
    }

    function moveShoppingListCommand(moveToGroupId, title_info) {
        var payload = {"ShoppingList": []};

        var isDefault = false;
        if(angular.isDefined($scope.Device.ShoppingList[moveToGroupId]) && angular.isDefined($scope.Device.ShoppingList[moveToGroupId].isDefault)) {
            console.log('moveShoppingListCommand::: isDefault = ' + $scope.Device.ShoppingList[moveToGroupId].isDefault);
            isDefault = $scope.Device.ShoppingList[moveToGroupId].isDefault;
        }

        $scope.selectedItems.forEach(function (item) {
            item.groupId = moveToGroupId;
            item.isDefault = isDefault;

            var moveItem = getShoppingListFormat(item);
            payload["ShoppingList"].push(moveItem);
        });

        $scope.checkResponse.push(REQUEST.EDIT_SHOPPING_LIST);
        SHPService.sendNativeCommand(REQUEST.EDIT_SHOPPING_LIST, payload, "moveShoppinglist");
        if(angular.isDefined($scope.Device.ShoppingList[moveToGroupId]) && angular.isDefined($scope.Device.ShoppingList[moveToGroupId].category)) {
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_common_moved_to_string.replace("#string1#", $scope.Device.ShoppingList[moveToGroupId].category), REQUEST.SHOW_TOAST);
        }
        else if (angular.isDefined(title_info) && angular.isDefined(title_info.category) && title_info.category !== "") {
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_common_moved_to_string.replace("#string1#", title_info.category), REQUEST.SHOW_TOAST);
        }
        closeSelectedMode();
    }

    $scope.convertLocationValueToId = convertLocationValueToId;
    $scope.convertLocationIdToValue = convertLocationIdToValue;
    function convertLocationValueToId(value) {
        var output = "";
        $scope.DefineLocations.forEach(function (location) {
            if (value === location.name) {
                output = location.id;
                return;
            }
        });
        return output;
    }

    function convertLocationIdToValue(id) {
        var output = "";
        $scope.DefineLocations.forEach(function (location) {
            if (id === location.id) {
                output = location.name;
                return;
            }
        });
        return output;
    }

    $scope.isMaximumFoodList = isMaximumFoodList;
    function isMaximumFoodList(new_item_size) {
        if(!angular.isDefined($scope.Device.FoodList.Fridge))
            return false;
        return $scope.Device.FoodList.Fridge.length + new_item_size > $scope.MAX_FOOD_ITEM;
    }

    function sendToViewInsideCommand(location_id, items) {
        if (isMaximumFoodList(items.length)) {
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_food_reminder_send_max_items.replace("#num#", $scope.MAX_FOOD_ITEM.toString()), REQUEST.SHOW_TOAST);
            return;
        }

        var payload = {"FoodList": []};
        items.forEach(function(item, index) {
            //create id
            var currentLocalDate = new Date();
            currentLocalDate.setTime(currentLocalDate.getTime() + (index + 1));
            var id = timeStamp.getDateFormat(currentLocalDate,'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");

            if (item.name.trim().length > $scope.MAX_CHARACTER_ITEM && !isEmart(item) && !isWoolworth(item))
                item.name = item.name.trim().substr(0, $scope.MAX_CHARACTER_ITEM);
            else
                item.name = item.name.trim();

            var newItem = {
                userId: $scope.userId,
                id: id,
                category: "",
                Glaze: {
                    shelfID: 0,
                    tagPositionX: 2000,
                    tagPositionY: 2000,
                    depth: timeStamp.getDateFormat(new Date(), 'yyyy-MM-ddTHH:mm:ss', 'UTC')
                },
                is_expiry_tag: false,
                category_info: (angular.isDefined(item.category_info))? item.category_info : "",
                inputDate: timeStamp.getDateFormat(new Date(),'yyyy-MM-ddTHH:mm:ss', 'UTC'),
                entryDate: timeStamp.getDateFormat(new Date(),'yyyy-MM-ddTHH:mm:ss', 'UTC'),
                expirationDate: "",
                name: encodeEscape(item.name),
                storageType: (angular.isDefined(location_id))? location_id : $scope.locations[0].id,
                isReminder: false,
                imageURL: item.imageURL,
                memoId: "",
                data_type: (angular.isDefined(item.data_type) && !isDeals(item))? item.data_type : "",
                emart_item_id: (angular.isDefined(item.emart_item_id))? item.emart_item_id : "",
                emart_min_qty: (angular.isDefined(item.emart_min_qty))? item.emart_min_qty : "",
                site_no: (angular.isDefined(item.site_no))? item.site_no : "",
                recommended : {
                    location: false,
                    expiration: false
                },
                quantity: (angular.isDefined(item.quantity)) ? item.quantity : 1,
                quantityUnit: (angular.isDefined(item.quantityUnit)) ? item.quantityUnit : "",
                isNewlyAdded: false
            };
            payload["FoodList"].push(newItem);
        });
        $scope.checkResponse.push(REQUEST.ADD_FOOD_LIST);
        SHPService.sendNativeCommand(REQUEST.ADD_FOOD_LIST, payload, REQUEST.ADD_FOOD_LIST);
        closeSelectedMode();
    }

    function isFocused(item) {
        // console.log('$("#list_'+item.id+'").is(":focus") : ' + $('#list_'+item.id).is(':focus'));
        return $('#list_'+item.id).is(':focus');
    }

    $scope.removeItemImage = removeItemImage;
    function removeItemImage(item) {
        removeFocus();
        console.log("removeItemImage::: id = " + item.id);
        if (angular.isDefined(imageCache.get(item.imageURL)))
            imageCache.remove(item.imageURL);
        item.imageURL = "";

        if (isEmpty(item.imageURL) && isEmptyString(item.name)) {
            //if all fields are empty, remove item.
            deleteShoppingListItemCommand(item);
        }
        else {
            editShoppingListItemCommand(item);
        }
    }

    function isShoplistEmpty(index){
        var returnVal = false;
        if (index<2 && isEmpty($scope.Device['ShoppingList'])){
            returnVal = true;
        }
        return returnVal;
    }

    function encodeEscape(str) {
        if (angular.isDefined(str) && str !== "") {
            str = str.replace(/\n/g, "")
                .replace(/\r/g, "")
                .replace(/\t/g, "")
                .replace(/\b/g, "")
                .replace(/\f/g, "");
            return encodeURIComponent(str);
        }
        return "";
    }

    function decodeHtmlEntity(html) {
        var txt = document.createElement("textarea");
        txt.innerHTML = html;
        return txt.value.trim();
    }

    function decodeUnescape(str) {
        if (angular.isDefined(str) && str.length > 0 && str.trim() !== "") {
            try {
                str = decodeURIComponent(str);
                return decodeHtmlEntity(str);
            }
            catch(err) {
                console.log("In decodeUnescape Error::: str = " + str);
                console.log("err = " + JSON.stringify(err));
                return decodeHtmlEntity(str);
            }
        }
        return "";
    }

    /*
     CheckBox Function for Delete
     */
    $scope.isSelectedMode = false;
    $scope.selectedItems = [];

    function closeSelectedMode() {
        $scope.sendToViewInsidePopup = false;
        $scope.createNewListPopUp = false;

        $scope.isSelectedMode = false;
        $scope.currentSelectedMode = "";
        $scope.selectedMode_option = false;
        clearSelectedItems();
        removeFocus();

        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.MOVE_TO_OTHER_LIST_SCREEN ||
            $scope.currentScreen === SHOPPINGLIST_SCREEN.CHANGE_CATEGORY_SCREEN ||
            $scope.currentScreen === SHOPPINGLIST_SCREEN.FREQUENT_ITEM_SCREEN)
            showDetailScreen($scope.inputData.groupId);
    }

    function setSelectedItems(item) {
        debugMessage("setSelectedItems:::"+item);
        if (angular.isDefined(item) && !isChecked(item))
            $scope.selectedItems.push(item);
    }

    function deleteSelectedItems(item) {
        debugMessage("deleteSelectedItems:::");
        $scope.selectedItems.forEach(function (selectedItem, index) {
            if (angular.isDefined(selectedItem) && angular.isDefined(item)) {
                if ($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME &&
                    angular.isDefined(selectedItem.groupId) && angular.isDefined(item.groupId) &&
                    selectedItem.groupId === item.groupId) {
                    //selectMode of shoppingList
                    $scope.selectedItems.splice(index, 1);
                    // console.log("unChecking");
                }
                else if ($scope.currentScreen === SHOPPINGLIST_SCREEN.FIND_DEALS_SCREEN &&
                    angular.isDefined(selectedItem.deals_id) && angular.isDefined(item.deals_id) &&
                    selectedItem.deals_id === item.deals_id) {
                    $scope.selectedItems.splice(index, 1);
                }
                else if ($scope.currentScreen !== SHOPPINGLIST_SCREEN.HOME &&
                    angular.isDefined(selectedItem.id) && angular.isDefined(item.id) &&
                    selectedItem.id === item.id) {
                    //selectMode of items
                    $scope.selectedItems.splice(index, 1);
                    // console.log("unChecking");
                }
            }
        });
    }

    function clearSelectedItems() {
        debugMessage("clearSelectedItems:::");
        $scope.selectedItems = [];
    }

    function isCheckedItems() {
        // debugMessage("isCheckedItems:::");
        return ($scope.selectedItems.length > 0);
    }

    function toggleCheckList(item) {
        debugMessage("toggleCheckList:::");
        if (!isChecked(item))
            setSelectedItems(item);
        else
            deleteSelectedItems(item);
        isAllCheckBoxSelected();
    }

    function isChecked(item) {
        // debugMessage("isChecked:::" );
        for (var i=0; i<$scope.selectedItems.length; i++) {
            var selectedItem = $scope.selectedItems[i];
            if (angular.isDefined(selectedItem) && angular.isDefined(item)) {
                if ($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME &&
                    angular.isDefined(selectedItem.groupId) && angular.isDefined(item.groupId) &&
                    selectedItem.groupId === item.groupId) {
                    //selectMode of shoppingList
                    // debugMessage("isChecked:::" + selectedItem[0].groupId + " === " + item[0].groupId + ", "+(selectedItem[0].groupId === item[0].groupId));
                    return true;
                }
                else if ($scope.currentScreen === SHOPPINGLIST_SCREEN.FIND_DEALS_SCREEN &&
                    angular.isDefined(selectedItem.deals_id) && angular.isDefined(item.deals_id) &&
                    selectedItem.deals_id === item.deals_id) {
                    //selectMode of items
                    // debugMessage("isChecked:::" + selectedItem.id + " === " + item.id + ", "+(selectedItem.id === item.id));
                    return true;
                }
                else if ($scope.currentScreen !== SHOPPINGLIST_SCREEN.HOME &&
                    angular.isDefined(selectedItem.id) && angular.isDefined(item.id) &&
                    selectedItem.id === item.id) {
                    //selectMode of items
                    // debugMessage("isChecked:::" + selectedItem.id + " === " + item.id + ", "+(selectedItem.id === item.id));
                    return true;
                }
            }
        }

        return false;
    }

    $scope.checkBox = {isAll : false};
    function toggleSelectAllListCheckBox() {
        debugMessage("toggleSelectAllListCheckBox:::");
        if ($scope.checkBox.isAll)
            clearSelectedItems();
        else {
            if($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME) {
                $.each($scope.Device.ShoppingList, function (groupId, list) {
                    setSelectedItems(list);
                });
            }
            else if ($scope.currentScreen !== SHOPPINGLIST_SCREEN.HOME) {
                $scope.Device.ShoppingList[$scope.inputData.groupId].items.forEach(function (item) {
                    setSelectedItems(item);
                });
            }
        }
        isAllCheckBoxSelected();
    }

    function isAllCheckBoxSelected() {
        if (!$scope.isSelectedMode)
            return false;
        // debugMessage("isAllCheckBoxSelected:::");
        if ($scope.currentScreen === SHOPPINGLIST_SCREEN.HOME && $scope.selectedItems.length === Object.keys($scope.Device.ShoppingList).length) {
            // debugMessage("checkBox.isAll = " + true + " / " + $scope.selectedItems.length + " / " + Object.keys($scope.Device.ShoppingList).length);
            $scope.checkBox.isAll = true;
            return true;
        }
        else if ($scope.currentScreen !== SHOPPINGLIST_SCREEN.HOME &&
                angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId]) && angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId].items) &&
                $scope.selectedItems.length === $scope.Device.ShoppingList[$scope.inputData.groupId].items.length) {
            // debugMessage("checkBox.isAll = " + true + " / " + $scope.selectedItems.length + " / " + $scope.Device.ShoppingList[$scope.inputData.groupId].length);
            $scope.checkBox.isAll = true;
            return true;
        }
        else {
            // debugMessage("isAllCheckBoxSelected:::checkBox.isAll = " + false + " " + $scope.selectedItems.length);
            $scope.checkBox.isAll = false;
            return false;
        }
    }

    function getImage (key) {
        if (angular.isUndefined(key) || key === "")
            return "";
        if ($scope.isStatic) {
            return './REF_ViewInside/assets/img/food list category_m/164x164/food_list_ic_fridge_ketchup_164.png';
        }
        if (angular.isDefined(imageCache) && angular.isDefined(imageCache.get(key))) {
            return imageCache.get(key);
        }
        return "";
    }

    function imageURL_Request (item) {
        imageRequest.nativeRequest(item.imageURL);
    }

    function request_imageURL_List() {
        var url = $scope.imageURL_List.pop();
        var url2 = $scope.imageURL_List.pop();
        console.log('request_imageURL_List::: imageURL_List = ', $scope.imageURL_List, url);
        if (angular.isDefined(url) && url !== null && url !== '')
            imageRequest.nativeRequest(url);
        if (angular.isDefined(url2) && url2 !== null && url2 !== '')
            imageRequest.nativeRequest(url2);

        if (angular.isDefined($scope.imageURL_List) && $scope.imageURL_List !== null &&
            $scope.imageURL_List.length > 1 && $scope.imageURL_List.length % 2 !== 0) {
            var url3 = $scope.imageURL_List.pop();
            if (angular.isDefined(url3) && url3 !== null && url3 !== '')
                imageRequest.nativeRequest(url3);
        }
    }

    /** Start AutoComplete func to Search for Food Data **/
    $scope.queryItems = [];
    $scope.requestQuery = requestQuery;
    function requestQuery(str) {
        if (!angular.isDefined(str) || str.length < 1) {
            return;
        }
        else if ($scope.isStatic || $scope.isLocal) {
            $timeout(function () {
                var response = staticData.responseAutoComplete(str);
                responseAutoCompleteFromFoodDB(response["data"]);
            }, 0);  //test for delay
        }
        else {
            var payload = {
                search : str
            };
            SHPService.sendNativeCommand(REQUEST.SEARCH_FOR_FOOD, payload, REQUEST.SEARCH_FOR_FOOD + "_QUERY_" + str, false);
        }
    }

    $scope.responseAutoCompleteFromFoodDB = responseAutoCompleteFromFoodDB;
    function responseAutoCompleteFromFoodDB(data) {
        console.log("responseAutoCompleteFromFoodDB:::", data);
        if (angular.isDefined(data) && angular.isDefined(data["SearchList"]) && data["SearchList"].length > 0) {
            return data["SearchList"];
        }
        else {
            return [];
        }
    }

    $scope.asyncQuery = null;
    $scope.querySearch = function (query) {
        if (!angular.isDefined(query) || query.length < 1) {
            return [];
        }

        requestQuery(query);
        if (angular.isUndefined($scope.asyncQuery) || $scope.asyncQuery === null) {
            $scope.asyncQuery = $q.defer();
        }

        return $scope.asyncQuery.promise.then(
            function successCallback(response) {
                console.log("successCallback = ", response);
                $timeout(function () {
                    $(".md-scroll-mask").bind({
                        click: function () {
                            console.log("Clicked .md-scroll-mask");
                            removeFocus();
                            $(".md-scroll-mask").css({'display': 'none'});
                            $("md-virtual-repeat-container").css({'display': 'none'});
                        }
                    });

                    //RF00039359: moved the scroll position to top
                    var scroll_element = $('.md-virtual-repeat-scroller');
                    if (angular.isDefined(scroll_element) && scroll_element !== null && scroll_element.length > 0) {
                        scroll_element[0].scrollTop = 0;
                    }
                }, 0);

                $scope.asyncQuery = null;
                return response;
            },
            function errorCallback(response) {
                console.log("errorCallback = ", response);
                return [];
            },
            function notifyCallback(response) {
                console.log('notifyCallback = ', response);
                try {
                    var splitArr = response['requestToken'].split(REQUEST.SEARCH_FOR_FOOD + "_QUERY_");
                    var query = splitArr[splitArr.length - 1];

                    if (angular.isDefined(query) && query !== null && query === $scope.inputData.name) {
                        $scope.queryItems = $scope.responseAutoCompleteFromFoodDB(response["data"]);
                        console.log('notifyCallback - resolve = ', $scope.queryItems);
                        $scope.asyncQuery.resolve($scope.queryItems);
                    }
                } catch (err) {
                    console.log("asyncQuery - notifyCallback error = ", err);
                }
            }
        );
    };

    $scope.searchTextChanged = function (str) {
        console.log('searchTextChanged:::' + str);
        if (str !== "" && angular.isDefined($scope.queryItems) && $scope.queryItems.length > 0) {
            var index = $scope.queryItems.map(function (food_item) {
                return angular.isDefined(food_item.displayName) ? food_item.displayName.toLocaleLowerCase() : "";
            }).indexOf(str.toLocaleLowerCase());
            if (index !== -1) {
                updateFoodLifeByFoodDB($scope.queryItems[index]);
            }
        }
    };

    $scope.searchTextSelected = function (selectedData) {
        console.log('searchTextSelected:::', selectedData);
        if (angular.isDefined(selectedData)) {
            console.log('searchTextSelected::: selectedData=' + JSON.stringify(selectedData));
            updateFoodLifeByFoodDB(selectedData);
            addShoppingListItemCommand();
        }
    };

    $scope.updateFoodLifeByFoodDB = updateFoodLifeByFoodDB;
    function updateFoodLifeByFoodDB(selectedData) {
        console.log('updateFoodLifeByFoodDB:::', selectedData);
        if (angular.isDefined(selectedData)) {
            console.log('updateFoodLifeByFoodDB::: selectedData=' + JSON.stringify(selectedData));
            $scope.inputData.name = selectedData.displayName;
            try {
                $scope.inputData.imageURL = selectedData.imageUrl;
                imageURL_Request(selectedData.imageUrl);
            } catch (err) {
                console.log('[Error]updateFoodLifeByFoodDB:::' + err);
                $scope.inputData.imageURL = '';
            }

            var metadata = selectedData['metadata'];
            if (angular.isDefined(metadata)) {
                $scope.inputData.category_info = metadata.category;
                if (angular.isDefined(selectedData['metadata']) &&
                    angular.isDefined(selectedData['metadata']['storing'])) {
                    var storing = selectedData['metadata']['storing'];

                    if (angular.isDefined(storing['defaultLocation']) && storing['defaultLocation'] !== null && storing['defaultLocation'] !== "") {
                        var index = $scope.DefineLocations.map(function (location) {return location.whiskType;}).indexOf(storing['defaultLocation'].toLocaleLowerCase());
                        if (index !== -1 && angular.isDefined(storing[$scope.DefineLocations[index].whiskType])) { //recommended priority 1
                            $scope.inputData.food_position = $scope.DefineLocations[index].id;
                        }
                        else {
                            $scope.inputData.food_position = $scope.DefineLocations[0].id;
                        }
                    }
                }

                if ($scope.inputData.food_position === '')
                    $scope.inputData.food_position = $scope.DefineLocations[0].id;
            }
        }
    }
    /** End AutoComplete func to Search for Food Data **/


    /** Start Find Deals functions **/
    function showNoStorePopup() {
        $scope.noStorePopup = true;
    }

    function closeNoStorePopup() {
        $scope.noStorePopup = false;
    }

    function goToStoreSettings() {
        SHPService.sendNativeCommand(REQUEST.GOTO_STORE_SETTINGS, "", REQUEST.GOTO_STORE_SETTINGS, false);
        closeNoStorePopup();
    }

    function set_storeFilter(store_id, index) {
        if (angular.isDefined(store_id) && store_id !== null && store_id !== "") {
            setLocalStorageData('store_id', store_id);
            requestFindDealsCommand(store_id);

            if (angular.isDefined(index) && index !== null && index >= 0) {
                //re-order store list
                console.log($scope.FindDealsData.StoreList);
                var store = angular.copy($scope.FindDealsData.StoreList[index]);
                var store_array = angular.copy($scope.FindDealsData.StoreList);
                store_array.splice(index, 1);
                store_array.splice(0, 0, store);
                console.log(store_array);
                $scope.FindDealsData.StoreList = angular.copy(store_array);
            }

            $scope.isExpandStoreList = false;
        }
    }


    function get_storeFilter() {
        var store_id = getLocalStorageData('store_id');
        if (angular.isDefined(store_id) && store_id !== null && store_id !== "") {
            return store_id;
        }
        else {  //If store is not saved in local storage, set first store.
            return $scope.FindDealsData.StoreList[0].id;
        }
    }

    $scope.disableFindDealsBtn = function () {
        if (angular.isDefined($scope.inputData.groupId) && $scope.inputData.groupId !== "" && angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId])) {
            var filtered_deals_items = $filter('filter')($scope.Device.ShoppingList[$scope.inputData.groupId].items, {'data_type': 'deals'});
            return isShoppingListItemEmpty($scope.inputData.groupId) || $scope.Device.ShoppingList[$scope.inputData.groupId].items.length === filtered_deals_items.length;
        }
        return true;
    };

    $scope.getStoreListCommand = getStoreListCommand;
    function getStoreListCommand() {
        $scope.checkResponse.push(REQUEST.GET_STORE_LIST);

        if ($scope.isStatic)
            requestResponseHandler(staticData.responseGetStoreList());
        else
            SHPService.sendNativeCommand(REQUEST.GET_STORE_LIST, "", REQUEST.GET_STORE_LIST);
    }

    function requestFindDealsCommand(store_id) {
        if (angular.isDefined(store_id) &&
            angular.isDefined($scope.inputData.groupId) && $scope.inputData.groupId !== "" &&
            angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId]) &&
            angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId].items)) {
            var payload = {
                "store_id": store_id,
                "search_terms": []
            };

            var orderBy_items = $filter('orderBy')($scope.Device.ShoppingList[$scope.inputData.groupId].items, orderByShoppingItem());
            orderBy_items.forEach(function (item) {
                if (!isDeals(item) && item.name !== "" && payload.search_terms.indexOf(item.name) === -1) {
                    payload.search_terms.push(item.name);
                }
            });

            $scope.checkResponse.push(REQUEST.FIND_DEALS);
            $scope.FindDealsData.search_terms = payload.search_terms;
            if ($scope.isStatic)
                requestResponseHandler(staticData.responseFindDeals(payload));
            else
                SHPService.sendNativeCommand(REQUEST.FIND_DEALS, payload, REQUEST.FIND_DEALS);
        }
    }

    function parseStoreListData(data) {
        if (angular.isUndefined(data) && angular.isUndefined(data["StoreList"]))
            return;

        if (angular.isUndefined(data["StoreList"].length) || data["StoreList"].length === 0) {
            showNoStorePopup();
        }
        else {
            $scope.FindDealsData.StoreList = [];
            data["StoreList"].forEach(function (store) {
                if (angular.isUndefined(store.id) || angular.isUndefined(store.name) || store.name === "")
                    return;
                var store_info = {
                    id: store.id.toString(),
                    name: decodeHtmlEntity(store.name)
                };
                $scope.FindDealsData.StoreList.push(store_info);
            });

            goToFindDealsPage();

            var selected_store = get_storeFilter();
            var index = $scope.FindDealsData.StoreList.map(function (store) {
                return store.id;
            }).indexOf(selected_store);
            if (index === -1) {
                set_storeFilter($scope.FindDealsData.StoreList[0].id, 0);
            }
            else {
                set_storeFilter(selected_store, index);
            }

        }
    }

    function parseFindDealsData(data) {
        if (angular.isUndefined(data) && angular.isUndefined(data["DealsList"]))
            return;

        $scope.FindDealsData.DealsList = [];
        data["DealsList"].forEach(function (deals_item) {
            var index = $scope.FindDealsData.DealsList.map(function (item) {return item.deals_id;}).indexOf(deals_item.deals_id);
            if (index === -1) {
                deals_item.name = decodeHtmlEntity(deals_item.name);
                deals_item.storeName = decodeHtmlEntity(deals_item.storeName);
                deals_item.deals_detail = decodeHtmlEntity(deals_item.deals_detail);
                if (angular.isDefined(deals_item.imageURL) && deals_item.imageURL !== "")
                    imageURL_Request(deals_item);
                $scope.FindDealsData.DealsList.push(deals_item);
            }
        });
    }

    function toggleExpandStoreList() {
        $scope.isExpandStoreList = !$scope.isExpandStoreList;
        $scope.$emit('resize_scroll_height');
    }

    function isOutOfFirstLine(element_id) {
        var baseFontSize = parseFloat(document.getElementById("htmlTag").style.fontSize.replace('px', ''));
        var max_width = (1100 / 80) * baseFontSize;     //1172  //1376  //1440
        var element = $('#'+element_id);
        var element_width = element.width();
        var element_offset = element.offset();

        var first_element_offset = $('#'+$scope.FindDealsData.StoreList[0].id).offset();
        if (angular.isDefined(first_element_offset) && angular.isDefined(first_element_offset.top)) {
            return (first_element_offset.top !== element_offset.top || element_offset.left + element_width > max_width);
        }

        return true;
    }

    $scope.$on('resize_scroll_height', function () {
        console.log('resize_scroll_height');
        $timeout(function () {
            $scope.findDealsScrollAreaHeight();
        }, 0);
    });

    $scope.isDisplayedLastStore = function () {
        var first_element_offset = $('#'+$scope.FindDealsData.StoreList[0].id).offset();
        var last_element_offset = $('#'+$scope.FindDealsData.StoreList[$scope.FindDealsData.StoreList.length - 1].id).offset();
        return (angular.isDefined(first_element_offset) && angular.isDefined(last_element_offset) &&
            first_element_offset.top === last_element_offset.top);
    };

    $scope.findDealsScrollAreaHeight = function () {
        // var store_view_container_height = $('.store_view_container').height();
        var store_view_container_height = document.getElementsByClassName('store_view_container')[0].clientHeight;
        console.log('findDealsScrollAreaHeight = ', store_view_container_height);
        if (angular.isUndefined(store_view_container_height))
            return;
        return {
            height: 'calc(100% - ' + store_view_container_height + 'px)'
        };
    };

    function addFindDealsCommand() {
        if (angular.isUndefined($scope.inputData.groupId) || $scope.inputData.groupId === '')
            return;

        if (isMaximum_ShoppingList_item($scope.inputData.groupId, $scope.selectedItems.length)) {
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_shopping_list_send_max_items.replace("#num#", $scope.MAX_LIST_ITEM.toString()), "");
            return;
        }

        var payload_ShopingList = {
            "ShoppingList": [],
            "sendPush": true
        };
        var payload_WeeklyDeals = {
            "WeeklyDeals": [],
            "sendPush": false
        };

        $scope.selectedItems.forEach(function (selected_item, index) {
            console.log("addFindDealsCommand:::", selected_item);
            //check valid deals_id
            if (angular.isUndefined(selected_item.deals_id) || selected_item.deals_id === null || selected_item.deals_id === "") {
                return;
            }

            var groupId = $scope.inputData.groupId;
            //create id
            var currentLocalDate = new Date();
            currentLocalDate.setTime(currentLocalDate.getTime() + (index + 1));
            var id = timeStamp.getDateFormat(currentLocalDate, 'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");

            var isDefault = false;
            if(angular.isDefined($scope.Device.ShoppingList[groupId]) && angular.isDefined($scope.Device.ShoppingList[groupId].isDefault)) {
                isDefault = $scope.Device.ShoppingList[groupId].isDefault;
            }

            var shopping_item_info = {
                groupId: groupId,
                id: id,
                isDefault: isDefault,
                category_info: selected_item.category_info,
                name: selected_item.name.trim(),
                imageURL: selected_item.imageURL,
                data_type: "deals",
                Deals: {
                    deals_id: selected_item.deals_id,
                    price: selected_item.price,
                    storeName: selected_item.storeName,
                    deals_detail: selected_item.deals_detail,
                    expiry_date: selected_item.expiry_date,
                    api_name: selected_item.api_name,
                    clip_state: "clip"
                }
            };
            payload_ShopingList.ShoppingList.push(getShoppingListFormat(shopping_item_info));

            var deals_item_info = {
                deals_id: selected_item.deals_id,
                shoppinglist_id: id
            };
            payload_WeeklyDeals.WeeklyDeals.push(deals_item_info);
        });


        if (payload_WeeklyDeals.WeeklyDeals.length > 0)
            SHPService.sendNativeCommand(REQUEST.ADD_WEEKLY_DEALS, payload_WeeklyDeals, REQUEST.ADD_WEEKLY_DEALS);
        if (payload_ShopingList.ShoppingList.length > 0) {
            $scope.checkResponse.push(REQUEST.ADD_SHOPPING_LIST);
            SHPService.sendNativeCommand(REQUEST.ADD_SHOPPING_LIST, payload_ShopingList, REQUEST.ADD_SHOPPING_LIST);
        }

        onBackPressed();
    }
    /** End Find Deals functions **/
});

app.directive('endRepeatItems', ['$timeout', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit('ngRepeatFinishedForItems');
                });
            }
        }
    }
}]);

app.directive('endRepeatProductImages', ['$timeout', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit('ngRepeatProductImages');
                });
            }
        }
    }
}]);