/**
 * Created by jji.yeon on 2017-11-03.
 */
app.service('staticData', [function () {
    var scope = angular.element(document.getElementById("bodyTag")).scope();
    var foodCategoryData = [
        {"Category_ID":"Fruits_Vegetables",         "Order":1,"Icon":"produce.png","displayName":"Fruits and Vegetables"},
        {"Category_ID":"Meats_Seafood",             "Order":2,"Icon":"meat.png","displayName":"Meats and Seafood"},
        {"Category_ID":"Bread_Bakery",              "Order":3,"Icon":"bread.png","displayName":"Bread and Bakery"},
        {"Category_ID":"Dairy_Eggs_Cheese",         "Order":4,"Icon":"dairy.png","displayName":"Dairy, Eggs and Cheese"},
        {"Category_ID":"Condiments_Sauces",         "Order":5,"Icon":"ketchup.png","displayName":"Condiments and Sauces"},
        {"Category_ID":"Frozen",                    "Order":6,"Icon":"frozen.png","displayName":"Frozen"},
        {"Category_ID":"Seasoning_Spices_Baking",   "Order":7,"Icon":"spices.png","displayName":"Seasoning, Spices and Baking"},
        {"Category_ID":"Breakfast_Cereal",          "Order":8,"Icon":"cereal.png","displayName":"Breakfast and Cereal"},
        {"Category_ID":"Cookies_Snacks_Candy",      "Order":9,"Icon":"snacks.png","displayName":"Cookies, Snacks and Candy"},
        {"Category_ID":"Beverages",                 "Order":10,"Icon":"drinks.png","displayName":"Beverages"},
        {"Category_ID":"Canned_DryGoods",           "Order":11,"Icon":"cans.png","displayName":"Canned and Dry Goods"},
        {"Category_ID":"PetCare",                   "Order":12,"Icon":"pets.png","displayName":"Pet Care"},
        {"Category_ID":"Household",                 "Order":13,"Icon":"household.png","displayName":"Household"},
        {"Category_ID":"PersonalCare",              "Order":14,"Icon":"personal.png","displayName":"Personal Care"},
        {"Category_ID":"BabyCare",                  "Order":15,"Icon":"baby.png","displayName":"Baby Care"},
        {"Category_ID":"Other",                     "Order":16,"Icon":"other.png","displayName":"Other"}
    ];

    this.parseStaticData_FHub3 = parseStaticData_FHub3;
    this.parseStaticData_FHub2 = parseStaticData_FHub2;
    this.responseAutoComplete = responseAutoComplete;
    this.responseGetStoreList = responseGetStoreList;
    this.responseFindDeals = responseFindDeals;

    function responseAutoComplete(str) {
        return {
            "type":"requestResponse",
            "status":200,
            "requestToken": "searchForFood",
            "data":{
                "SearchList": [
                    {
                        "name": str,
                        "displayName": str,
                        "popularity":100,
                        "imageUrl":"https://lh3.googleusercontent.com/s5CjFLsXW4FLV3p315nfBwc-0AOI4lMA399PP-qi70jGy8rfJb5UgqtCJgLdWyBpjj4PGvN7QOhJPZ_8-xZbLUgkWKY",
                        "metadata":{
                            "category":"FRUITS AND VEGETABLES",
                            "storing":{
                                "pantry":{
                                    "metric":"Days",
                                    "min":3,
                                    "max":4
                                },
                                "fridge":{
                                    "metric":"Days",
                                    "min":3,
                                    "max":4
                                },
                                "freezer":{
                                    "metric":"NotRecommended"
                                }
                            }
                        }
                    }
                ]
            }
        };
    }

    function responseGetStoreList() {
        return {
            "type": "requestResponse",
            "status": 200,
            "requestToken": "getStoreList",
            "data": {
                "StoreList": [
                    {"id": "123123123", "name": "Safeway"},
                    {"id": "123123124", "name": "Target"},
                    {"id": "123123125", "name": "wholeFoods"},
                    {"id": "123123126", "name": "Safeway1"},
                    {"id": "123123127", "name": "Target2"},
                    {"id": "123123128", "name": "wholeFoods3"}
                ]
            }
        };
    }

    function responseFindDeals(payload) {
        var search_terms = (payload.search_terms.length > 0)? payload.search_terms[0] : "";
        return {
            "type": "requestResponse",
            "status": 200,
            "requestToken": "findDeals",
            "data": {
                "DealsList": [
                    {"search_terms":search_terms, "deals_id":"1010101010", "imageURL":"images/reminder/main_rf_img_02.png", "name":"Beer", "category_Info":"Fruits_Vegetables", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-08-29T05:50:31", "api_name": "allRecipeApi", "clip_state": "clip"},
                    {"search_terms":search_terms, "deals_id":"1010101011", "imageURL":"images/reminder/main_rf_img_02.png", "name":"Beer WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-08-29T05:50:31", "api_name": "allRecipeApi", "clip_state": "clip"},
                    {"search_terms":search_terms, "deals_id":"1010101012", "imageURL":"images/reminder/main_rf_img_02.png", "name":"Beer WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-08-29T05:50:31", "api_name": "allRecipeApi", "clip_state": "clip"},
                    {"search_terms":search_terms, "deals_id":"1010101013", "imageURL":"images/reminder/main_rf_img_02.png", "name":"Beer WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-08-29T05:50:31", "api_name": "allRecipeApi", "clip_state": "clip"}
                ]
            }
        };
    }

    function parseStaticData_FHub3() {
        console.log("parseStaticData_FHub3");
        scope.isStatic = true;

        var lcdSpec = {
            "applications": {
                "calendar": {
                    "installed": true,
                    "supportedCalendars":["GoogleCalendar","OutlookCalendar","OpenCalendar"]
                },
                "todo": {
                    "installed": true,
                    "maxLists": 50,
                    "maxItems": 50,
                    "maxChar_list": 100,
                    "maxChar_item": 160
                },
                "memo": {
                    "installed": true,
                    "maxItems": 100,
                    "recordable": true
                },
                "whiteboard": {
                    "installed": true,
                    "maxItems": 80,
                    "recordable": true
                },
                "photo": {
                    "installed": true
                },
                "viewinside": {
                    "installed": true,
                    "foodTag": true,
                    "maxItems": 150,
                    "maxFoodTags": 20,
                    "maxMemoTags": 10,
                    "maxChar": 100
                },
                "shoppinglist": {
                    "installed": true,
                    "maxLists": 24,
                    "maxItems": 50,
                    "maxChar_list": 100,
                    "maxChar_item": 100
                },
                "deals": {
                    "installed": true
                }
            }
        };
        scope.parseLcdSpec(lcdSpec["applications"]);

        var glazeInfo = {
            GlazeInfo: {
                // "GlazeURL": [DEFAULT_GLAZE_IMAGE[0], DEFAULT_GLAZE_IMAGE[1], DEFAULT_GLAZE_IMAGE[2]],
                "GlazeURL": ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                "doorOpenedTime": "2016-10-31T00:00:00",
                "pastHistory_URL":[
                    ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"]
                ],
                "pastHistory_doorOpenedTime":[
                    "2016-10-09T10:10:10",
                    "2016-10-08T10:10:10",
                    "2016-10-07T10:10:10",
                    "2016-10-06T10:10:10",
                    "2016-10-05T10:10:10",
                    "2016-10-04T10:10:10",
                    "2016-10-03T10:10:10",
                    "2016-10-02T10:10:10",
                    "2016-10-01T10:10:10"
                ],
                "drawSize" : [
                    {"startX":17, "startY": 318, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 874, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 332, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 881, "width": 1165, "height": 540, "rotate": 90}
                ],
                "homeScreenIndex": 1,
                "StorageModes": ['STORAGE_FRIDGE', 'STORAGE_FREEZER', 'STORAGE_FLEX_ZONE', 'STORAGE_PANTRY']
            }
        };
        scope.parseDeviceData(glazeInfo);

        var CategoryDB = {CategoryDB: []};
        CategoryDB.CategoryDB = foodCategoryData;
        scope.parseCategoryDB(foodCategoryData);

        var shoppingList = {ShoppingList: []};
        var shoppingListData = [
            {"id":"20161217212642123",  "groupId":"20161217212642123",  "category":"20161217212642123 My Shopping List",            "order":"20161217212642123", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"185",                "groupId":"185",                "category":"WWWWWWWWWW WWWWWWWWWW WWWWWWWWWW WWWWWWWWWW WWWWWWWWWW WWWWWWWWWW WWWWWWWWWW WWWWWWWWWW WWWWWWWWWW WWWWWWWWWW",                               "order":"185", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106132",    "groupId":"201610180106132",    "category":"gj201610180106132 ggggggggNew Shopping List",   "order":"201610180106132", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:45",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106863",    "groupId":"201610180106863",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106864",    "groupId":"201610180106864",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106865",    "groupId":"201610180106865",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106866",    "groupId":"201610180106866",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106867",    "groupId":"201610180106867",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106868",    "groupId":"201610180106868",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106869",    "groupId":"201610180106869",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106870",    "groupId":"201610180106870",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106871",    "groupId":"201610180106871",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106872",    "groupId":"201610180106872",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106873",    "groupId":"201610180106873",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106874",    "groupId":"201610180106874",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106875",    "groupId":"201610180106875",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106876",    "groupId":"201610180106876",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106877",    "groupId":"201610180106877",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106878",    "groupId":"201610180106878",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106879",    "groupId":"201610180106879",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106880",    "groupId":"201610180106880",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106881",    "groupId":"201610180106881",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106882",    "groupId":"201610180106882",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106883",    "groupId":"201610180106883",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106884",    "groupId":"201610180106884",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106885",    "groupId":"201610180106885",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106886",    "groupId":"201610180106886",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106887",    "groupId":"201610180106887",    "category":"201610180106863 New Shopping List1",            "order":"201610180106863", "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false, "category_info" : "", "food_position": "",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}}
        ];
        var shoppingItemData = [
            {"id":"184",            "groupId":"185",                "category":"",  "order":"184",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"184 [R]test",           "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",        "isDefault":false,                                  "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"186",            "groupId":"185",                "category":"",  "order":"186",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"186 [R]test",           "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",        "isDefault":false,                                  "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"187",            "groupId":"185",                "category":"",  "order":"187",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"187 [R]test",           "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",        "isDefault":false,      "data_type":"emart",        "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"188",            "groupId":"185",                "category":"",  "order":"188",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"188 [R]test",           "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"Cream Pasta",               "isDefault":false,                                 "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"189",            "groupId":"185",                "category":"",  "order":"189",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"189 [R]test",           "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":false,     "data_type":"woolworths",   "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"190",            "groupId":"185",                "category":"",  "order":"190",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"190 [R]test",           "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",        "isDefault":false,      "data_type":"woolworths",   "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"200",            "groupId":"185",                "category":"",  "order":"200",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"200 [R]test",           "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":false,     "data_type":"emart",        "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201",            "groupId":"185",                "category":"",  "order":"201",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"201 [R]test",           "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",        "isDefault":false,      "data_type":"deals",                            "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-09", "api_name": "allRecipeApi", "clip_state": "clip"}},
            {"id":"202",            "groupId":"185",                "category":"",  "order":"202",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"202 [R]test",           "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",        "isDefault":false,      "data_type":"deals",                            "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-10", "api_name": "allRecipeApi", "clip_state": "clip"}},
            {"id":"180",            "groupId":"20161217212642123",  "category":"",  "order":"180",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"180 Gaa-3",             "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,      "data_type":"deals",                            "category_info" : "BREAD AND BAKERY", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-11", "api_name": "allRecipeApi", "clip_state": "clip"}},
            {"id":"182",            "groupId":"20161217212642123",  "category":"",  "order":"182",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"182 Gaa-2",             "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,      "data_type":"deals",                            "category_info" : "BREAD AND BAKERY", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-12", "api_name": "allRecipeApi", "clip_state": "clip"}},
            {"id":"191",            "groupId":"20161217212642123",  "category":"",  "order":"191",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"191 test1",             "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,      "data_type":"deals",                            "category_info" : "BREAD AND BAKERY", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-13", "api_name": "allRecipeApi", "clip_state": "clip"}},
            {"id":"192",            "groupId":"20161217212642123",  "category":"",  "order":"192",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"192 test2",             "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,      "data_type":"deals",                            "category_info" : "BREAD AND BAKERY", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-14", "api_name": "allRecipeApi", "clip_state": "clip"}},
            {"id":"193",            "groupId":"20161217212642123",  "category":"",  "order":"193",             "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"193 test3",             "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,      "data_type":"deals",                            "category_info" : "BREAD AND BAKERY", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-15", "api_name": "allRecipeApi", "clip_state": "clip"}},
            {"id":"201610180105140","groupId":"20161217212642123",  "category":"",  "order":"201610180105140", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180105140 test4",  "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,     "data_type":"deals",                            "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-16", "api_name": "quotientApi", "clip_state": "clip"}},
            {"id":"201610180106330","groupId":"20161217212642123",  "category":"",  "order":"201610180106330", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106330 test5",  "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,     "data_type":"deals",                            "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-17", "api_name": "quotientApi", "clip_state": "clip"}},
            {"id":"201610180106924","groupId":"20161217212642123",  "category":"",  "order":"201610180106924", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106924 test6",  "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,     "data_type":"deals",                            "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-18", "api_name": "quotientApi", "clip_state": "clip"}},
            {"id":"201610180106206","groupId":"20161217212642123",  "category":"",  "order":"201610180106206", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106206 Gaa7",   "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,     "data_type":"deals",                            "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-19", "api_name": "quotientApi", "clip_state": "clip"}},
            {"id":"201610180106733","groupId":"20161217212642123",  "category":"",  "order":"201610180106733", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106733 [R]Gaa8",   "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",        "isDefault":true,   "data_type":"deals",                            "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "save $20","expiry_date": "2017-12-20", "api_name": "quotientApi", "clip_state": "clip"}},
            {"id":"201610180106616","groupId":"20161217212642123",  "category":"",  "order":"201610180106616", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106616 Gaa9",   "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                          "isDefault":true,     "data_type":"deals",                            "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "", "deals_detail": "save $20","expiry_date": "2017-12-21", "api_name": "quotientApi", "clip_state": "clip"}},
            {"id":"201610180106219","groupId":"20161217212642123",  "category":"",  "order":"201610180106219", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"201610180106219 Gaa10",   "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",                        "isDefault":true,      "data_type":"deals",                            "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "$1.99", "storeName": "Safeway", "deals_detail": "","expiry_date": "01/05/18", "api_name": "quotientApi", "clip_state": "clip"}},
            {"id":"201610180109747","groupId":"201610180106132",    "category":"",  "order":"201610180109747", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180109747", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,           "recipeName":"",                         "isDefault":false,                                 "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106748","groupId":"201610180106132",    "category":"",  "order":"201610180106748", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW", "quantity":2,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",  "isDefault":false, "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_PANTRY",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106649","groupId":"201610180106132",    "category":"",  "order":"201610180106649", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106649", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},

            {"id":"201610180106650","groupId":"201610180106132",    "category":"",  "order":"201610180106650", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106650", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "FRUITS AND VEGETABLES", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106651","groupId":"201610180106132",    "category":"",  "order":"201610180106651", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106651", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "FRUITS AND VEGETABLES", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106652","groupId":"201610180106132",    "category":"",  "order":"201610180106652", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106652", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "BREAD AND BAKERY", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106653","groupId":"201610180106132",    "category":"",  "order":"201610180106653", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106653", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "BREAD AND BAKERY", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106654","groupId":"201610180106132",    "category":"",  "order":"201610180106654", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106654", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "DAIRY AND EGGS", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106655","groupId":"201610180106132",    "category":"",  "order":"201610180106655", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106655", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "DAIRY AND EGGS", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106656","groupId":"201610180106132",    "category":"",  "order":"201610180106656", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106656", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "CONDIMENTS", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106657","groupId":"201610180106132",    "category":"",  "order":"201610180106657", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106657", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "CONDIMENTS", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106658","groupId":"201610180106132",    "category":"",  "order":"201610180106658", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106658", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "FROZEN", "food_position": "STORAGE_PANTRY",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106659","groupId":"201610180106132",    "category":"",  "order":"201610180106659", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106659", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "FROZEN", "food_position": "STORAGE_PANTRY",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106660","groupId":"201610180106132",    "category":"",  "order":"201610180106660", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106660", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "HERBS AND SPICES", "food_position": "STORAGE_PANTRY",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106661","groupId":"201610180106132",    "category":"",  "order":"201610180106661", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106661", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "HERBS AND SPICES", "food_position": "STORAGE_PANTRY",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106662","groupId":"201610180106132",    "category":"",  "order":"201610180106662", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106662", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "BREAKFAST FOODS", "food_position": "STORAGE_PANTRY",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106663","groupId":"201610180106132",    "category":"",  "order":"201610180106663", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106663", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "BREAKFAST FOODS", "food_position": "STORAGE_PANTRY",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106664","groupId":"201610180106132",    "category":"",  "order":"201610180106664", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106664", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "SNACKS", "food_position": "STORAGE_FREEZER",	        "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106665","groupId":"201610180106132",    "category":"",  "order":"201610180106665", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106665", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "SNACKS", "food_position": "STORAGE_FREEZER",	        "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106666","groupId":"201610180106132",    "category":"",  "order":"201610180106666", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106666", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "DRINKS", "food_position": "STORAGE_FREEZER",	        "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106667","groupId":"201610180106132",    "category":"",  "order":"201610180106667", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106667", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "DRINKS", "food_position": "STORAGE_FREEZER",	        "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106668","groupId":"201610180106132",    "category":"",  "order":"201610180106668", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106668", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "CANNED FOODS", "food_position": "STORAGE_FREEZER",	    "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106669","groupId":"201610180106132",    "category":"",  "order":"201610180106669", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106669", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "CANNED FOODS", "food_position": "STORAGE_FREEZER",	    "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106670","groupId":"201610180106132",    "category":"",  "order":"201610180106670", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106670", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "PET CARE", "food_position": "STORAGE_FREEZER",	        "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106671","groupId":"201610180106132",    "category":"",  "order":"201610180106671", "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106671", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,                  "category_info" : "PET CARE", "food_position": "STORAGE_FREEZER",	        "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106672","groupId":"201610180106132",    "category":"",  "order":"201610180106672", "imageURL":"http://item.ssgcdn.com/44/00/05/item/0000007050044_i1_202.jpg",    "itemStatus":"2",   "name":"목장의 신선함이 살아있는 우유 1L", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,    "category_info" : "HOUSEHOLD", "food_position": "STORAGE_FREEZER",  "data_type":"emart","emart_item_id":"0000007050044","emart_min_qty":"1","site_no":"6001",  "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106673","groupId":"201610180106132",    "category":"",  "order":"201610180106673", "imageURL":"http://item.ssgcdn.com/75/33/58/item/1000004583375_i1_202.jpg",    "itemStatus":"2",   "name":"[남양] 맛있는 우유 GT 1L×2", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,    "category_info" : "HOUSEHOLD", "food_position": "STORAGE_FREEZER",  "data_type":"emart","emart_item_id":"1000004583375","emart_min_qty":"1","site_no":"6001",   "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106674","groupId":"201610180106132",    "category":"",  "order":"201610180106674", "imageURL":"http://item.ssgcdn.com/74/54/61/item/0000006615474_i1_202.jpg",    "itemStatus":"2",   "name":"서울우유 1000ml 나100%", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,  "category_info" : "HEALTH AND BEAUTY", "food_position": "STORAGE_FLEX_ZONE",   "data_type":"emart","emart_item_id":"0000006615474","emart_min_qty":"1","site_no":"6001",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106675","groupId":"201610180106132",    "category":"",  "order":"201610180106675", "imageURL":"http://item.ssgcdn.com/96/55/09/item/0000007095596_i1_202.jpg",    "itemStatus":"2",   "name":"커피 삼각 포리 (200ml*3개)", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,    "category_info" : "HEALTH AND BEAUTY", "food_position": "STORAGE_FLEX_ZONE",	"data_type":"emart","emart_item_id":"0000007095596","emart_min_qty":"1","site_no":"6001",   "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106676","groupId":"201610180106132",    "category":"",  "order":"201610180106676", "imageURL":"http://item.ssgcdn.com/83/83/56/item/1000022568383_i1_202.jpg",    "itemStatus":"2",   "name":"[피코크] 우유(1등급) 1000ml", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,   "category_info" : "BABY CARE", "food_position": "STORAGE_FLEX_ZONE",	"data_type":"emart","emart_item_id":"1000022568383","emart_min_qty":"1","site_no":"6001",   "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106677","groupId":"201610180106132",    "category":"",  "order":"201610180106677", "imageURL":"http://item.ssgcdn.com/56/71/70/item/0000007707156_i1_202.jpg",    "itemStatus":"1",   "name":"매일우유 저지방1% 1.8L", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false, "category_info" : "BABY CARE", "food_position": "STORAGE_FLEX_ZONE",	"data_type":"emart","emart_item_id":"0000007707156","emart_min_qty":"1","site_no":"6001",   "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106678","groupId":"201610180106132",    "category":"",  "order":"201610180106678", "imageURL":"http://item.ssgcdn.com/65/85/62/item/0000007628565_i1_202.jpg",    "itemStatus":"1",   "name":"후레쉬 밀크 기획(900ml*2) 1800ml", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,  "category_info" : "BABY CARE", "food_position": "STORAGE_FLEX_ZONE",	"data_type":"emart","emart_item_id":"0000007628565","emart_min_qty":"1","site_no":"6001", "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}},
            {"id":"201610180106679","groupId":"201610180106132",    "category":"",  "order":"201610180106679", "imageURL":"http://item.ssgcdn.com/85/55/09/item/0000007095585_i1_202.jpg",    "itemStatus":"1",   "name":"서울우유 2.3L", "quantity":1,     "quantityUnit":"",    "storageType":"2016-04-21T13:21:47","isAdded":false,  "recipeName":"",    "isDefault":false,  "category_info" : "BABY CARE", "food_position": "STORAGE_FLEX_ZONE", "data_type":"emart","emart_item_id":"0000007095585","emart_min_qty":"1","site_no":"6001",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}}
        ];
        shoppingList['ShoppingList'] = shoppingListData.concat(shoppingItemData);

        // maximum test     20170113131812479.jpg
        // var shoppingList = {ShoppingList: []};
        // for (var i = 1; i <= 15; i++) {
        //     for (var j = 1; j <= 50; j++) {
        //         // var list = {"id": (i * j), "category":"List " + i, "groupId": i, "order":(i * j), "imageURL":"","itemStatus":"1","name":"item " + j, "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":false, "food_position": "STORAGE_FRIDGE", "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}};
        //         // var list = {"id": (i * j), "category":"List " + i, "groupId": i, "order":(i * j), "imageURL":"main_rf_img_02.png","itemStatus":"1","name":"뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁", "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":false, "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}};
        //         var list = {"id": (i * j), "category":"List " + i, "groupId": i, "order":(i * j), "imageURL":"main_rf_img_02.png","itemStatus":"1","name":"ㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡ", "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":false, "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE",	"Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}};
        //         // var list = {"id": (i * j), "category":"List " + i, "groupId": i, "order":(i * j), "imageURL":"main_rf_img_02.png","itemStatus":"1","name":"WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW", "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":false, "category_info" : "MEATS AND SEAFOOD", "food_position": "STORAGE_FRIDGE", "Deals" : {"deals_id": "", "price": "", "storeName": "", "deals_detail": "","expiry_date": "", "api_name": "", "clip_state": ""}};
        //         shoppingList['ShoppingList'].push(list);
        //     }
        // }
        scope.parseShoppingData(shoppingList);


        // maximum test
        // var foodList = {FoodList: []};
        // for (var i=1; i<=150; i++) {
        //     var item = {"category": "",	"expirationDate": "2015-12-20T03:57:50", "entryDate": "2016-09-27T03:57:50",	"id": i,   "Glaze" : {"shelfID" : 0,"tagPositionX" : 101, "tagPositionY" : 200},	"is_expiry_tag" : false, "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png",	"inputDate": "2012-08-07T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Eggs aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_PANTRY",    "isReminder":false, "category_info" : "MEATS AND SEAFOOD"};
        //     foodList['FoodList'].push(item);
        // }
        // scope.parseFoodData(foodList);

        // scope.selectedModeForDelete();
        // scope.resetSelectedMode();
    }

    function parseStaticData_FHub2() {
        console.log("parseStaticData_FHub2");
        scope.isStatic = true;

        var lcdSpec = {
            "applications": {
                "calendar": {
                    "installed": true,
                    "supportedCalendars":["GoogleCalendar","OutlookCalendar"]
                },
                "todo": {
                    "installed": true,
                    "maxLists": 50,
                    "maxItems": 50,
                    "maxChar_list": 32,
                    "maxChar_item": 160
                },
                "memo": {
                    "installed": true,
                    "maxItems": 100,
                    "recordable": true
                },
                "whiteboard": {
                    "installed": true,
                    "maxItems": 80,
                    "recordable": true
                },
                "photo": {
                    "installed": true
                },
                "viewinside": {
                    "installed": true,
                    "foodTag": false,
                    "maxItems": 150,
                    "maxFoodTags": 0,
                    "maxMemoTags": 50,
                    "maxChar": 32
                },
                "shoppinglist": {
                    "installed": true,
                    "maxLists": 24,
                    "maxItems": 50,
                    "maxChar_list": 32,
                    "maxChar_item": 32
                },
                "deals": {
                    "installed": true
                }
            }
        };
        scope.parseLcdSpec(lcdSpec["applications"]);

        var glazeInfo = {
            GlazeInfo: {
                // "GlazeURL": [DEFAULT_GLAZE_IMAGE[0], DEFAULT_GLAZE_IMAGE[1], DEFAULT_GLAZE_IMAGE[2]],
                "GlazeURL": ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                "doorOpenedTime": "2016-10-31T00:00:00",
                "drawSize" : [
                    {"startX":17, "startY": 318, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 874, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 332, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 881, "width": 1165, "height": 540, "rotate": 90}
                ],
                "homeScreenIndex": 1,
                "StorageModes": ['STORAGE_FRIDGE', 'STORAGE_FREEZER', 'STORAGE_FLEX_ZONE', 'STORAGE_PANTRY']
            }
        };
        scope.parseDeviceData(glazeInfo);

        var shoppingList = {ShoppingList: []};
        var shoppingListData = [
            {"id":"20161217212642123",  "groupId":"20161217212642123",  "category":"20161217212642123 My Shopping List",            "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59",   "isAdded":false,    "recipeName":"",   "isDefault":true},
            {"id":"185",                "groupId":"185",                "category":"185 Recipe List",                               "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59",   "isAdded":false,    "recipeName":"",   "isDefault":false},
            {"id":"201610180106132",    "groupId":"201610180106132",    "category":"gj201610180106132 ggggggggNew Shopping List",   "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:45",   "isAdded":false,    "recipeName":"",   "isDefault":false},
            {"id":"201610180106863",    "groupId":"201610180106863",    "category":"201610180106863 New Shopping List1",            "imageURL":"",  "itemStatus":"",    "name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:13",   "isAdded":false,    "recipeName":"",   "isDefault":false}
        ];
        var shoppingItemData = [
            {"id":"184",            "groupId":"185",                "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"184 [R]test",           "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"186",            "groupId":"185",                "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"186 [R]test",           "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"187",            "groupId":"185",                "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"187 [R]test",           "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false, "data_type":"emart"},
            {"id":"188",            "groupId":"185",                "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"188 [R]test",           "quantity":"1",     "quantityUnit":"lb",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"Cream Pasta",               "isDefault":false},
            {"id":"189",            "groupId":"185",                "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"189 [R]test",           "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":false, "data_type":"woolworths"},
            {"id":"190",            "groupId":"185",                "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"190 [R]test",           "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false, "data_type":"woolworths"},
            {"id":"200",            "groupId":"185",                "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"200 [R]test",           "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":false, "data_type":"emart"},
            {"id":"201",            "groupId":"185",                "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"201 [R]test",           "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"202",            "groupId":"185",                "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"202 [R]test",           "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"180",            "groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"180 Gaa-3",             "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"182",            "groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"182 Gaa-2",             "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"191",            "groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"191 test1",             "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"192",            "groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"192 test2",             "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"193",            "groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"193 test3",             "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180105140","groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180105140 test4",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106330","groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106330 test5",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106924","groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106924 test6",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106206","groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106206 Gaa7",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106733","groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106733 [R]Gaa8",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":true},
            {"id":"201610180106616","groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180106616 Gaa9",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106219","groupId":"20161217212642123",  "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"201610180106219 Gaa10",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180109750","groupId":"201610180106132",    "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"201610180109750", "quantity":"2",     "quantityUnit":"kg",    "storageType":"2016-04-21T13:21:47","isAdded":false,    "recipeName":"",               "isDefault":false},
            {"id":"201610180106750","groupId":"201610180106132",    "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"1",   "name":"gj201610180106750@@@@@@@@@@@@@@@@@@@@@@@@@@@", "quantity":"2",     "quantityUnit":"kg",    "storageType":"2016-04-21T13:21:47","isAdded":false,    "recipeName":"",               "isDefault":false},
            {"id":"201610180106649","groupId":"201610180106132",    "category":"",  "imageURL":"images/reminder/main_rf_img_02.png",    "itemStatus":"2",   "name":"gj201610180106649 item1ggggggggggggggggggggggggggggggggggggg", "quantity":"2",     "quantityUnit":"kg",    "storageType":"2016-04-21T13:21:47","isAdded":false,    "recipeName":"",               "isDefault":false},
        ];
        shoppingList['ShoppingList'] = shoppingListData.concat(shoppingItemData);

        // maximum test     20170113131812479.jpg
        // var shoppingList = {ShoppingList: []};
        // for (var i = 1; i <= 15; i++) {
        //     for (var j = 1; j <= 50; j++) {
        //         // var list = {"id": (i * j), "category":"List " + i, "groupId": i, "imageURL":"","itemStatus":"1","name":"item " + j, "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":false};
        //         // var list = {"id": (i * j), "category":"List " + i, "groupId": i, "imageURL":"main_rf_img_02.png","itemStatus":"1","name":"뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁뷁", "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":false};
        //         var list = {"id": (i * j), "category":"List " + i, "groupId": i, "imageURL":"main_rf_img_02.png","itemStatus":"1","name":"ㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡ", "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":false};
        //         // var list = {"id": (i * j), "category":"List " + i, "groupId": i, "imageURL":"main_rf_img_02.png","itemStatus":"1","name":"WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW", "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":false};
        //         shoppingList['ShoppingList'].push(list);
        //     }
        // }
        scope.parseShoppingData(shoppingList);


        // maximum test
        // var foodList = {FoodList: []};
        // for (var i=1; i<=150; i++) {
        //     var item = {"category": "",	"expirationDate": "2015-12-20T03:57:50", "entryDate": "2016-09-27T03:57:50",	"id": i,   "Glaze" : {"shelfID" : 0,"tagPositionX" : 101, "tagPositionY" : 200},	"imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png",	"inputDate": "2012-08-07T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Eggs aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_PANTRY",    "isReminder":false};
        //     foodList['FoodList'].push(item);
        // }
        // scope.parseFoodData(foodList);

        // scope.selectedModeForDelete();
        // scope.resetSelectedMode();
    }
}]);