/**
 * Created by jji.yeon on 2017-11-03.
 */
app.service('staticData', ['profileService', function (profileService) {
    var scope = angular.element(document.getElementById("bodyTag")).scope();

    var DEFAULT_GLAZE_IMAGE = ["./REF_ViewInside/assets/img/main_rf_img_01.png",
        './REF_ViewInside/assets/img/main_rf_img_02.png',
        './REF_ViewInside/assets/img/main_rf_img_03.png',
        './REF_ViewInside/assets/img/main_rf_img_01.png'];

    var foodCategoryData = [
        {"Category_ID":"Fruits_Vegetables",         "Order":1,"Icon":"produce.png","displayName":"Fruits and Vegetables"},
        {"Category_ID":"Meats_Seafood",             "Order":2,"Icon":"meat.png","displayName":"Meats and Seafood"},
        {"Category_ID":"Bread_Bakery",              "Order":3,"Icon":"bread.png","displayName":"Bread and Bakery"},
        {"Category_ID":"Dairy_Eggs_Cheese",         "Order":4,"Icon":"dairy.png","displayName":"Dairy, Eggs and Cheese"},
        {"Category_ID":"Condiments_Sauces",         "Order":5,"Icon":"ketchup.png","displayName":"Condiments and Sauces"},
        {"Category_ID":"Frozen",                    "Order":6,"Icon":"frozen.png","displayName":"Frozen"},
        {"Category_ID":"Seasoning_Spices_Baking",   "Order":7,"Icon":"spices.png","displayName":"Seasoning, Spices and Baking"},
        {"Category_ID":"Breakfast_Cereal",          "Order":8,"Icon":"cereal.png","displayName":"Breakfast and Cereal"},
        {"Category_ID":"Cookies_Snacks_Candy",      "Order":9,"Icon":"snacks.png","displayName":"Cookies, Snacks and Candy"},
        {"Category_ID":"Beverages",                 "Order":10,"Icon":"drinks.png","displayName":"Beverages"},
        {"Category_ID":"Canned_DryGoods",           "Order":11,"Icon":"cans.png","displayName":"Canned and Dry Goods"},
        {"Category_ID":"PetCare",                   "Order":12,"Icon":"pets.png","displayName":"Pet Care"},
        {"Category_ID":"Household",                 "Order":13,"Icon":"household.png","displayName":"Household"},
        {"Category_ID":"PersonalCare",              "Order":14,"Icon":"personal.png","displayName":"Personal Care"},
        {"Category_ID":"BabyCare",                  "Order":15,"Icon":"baby.png","displayName":"Baby Care"},
        {"Category_ID":"Other",                     "Order":16,"Icon":"other.png","displayName":"Other"}
    ];

    this.parseStaticData_FHub3 = parseStaticData_FHub3;
    this.parseStaticData_FHub2 = parseStaticData_FHub2;
    this.responseAutoComplete = responseAutoComplete;
    this.responseGetMemo = responseGetMemo;

    function responseAutoComplete(str) {
        return {
            "type":"requestResponse",
            "status":200,
            "requestToken": "searchForFood",
            "data":{
                "SearchList": [
                    {
                        "name": str,
                        "displayName": str,
                        "popularity":100,
                        "imageUrl":"https://lh3.googleusercontent.com/s5CjFLsXW4FLV3p315nfBwc-0AOI4lMA399PP-qi70jGy8rfJb5UgqtCJgLdWyBpjj4PGvN7QOhJPZ_8-xZbLUgkWKY",
                        "metadata":{
                            "category":"FRUITS AND VEGETABLES",
                            "storing":{
                                "fridge":{
                                    "metric":"Days",
                                    "min":3,
                                    "max":4
                                },
                                "freezer":{
                                    "metric":"NotRecommended"
                                }
                            }
                        }
                    }
                ]
            }
        };
    }

    function responseGetMemo(id) {
        return {
            "type":"requestResponse",
            "status":200,
            "requestToken": "getMemo",
            "data":{
                "Memo": [
                    {
                        "id": id,
                        "writer": "1090c79a-6088-4a6b-ba09-af0c1691d507",  // writer(user id)
                        "receiver":[  // receiver(user id)
                            "1090c79a-6088-4a6b-ba09-af0c1691d507",
                            "29bcef92-3c27-4281-a822-169818fb2c3e",
                            "b4a79e87-9c2f-4815-a955-943f19bb226a",
                            "2e1791b5-fbec-4309-ad42-d3355778981a",
                            "5a3f9ad7-5e09-4510-b8cf-fc79f5f3aae8",
                            "d55a54d1-e872-4202-a813-dc79d7219b0f"
                        ],
                        "imageURL":"/201609211233000.jpg",  // s-Cloud path
                        "voiceURL":"/201609211233000.aac",  // s-Cloud path
                        "createdTime":"2016-04-21T13:21:13",  // createdTime(UTC),
                        "foodListId":"201609211233000", // view inside ID
                        "text":"aaaaaaa"  // for accessibility of memo text
                    }
                ]
            }
        };
    }

    function parseStaticData_FHub3() {
        console.log("parseStaticData_FHub3");
        scope.isStatic = true;

        var lcdSpec = {
            "applications": {
                "calendar": {
                    "installed": true,
                    "supportedCalendars":["GoogleCalendar","OutlookCalendar","OpenCalendar"]
                },
                "todo": {
                    "installed": true,
                    "maxLists": 50,
                    "maxItems": 50,
                    "maxChar_list": 100,
                    "maxChar_item": 160
                },
                "memo": {
                    "installed": true,
                    "maxItems": 100,
                    "recordable": true
                },
                "whiteboard": {
                    "installed": true,
                    "maxItems": 80,
                    "recordable": true
                },
                "photo": {
                    "installed": true
                },
                "viewinside": {
                    "installed": true,
                    "foodTag": true,
                    "maxItems": 150,
                    "maxFoodTags": 20,
                    "maxMemoTags": 10,
                    "maxChar": 100,
                    "maxHistoryCnt": 9
                },
                "shoppinglist": {
                    "installed": true,
                    "maxLists": 150,
                    "maxItems": 50,
                    "maxChar_list": 100,
                    "maxChar_item": 100
                },
                "deals": {
                    "installed": true
                }
            }
        };
        scope.parseLcdSpec(lcdSpec["applications"]);

        var profileList = {profileList: []};
        var profileListData = [
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "1090c79a-6088-4a6b-ba09-af0c1691d507","screenName": "dayeon4","profileColor": "3","photo": "","avatar": "9"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "29bcef92-3c27-4281-a822-169818fb2c3e","screenName": "gary","profileColor": "7","photo": "","avatar": "16"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "b4a79e87-9c2f-4815-a955-943f19bb226a","screenName": "dayeon2","profileColor": "2","photo": "","avatar": "23"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "2e1791b5-fbec-4309-ad42-d3355778981a","screenName": "dayeon","profileColor": "7","photo": "","avatar": "20"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "5a3f9ad7-5e09-4510-b8cf-fc79f5f3aae8","screenName": "dayeon3","profileColor": "5","photo": "","avatar": "15"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "d55a54d1-e872-4202-a813-dc79d7219b0f","screenName": "dayeon5","profileColor": "4","photo": "","avatar": "17"}
        ];
        profileList['profileList'] = profileListData;
        profileService.parseProfileData(profileList);

        var glazeInfo = {
            GlazeInfo: {
                // "GlazeURL": [DEFAULT_GLAZE_IMAGE[0], DEFAULT_GLAZE_IMAGE[1], DEFAULT_GLAZE_IMAGE[2]],
                "GlazeURL": ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"],
                "doorOpenedTime": "2016-10-31T00:00:00",
                "pastHistory_URL":[
                    ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"],
                    ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"],
                    ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"],
                    ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"],
                    ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"],
                    ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"],
                    ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"],
                    ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"],
                    ["camera_1.jpg", "camera_2.jpg", "camera_3.jpg"]

                    // ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    // ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    // ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    // ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    // ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    // ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    // ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    // ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                    // ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"]
                ],
                "pastHistory_doorOpenedTime":[
                    "2016-10-09T10:10:10",
                    "2016-10-08T10:10:10",
                    "2016-10-07T10:10:10",
                    "2016-10-06T10:10:10",
                    "2016-10-05T10:10:10",
                    "2016-10-04T10:10:10",
                    "2016-10-03T10:10:10",
                    "2016-10-02T10:10:10",
                    "2016-10-01T10:10:10"
                ],
                "drawSize" : [
                    {"startX":17, "startY": 318, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 874, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 332, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 881, "width": 1165, "height": 540, "rotate": 90}
                ],
                "homeScreenIndex": 1,
                "StorageModes": ['STORAGE_FRIDGE', 'STORAGE_FREEZER', 'STORAGE_FLEX_ZONE', 'STORAGE_PANTRY']
            }
        };
        scope.parseDeviceData(glazeInfo);

        var CategoryDB = {CategoryDB: []};
        CategoryDB.CategoryDB = foodCategoryData;
        scope.parseCategoryDB(foodCategoryData);

        var shoppingList = {ShoppingList: []};
        var shoppingListData = [
            {"id":"183",                "category":"New Shopping List",     "groupId":"183",                "imageURL":"","itemStatus":"","name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"185",                "category":"Recipe List",           "groupId":"185",                "imageURL":"","itemStatus":"","name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":false},
            {"id":"201610180106132",    "category":"New Shopping List",     "groupId":"201610180106132",    "imageURL":"","itemStatus":"","name":"", "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:45","isAdded":false,    "recipeName":"",               "isDefault":false}
        ];
        var shoppingItemData = [
            {"id":"180",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"Gaa-3",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"182",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"Gaa-2",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"191",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"test1",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"192",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"test2",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"193",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"test3",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180105140",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"test4",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106330",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"test5",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106924",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"test6",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106206",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"Gaa7",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106733",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"[R]Gaa8",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":true},
            {"id":"201610180106616",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"Gaa9",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106219",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"Gaa10",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"184",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"186",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"187",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"188",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"[R]test",  "quantity":"1",     "quantityUnit":"lb",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"189",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"190",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"201610180106649",    "category":"",     "groupId":"201610180106132",    "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"item1", "quantity":"2",     "quantityUnit":"kg",    "storageType":"2016-04-21T13:21:47","isAdded":false,    "recipeName":"",               "isDefault":false},
            {"id":"201610180106863",    "category":"",     "groupId":"201610180106863",    "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"name",  "quantity":"10",    "quantityUnit":"kg",    "storageType":"2016-04-21T13:21:13","isAdded":false,    "recipeName":"",               "isDefault":false}
        ];
        shoppingList['ShoppingList'] = shoppingListData.concat(shoppingItemData);

        // maximum test
        // var shoppingList = {ShoppingList: []};
        // for (var i = 1; i <= 25; i++) {
        //     for (var j = 1; j <= 50; j++) {
        //         var list = {"id": (i * j), "category":"List " + i, "groupId": i, "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"item " + j, "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":true};
        //         shoppingList['ShoppingList'].push(list);
        //     }
        // }
        scope.parseShoppingData(shoppingList);


        var foodList = {FoodList: []};
        var foodData = [
            {"category": "",	"expirationDate": "",	                    "id": "10", "Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	"imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png",	"inputDate": "2012-08-07T03:57:50", "entryDate": "2016-10-29T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Eggs aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",    "isReminder":false, "data_type":"woolworths", "category_info" : "FRUITS AND VEGETABLES"},
            {"category": "",	"expirationDate": "2018-09-20T03:57:50",	"id": "11",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	"imageURL":"./REF_ViewInside/assets/img/main_rf_img_01.png",	"inputDate": "2015-06-27T03:10:02", "entryDate": "2016-10-31T03:10:02",	"isNewlyAdded": false,	"name": "(text+img)Coffee aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",     "isReminder":true, "data_type":"emart", "category_info" : "Meats_Seafood"},
            {"category": "",	"expirationDate": "2016-12-23T03:57:50",	"id": "12",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"./REF_ViewInside/assets/img/main_rf_img_01.png",	"inputDate": "2016-09-27T03:57:50", "entryDate": "2013-10-30T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Cake aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",    "isReminder":true, "data_type":"woolworths", "category_info" : "BREAD AND BAKERY"},
            {"category": "",	"expirationDate": "2016-09-09T03:57:50",	"id": "15",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2016-10-28T03:10:02",	"isNewlyAdded": false,	"name": "(text)Milk aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_PANTRY",    "isReminder":true, "data_type":"", "category_info" : "DAIRY AND EGGS"},
            {"category": "",	"expirationDate": "2016-12-29T03:57:50",	"id": "16",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	"imageURL":"",	"inputDate": "2016-10-27T03:10:02", "entryDate": "2016-12-25T03:10:02",	"isNewlyAdded": false,	"name": "(text)Squid aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FREEZER",   "isReminder":true, "data_type":"", "category_info" : "CONDIMENTS"},
            {"category": "",	"expirationDate": "2017-11-17T03:57:50",	"id": "17",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2016-10-28T03:10:02",	"isNewlyAdded": false,	"name": "aaaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "HERBS AND SPICES"},
            {"category": "",	"expirationDate": "2017-11-16T03:57:50",	"id": "18",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-11-16T03:10:02",	"isNewlyAdded": false,	"name": "(text)Milk aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_PANTRY",    "isReminder":true, "data_type":"", "category_info" : "FROZEN"},
            {"category": "",	"expirationDate": "2017-12-25T03:57:50",	"id": "19",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-12-24T03:10:02",	"isNewlyAdded": false,	"name": "baaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "BAKING"},
            {"category": "",	"expirationDate": "2017-12-25T03:57:50",	"id": "20",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-12-24T03:10:02",	"isNewlyAdded": false,	"name": "baaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "DRINKS"},
            {"category": "",	"expirationDate": "2017-12-25T03:57:50",	"id": "21",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-12-24T03:10:02",	"isNewlyAdded": false,	"name": "baaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "CANNED FOODS"},
            {"category": "",	"expirationDate": "2017-12-25T03:57:50",	"id": "22",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-12-24T03:10:02",	"isNewlyAdded": false,	"name": "baaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "PASTA, RICE AND BEANS"},
            {"category": "",	"expirationDate": "2017-12-25T03:57:50",	"id": "23",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-12-24T03:10:02",	"isNewlyAdded": false,	"name": "baaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "PET CARE"},
            {"category": "",	"expirationDate": "2020-09-20T03:57:50",	"id": "24",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-12-24T03:10:02",	"isNewlyAdded": false,	"name": "baaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "HOUSEHOLD"},
            {"category": "",	"expirationDate": "2018-01-05T03:57:50",	"id": "25",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-12-24T03:10:02",	"isNewlyAdded": false,	"name": "baaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "HEALTH AND BEAUTY"},
            {"category": "",	"expirationDate": "2018-01-04T03:57:50",	"id": "26",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-12-24T03:10:02",	"isNewlyAdded": false,	"name": "baaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "BABY CARE"},
            {"category": "",	"expirationDate": "2018-01-03T03:57:50",	"id": "27",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},"is_expiry_tag" : false,	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2017-12-24T03:10:02",	"isNewlyAdded": false,	"name": "baaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FLEX_ZONE",    "isReminder":true, "data_type":"", "category_info" : "OTHER"}

        ];
        var food_tagData = [
            {"category": "",	"expirationDate": "2016-12-23T03:57:50",	"id": "203",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 70, "tagPositionY" : 50},"is_expiry_tag" : true,	    "imageURL":"./REF_ViewInside/assets/img/main_rf_img_01.png",	"inputDate": "2016-09-27T03:57:50", "entryDate": "2013-10-30T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Cake aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",    "isReminder":true, "data_type":"emart", "category_info" : "BREAKFAST FOODS"},
            {"category": "",	"expirationDate": "2025-12-23T03:57:50",	"id": "204",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 10, "tagPositionY" : 250},"is_expiry_tag" : true,	    "imageURL":"",	"inputDate": "2016-10-30T03:57:50", "entryDate": "2016-10-30T03:57:50",	"isNewlyAdded": true,	"name": "(text)Cake aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",    "isReminder":true, "data_type":"", "category_info" : "SNACKS"}
        ];
        // foodList['FoodList'] = foodData.concat(food_tagData);

        var memo_tagData = [
            {"category": "",    "inputDate": "2015-10-07T03:57:50",     "id": "100",    "Glaze" : {"shelfID" : 0,"tagPositionX" : 101, "tagPositionY" : 200},   "memoId": "100",    "is_expiry_tag" : false,	"imageURL":"",	"entryDate": "2016-10-29T03:57:50", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":"", "category_info" : ""},
            {"category": "",    "inputDate": "2015-06-07T03:57:50",     "id": "101",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 201, "tagPositionY" : 200},   "memoId": "101",    "is_expiry_tag" : false,	"imageURL":"",	"entryDate": "2016-10-31T03:10:02", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":"", "category_info" : ""},
            {"category": "",    "inputDate": "2015-06-27T03:10:02",     "id": "102",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 301, "tagPositionY" : 200},   "memoId": "102",    "is_expiry_tag" : false,	"imageURL":"",	"entryDate": "2016-10-31T03:10:02", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":"", "category_info" : ""},
            {"category": "",    "inputDate": "2015-06-27T03:11:02",     "id": "104",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 401, "tagPositionY" : 200},   "memoId": "104",    "is_expiry_tag" : false,	"imageURL":"",	"entryDate": "2016-10-31T03:10:02", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":"", "category_info" : ""},
            {"category": "",    "inputDate": "2015-10-27T03:12:02",     "id": "105",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 501, "tagPositionY" : 200},   "memoId": "105",    "is_expiry_tag" : false,	"imageURL":"",	"entryDate": "2016-10-31T03:10:02", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":"", "category_info" : ""}
        ];
        foodList['FoodList'] = foodData.concat(memo_tagData).concat(food_tagData);

        // maximum test
        // var foodList = {FoodList: []};
        // for (var i=1; i<=150; i++) {
        //     var item = {"category": "",	"expirationDate": "2015-12-20T03:57:50", "entryDate": "2016-09-27T03:57:50",	"id": i,   "Glaze" : {"shelfID" : 0,"tagPositionX" : 101, "tagPositionY" : 200}, "is_expiry_tag" : false,	"imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png",	"inputDate": "2012-08-07T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Eggs aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_PANTRY",    "isReminder":false, "category_info" : "Meats_Seafood"};
        //     foodList['FoodList'].push(item);
        // }
        scope.parseFoodData(foodList);
    }

    function parseStaticData_FHub2() {
        console.log("parseStaticData_FHub2");
        scope.isStatic = true;

        var lcdSpec = {
            "applications": {
                "calendar": {
                    "installed": true,
                    "supportedCalendars":["GoogleCalendar","OutlookCalendar"]
                },
                "todo": {
                    "installed": true,
                    "maxLists": 50,
                    "maxItems": 50,
                    "maxChar_list": 32,
                    "maxChar_item": 160
                },
                "memo": {
                    "installed": true,
                    "maxItems": 100,
                    "recordable": true
                },
                "whiteboard": {
                    "installed": true,
                    "maxItems": 80,
                    "recordable": true
                },
                "photo": {
                    "installed": true
                },
                "viewinside": {
                    "installed": true,
                    "foodTag": false,
                    "maxItems": 150,
                    "maxFoodTags": 0,
                    "maxMemoTags": 50,
                    "maxChar": 32
                },
                "shoppinglist": {
                    "installed": true,
                    "maxLists": 24,
                    "maxItems": 50,
                    "maxChar_list": 32,
                    "maxChar_item": 32
                },
                "deals": {
                    "installed": true
                }
            }
        };
        scope.parseLcdSpec(lcdSpec["applications"]);

        var glazeInfo = {
            GlazeInfo: {
                // "GlazeURL": [DEFAULT_GLAZE_IMAGE[0], DEFAULT_GLAZE_IMAGE[1], DEFAULT_GLAZE_IMAGE[2]],
                "GlazeURL": ["camera_1.jpg", "camera_1.jpg", "camera_2.jpg", "camera_2.jpg"],
                "doorOpenedTime": "2016-10-31T00:00:00",
                "drawSize" : [
                    {"startX":17, "startY": 318, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 874, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 332, "width": 1165, "height": 540, "rotate": 90},
                    {"startX":17, "startY": 881, "width": 1165, "height": 540, "rotate": 90}
                ],
                "homeScreenIndex": 1,
                "StorageModes": ['STORAGE_FRIDGE', 'STORAGE_FREEZER', 'STORAGE_FLEX_ZONE', 'STORAGE_PANTRY']
            }
        };
        scope.parseDeviceData(glazeInfo);

        var shoppingList = {ShoppingList: []};
        var shoppingListData = [
            {"id":"183",                "category":"New Shopping List",     "groupId":"183",                "imageURL":"","itemStatus":"","name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"185",                "category":"Recipe List",           "groupId":"185",                "imageURL":"","itemStatus":"","name":"",  "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":false},
            {"id":"201610180106132",    "category":"New Shopping List",     "groupId":"201610180106132",    "imageURL":"","itemStatus":"","name":"", "quantity":"",     "quantityUnit":"",    "storageType":"2016-04-21T13:21:45","isAdded":false,    "recipeName":"",               "isDefault":false}
        ];
        var shoppingItemData = [
            {"id":"180",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"Gaa-3",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"182",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"Gaa-2",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"191",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"test1",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"192",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"test2",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"193",                "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"test3",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180105140",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"test4",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106330",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"test5",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106924",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"test6",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106206",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"Gaa7",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106733",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"[R]Gaa8",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":true},
            {"id":"201610180106616",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"Gaa9",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"201610180106219",    "category":"",     "groupId":"183",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"Gaa10",   "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"",               "isDefault":true},
            {"id":"184",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"186",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"187",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"188",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"[R]test",  "quantity":"1",     "quantityUnit":"lb",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"189",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"190",                "category":"",     "groupId":"185",                "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"[R]test",  "quantity":"1",     "quantityUnit":"ea",    "storageType":"2016-04-22T05:00:59","isAdded":false,    "recipeName":"TomatoBasil Pasta",               "isDefault":false},
            {"id":"201610180106649",    "category":"",     "groupId":"201610180106132",    "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"2","name":"item1", "quantity":"2",     "quantityUnit":"kg",    "storageType":"2016-04-21T13:21:47","isAdded":false,    "recipeName":"",               "isDefault":false},
            {"id":"201610180106863",    "category":"",     "groupId":"201610180106863",    "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"name",  "quantity":"10",    "quantityUnit":"kg",    "storageType":"2016-04-21T13:21:13","isAdded":false,    "recipeName":"",               "isDefault":false}
        ];
        shoppingList['ShoppingList'] = shoppingListData.concat(shoppingItemData);

        // maximum test
        // var shoppingList = {ShoppingList: []};
        // for (var i = 1; i <= 25; i++) {
        //     for (var j = 1; j <= 50; j++) {
        //         var list = {"id": (i * j), "category":"List " + i, "groupId": i, "imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png","itemStatus":"1","name":"item " + j, "quantityUnit":"ea","storageType":"2016-04-22T05:00:59","isAdded":false,"quantity":1,"recipeName":"","isDefault":true};
        //         shoppingList['ShoppingList'].push(list);
        //     }
        // }
        scope.parseShoppingData(shoppingList);


        var foodList = {FoodList: []};
        var foodData = [
            {"category": "",	"expirationDate": "",	                    "id": "10", "Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},	"imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png",	"inputDate": "2012-08-07T03:57:50", "entryDate": "2016-10-29T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Eggs aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",    "isReminder":false, "data_type":"woolworths"},
            {"category": "",	"expirationDate": "2018-09-20T03:57:50",	"id": "11",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},	"imageURL":"./REF_ViewInside/assets/img/main_rf_img_01.png",	"inputDate": "2015-06-27T03:10:02", "entryDate": "2016-10-31T03:10:02",	"isNewlyAdded": false,	"name": "(text+img)Coffee aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",     "isReminder":true, "data_type":"emart"},
            {"category": "",	"expirationDate": "2016-12-23T03:57:50",	"id": "12",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},	    "imageURL":"./REF_ViewInside/assets/img/main_rf_img_01.png",	"inputDate": "2016-09-27T03:57:50", "entryDate": "2013-10-30T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Cake aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",    "isReminder":true, "data_type":"woolworths"},
            {"category": "",	"expirationDate": "2016-12-23T03:57:50",	"id": "13",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},	    "imageURL":"./REF_ViewInside/assets/img/main_rf_img_01.png",	"inputDate": "2016-09-27T03:57:50", "entryDate": "2013-10-30T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Cake aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",    "isReminder":true, "data_type":"emart"},
            {"category": "",	"expirationDate": "",	                    "id": "14",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},	    "imageURL":"",	"inputDate": "2016-10-30T03:57:50", "entryDate": "2016-10-30T03:57:50",	"isNewlyAdded": true,	"name": "(text)Cake aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",    "isReminder":false, "data_type":""},
            {"category": "",	"expirationDate": "2016-09-09T03:57:50",	"id": "15",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},	    "imageURL":"",	"inputDate": "2016-10-28T03:10:02", "entryDate": "2016-10-28T03:10:02",	"isNewlyAdded": false,	"name": "(text)Milk aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FRIDGE",    "isReminder":true, "data_type":""},
            {"category": "",	"expirationDate": "2016-12-29T03:57:50",	"id": "16",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 0, "tagPositionY" : 0},	"imageURL":"",	"inputDate": "2016-10-27T03:10:02", "entryDate": "2016-12-25T03:10:02",	"isNewlyAdded": false,	"name": "(text)Squid aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_FREEZER",   "isReminder":true, "data_type":""}
        ];
        var tagData = [
            {"category": "",    "inputDate": "2015-10-07T03:57:50",     "id": "100",    "Glaze" : {"shelfID" : 0,"tagPositionX" : 101, "tagPositionY" : 200},	"imageURL":"",	"entryDate": "2016-10-29T03:57:50", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":""},
            {"category": "",    "inputDate": "2015-06-07T03:57:50",     "id": "101",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 201, "tagPositionY" : 200},	"imageURL":"",	"entryDate": "2016-10-31T03:10:02", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":""},
            {"category": "",    "inputDate": "2015-06-27T03:10:02",     "id": "102",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 301, "tagPositionY" : 200},	"imageURL":"",	"entryDate": "2016-10-31T03:10:02", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":""},
            {"category": "",    "inputDate": "2015-06-27T03:11:02",     "id": "104",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 401, "tagPositionY" : 200},	"imageURL":"",	"entryDate": "2016-10-31T03:10:02", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":""},
            {"category": "",    "inputDate": "2015-10-27T03:12:02",     "id": "105",	"Glaze" : {"shelfID" : 0,"tagPositionX" : 501, "tagPositionY" : 200},	"imageURL":"",	"entryDate": "2016-10-31T03:10:02", "expirationDate": "",	"isNewlyAdded": false,	"name": "",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_TAG",     "isReminder":false, "data_type":""}
        ];
        foodList['FoodList'] = foodData.concat(tagData);

        // maximum test
        // var foodList = {FoodList: []};
        // for (var i=1; i<=150; i++) {
        //     var item = {"category": "",	"expirationDate": "2015-12-20T03:57:50", "entryDate": "2016-09-27T03:57:50",	"id": i,   "Glaze" : {"shelfID" : 0,"tagPositionX" : 101, "tagPositionY" : 200},	"imageURL":"./REF_ViewInside/assets/img/main_rf_img_02.png",	"inputDate": "2012-08-07T03:57:50",	"isNewlyAdded": true,	"name": "(text+img)Eggs aaaaaaaaaaaaaaaaaaaaaaa",	"quantity": 1,	"quantityUnit": "EA",	"storageType": "STORAGE_PANTRY",    "isReminder":false};
        //     foodList['FoodList'].push(item);
        // }
        scope.parseFoodData(foodList);
    }
}]);