/**
 * Created by jji.yeon on 2017-11-03.
 */
app.service('staticData', [function () {
    var scope = angular.element(document.getElementById("bodyTag")).scope();

    this.parseStaticData_FHub3 = parseStaticData_FHub3;
    this.parseStaticData_FHub2 = parseStaticData_FHub2;

    function parseStaticData_FHub3() {
        console.log("parseStaticData_FHub3");
        scope.isStatic = true;

        var lcdSpec = {
            "applications": {
                "calendar": {
                    "installed": true,
                    "supportedCalendars":["GoogleCalendar","OutlookCalendar","OpenCalendar"]
                },
                "todo": {
                    "installed": true,
                    "maxLists": 50,
                    "maxItems": 50,
                    "maxChar_list": 100,
                    "maxChar_item": 160
                },
                "memo": {
                    "installed": true,
                    "maxItems": 100,
                    "recordable": true
                },
                "whiteboard": {
                    "installed": true,
                    "maxItems": 80,
                    "recordable": true
                },
                "photo": {
                    "installed": true
                },
                "viewinside": {
                    "installed": true,
                    "foodTag": true,
                    "maxItems": 150,
                    "maxFoodTags": 20,
                    "maxMemoTags": 10,
                    "maxChar": 100
                },
                "shoppinglist": {
                    "installed": true,
                    "maxLists": 150,
                    "maxItems": 50,
                    "maxChar_list": 100,
                    "maxChar_item": 100
                },
                "deals": {
                    "installed": true
                }
            }
        };
        scope.parseLcdSpec(lcdSpec["applications"]);

        var profileList = {profileList: []};
        var profileListData = [
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "1090c79a-6088-4a6b-ba09-af0c1691d507","screenName": "dayeon4","profileColor": "3","photo": "","avatar": "9"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "29bcef92-3c27-4281-a822-169818fb2c3e","screenName": "gary","profileColor": "7","photo": "","avatar": "16"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "b4a79e87-9c2f-4815-a955-943f19bb226a","screenName": "dayeon2","profileColor": "2","photo": "","avatar": "23"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "2e1791b5-fbec-4309-ad42-d3355778981a","screenName": "dayeon","profileColor": "7","photo": "","avatar": "20"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "5a3f9ad7-5e09-4510-b8cf-fc79f5f3aae8","screenName": "dayeon3","profileColor": "5","photo": "","avatar": "15"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "d55a54d1-e872-4202-a813-dc79d7219b0f","screenName": "dayeon5","profileColor": "4","photo": "","avatar": "17"}
        ];
        profileList['profileList'] = profileListData;
        scope.fillProfileData(profileList);

        var todoList = {TodoList: []};
        var todoListData = [
            {"userId": "c139b472-5c2b-4aee-996f-86fdd426c4e1","groupId": "20141109011019700","category": "To Do List","isDefault": false,"order": "20141109011019700","isNewlyAdded": false},
            {"userId": "c139b472-5c2b-4aee-996f-86fdd426c4e1","groupId": "20161109011019700","category": "To Do List","isDefault": false,"order": "20141109011019700","isNewlyAdded": false},
            {"userId": "29bcef92-3c27-4281-a822-169818fb2c3e","groupId": "20161114142530702","category": "gary","isDefault": true,"order": "20161114142530702","isNewlyAdded": false},
            {"userId": "1090c79a-6088-4a6b-ba09-af0c1691d507","groupId": "20161111214202930","category": "dayeon4aaaaaaaaaaaaaaaaaaaaa","isDefault": true,"order": "20161111214202930","isNewlyAdded": false},
            {"userId": "d55a54d1-e872-4202-a813-dc79d7219b0f","groupId": "20161110154807058","category": "dayeon5","isDefault": true,"order": "20161110154807058","isNewlyAdded": false},
            {"userId": "b4a79e87-9c2f-4815-a955-943f19bb226a","groupId": "20161111214203240","category": "dayeon2","isDefault": true,"order": "20161111214203240","isNewlyAdded": false},
            {"userId": "5a3f9ad7-5e09-4510-b8cf-fc79f5f3aae8","groupId": "20161111214203088","category": "dayeon3","isDefault": true,"order": "20161111214203088","isNewlyAdded": false}
        ];
        todoList['TodoList'] = todoListData;
        scope.parseTodoListData(todoList);

        var todoItem = {Todo: []};
        var todoItemData = [
            {"groupId": "20161109011019700","id": "20161114093621812","name": "Ggggdfgdgdgdfgdgdgdgdgdgdgdgddgdfgdgdfgdfgdfgdfgdfgdgdgdfgdgdfgdfgdfgfdgddfgdfgfdgg","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621813","name": "Pay bills","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621814","name": "Wash car","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621815","name": "Book flight to","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621816","name": "Send Invitation","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621817","name": "Take out garbage","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621818","name": "Wash","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621813","name": "Pick up kids","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621814","name": "Pick up dry","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621815","name": "Pick up eggs","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621816","name": "Pay bills","itemStatus": "2","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621817","name": "Wash car","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621818","name": "Book flight to","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621813","name": "Send Invitation","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621814","name": "Take out garbage","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621899","name": "Take out garbage","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161110154807058","id": "20161114093621815","name": "Take out garbage","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161110154807058","id": "20161114093621816","name": "Wash","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214203240","id": "20161114093621817","name": "Pay bills","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214203240","id": "20161114093621818","name": "Pay tax","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},

            {"groupId": "20161111214203088","id": "20161114093621911","name": "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214203088","id": "20161114093621912","name": "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 2,"isNewlyAdded": true},
            {"groupId": "20161111214203088","id": "20161114093621913","name": "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 3,"isNewlyAdded": true},
            {"groupId": "20161111214203088","id": "20161114093621914","name": "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 4,"isNewlyAdded": true},
            {"groupId": "20161111214203088","id": "20161114093621915","name": "WWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 5,"isNewlyAdded": true},
        ];
        todoItem['Todo'] = todoItemData;

        // maximum test
        // var todoList = {TodoList: []};
        // var todoItem = {Todo: []};
        // for (var i = 1; i <= 15; i++) {
        //     var list = {"userId": "b4a79e87-9c2f-4815-a955-943f19bb226a","groupId": i,"category": "dayeon2","isDefault": true,"order": "20161111214203240","isNewlyAdded": false};
        //     todoList['TodoList'].push(list);
        //
        //     for (var j = 1; j <= 50; j++) {
        //         var id = timeStamp.getDateFormat(new Date,'yyyyMMddHHmmss sss', 'UTC').replace(" ", "") + '' + j;
        //         // var item = {"groupId": i,"id": id,"name": "1aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa 2aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa 3aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa 4aaaaaa","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true};
        //         var item = {"groupId": i,"id": id,"name": "ㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡㅡ","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true};
        //         todoItem['Todo'].push(item);
        //     }
        // }
        scope.parseTodoListData(todoList);
        scope.parseTodoItemData(todoItem);
    }

    function parseStaticData_FHub2() {
        console.log("parseStaticData_FHub2");
        scope.isStatic = true;

        var lcdSpec = {
            "applications": {
                "calendar": {
                    "installed": true,
                    "supportedCalendars":["GoogleCalendar","OutlookCalendar"]
                },
                "todo": {
                    "installed": true,
                    "maxLists": 50,
                    "maxItems": 50,
                    "maxChar_list": 32,
                    "maxChar_item": 160
                },
                "memo": {
                    "installed": true,
                    "maxItems": 100,
                    "recordable": true
                },
                "whiteboard": {
                    "installed": true,
                    "maxItems": 80,
                    "recordable": true
                },
                "photo": {
                    "installed": true
                },
                "viewinside": {
                    "installed": true,
                    "foodTag": false,
                    "maxItems": 150,
                    "maxFoodTags": 0,
                    "maxMemoTags": 50,
                    "maxChar": 32
                },
                "shoppinglist": {
                    "installed": true,
                    "maxLists": 24,
                    "maxItems": 50,
                    "maxChar_list": 32,
                    "maxChar_item": 32
                },
                "deals": {
                    "installed": true
                }
            }
        };
        scope.parseLcdSpec(lcdSpec["applications"]);

        var profileList = {profileList: []};
        var profileListData = [
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "1090c79a-6088-4a6b-ba09-af0c1691d507","screenName": "dayeon4","profileColor": "3","photo": "","avatar": "7"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "29bcef92-3c27-4281-a822-169818fb2c3e","screenName": "gary","profileColor": "7","photo": "","avatar": "1"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "b4a79e87-9c2f-4815-a955-943f19bb226a","screenName": "dayeon2","profileColor": "2","photo": "","avatar": "6"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "2e1791b5-fbec-4309-ad42-d3355778981a","screenName": "dayeon","profileColor": "7","photo": "","avatar": "4"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "5a3f9ad7-5e09-4510-b8cf-fc79f5f3aae8","screenName": "dayeon3","profileColor": "5","photo": "","avatar": "1"},
            {"familyId": "3420ff32-9550-4662-96b1-35341a7b73c7","userId": "d55a54d1-e872-4202-a813-dc79d7219b0f","screenName": "dayeon5","profileColor": "4","photo": "","avatar": "5"}
        ];
        profileList['profileList'] = profileListData;
        scope.fillProfileData(profileList);

        var todoList = {TodoList: []};
        var todoListData = [
            {"userId": "c139b472-5c2b-4aee-996f-86fdd426c4e1","groupId": "20141109011019700","category": "To Do List","isDefault": false,"order": "20141109011019700","isNewlyAdded": false},
            {"userId": "c139b472-5c2b-4aee-996f-86fdd426c4e1","groupId": "20161109011019700","category": "To Do List","isDefault": false,"order": "20141109011019700","isNewlyAdded": false},
            {"userId": "29bcef92-3c27-4281-a822-169818fb2c3e","groupId": "20161114142530702","category": "gary","isDefault": true,"order": "20161114142530702","isNewlyAdded": false},
            {"userId": "1090c79a-6088-4a6b-ba09-af0c1691d507","groupId": "20161111214202930","category": "dayeon4","isDefault": true,"order": "20161111214202930","isNewlyAdded": false},
            {"userId": "d55a54d1-e872-4202-a813-dc79d7219b0f","groupId": "20161110154807058","category": "dayeon5","isDefault": true,"order": "20161110154807058","isNewlyAdded": false},
            {"userId": "b4a79e87-9c2f-4815-a955-943f19bb226a","groupId": "20161111214203240","category": "dayeon2","isDefault": true,"order": "20161111214203240","isNewlyAdded": false},
            {"userId": "5a3f9ad7-5e09-4510-b8cf-fc79f5f3aae8","groupId": "20161111214203088","category": "dayeon3","isDefault": true,"order": "20161111214203088","isNewlyAdded": false}
        ];
        todoList['TodoList'] = todoListData;
        scope.parseTodoListData(todoList);

        var todoItem = {Todo: []};
        var todoItemData = [
            {"groupId": "20161109011019700","id": "20161114093621812","name": "Ggggdfgdgdgdfgdgdgdgdgdgdgdgddgdfgdgdfgdfgdfgdfgdfgdgdgdfgdgdfgdfgdfgfdgddfgdfgfdgg","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621813","name": "Pay bills","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621814","name": "Wash car","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621815","name": "Book flight to","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621816","name": "Send Invitation","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621817","name": "Take out garbage","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161114142530702","id": "20161114093621818","name": "Wash","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621813","name": "Pick up kids","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621814","name": "Pick up dry","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621815","name": "Pick up eggs","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621816","name": "Pay bills","itemStatus": "2","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621817","name": "Wash car","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621818","name": "Book flight to","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621813","name": "Send Invitation","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621814","name": "Take out garbage","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214202930","id": "20161114093621899","name": "Take out garbage","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161110154807058","id": "20161114093621815","name": "Take out garbage","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161110154807058","id": "20161114093621816","name": "Wash","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214203240","id": "20161114093621817","name": "Pay bills","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214203240","id": "20161114093621818","name": "Pay tax","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},

            {"groupId": "20161111214203088","id": "20161114093621911","name": "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true},
            {"groupId": "20161111214203088","id": "20161114093621912","name": "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 2,"isNewlyAdded": true},
            {"groupId": "20161111214203088","id": "20161114093621913","name": "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 3,"isNewlyAdded": true},
            {"groupId": "20161111214203088","id": "20161114093621914","name": "WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 4,"isNewlyAdded": true},
            {"groupId": "20161111214203088","id": "20161114093621915","name": "WWWWWWWWWWWWWWWWWW","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 5,"isNewlyAdded": true},
        ];
        todoItem['Todo'] = todoItemData;

        // maximum test
        // var todoList = {TodoList: []};
        // var todoItem = {Todo: []};
        // for (var i = 1; i <= 15; i++) {
        //     var list = {"userId": "b4a79e87-9c2f-4815-a955-943f19bb226a","groupId": i,"category": "dayeon2","isDefault": true,"order": "20161111214203240","isNewlyAdded": false};
        //     todoList['TodoList'].push(list);
        //
        //     for (var j = 1; j <= 50; j++) {
        //         var id = timeStamp.getDateFormat(new Date,'yyyyMMddHHmmss sss', 'UTC').replace(" ", "") + '' + j;
        //         // var item = {"groupId": i,"id": id,"name": "1aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa 2aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa 3aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa 4aaaaaa","itemStatus": "1","inputDate": "2016-11-14T09:36:21","order": 1,"isNewlyAdded": true};
        //         todoItem['Todo'].push(item);
        //     }
        // }
        scope.parseTodoListData(todoList);
        scope.parseTodoItemData(todoItem);
    }
}]);