var app = angular.module("SmartThings", ['ngSanitize', 'ui.router', 'ngMaterial', 'ngAria', 'ngTouch']);//

app.controller("todoListController", function ($scope, $state, $filter, imageCache, imageRequest, timeStamp, SHPService, REQUEST, staticData, QuickDelete, $timeout) {
    var ENTER_KEYCODE = 13, STATUS_500 = 500, langArr = Object.keys(LANGUAGE_FILE.language);

    if (langArr.indexOf(LANG.toUpperCase()) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase()];
    } else if (langArr.indexOf(LANG.toUpperCase().substring(0, 2)) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase().substring(0, 2)];
    } else {
        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
    }
    if (LANG.toUpperCase().indexOf('EN') !== -1) {
        $scope.selectedLangEnglish = true;
    }
    if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
        $scope.isAppleDevice = true;
    }

    // to check if input ot textara is focused
    function isTextInput(node) {
        return ['INPUT', 'TEXTAREA'].indexOf(node.nodeName) !== -1;
    }

    // remove focues on touch anywhere on the screen
    document.addEventListener('touchstart', function (e) {
        if ($scope.isAppleDevice) {
            if (!isTextInput(e.target) && isTextInput(document.activeElement)) {
                removeFocus();
            }
        }
    }, false);

    var TODOLIST_SCREEN = {
        HOME: 'HOME',
        DETAIL_SCREEN: 'DETAIL_SCREEN'
    };

    /** Starts to define the default values for FHub 2.0 **/
    $scope.MAX_LIST = 50;
    $scope.MAX_LIST_ITEM = 50;
    $scope.MAX_CHARACTER_TITLE = 32;//32;
    $scope.MAX_CHARACTER_ITEM = 160;//160;
    /** Ends to define the default values for FHub 2.0 **/

    var colorList = ["red", "orange", "yellow", "green", "blue", "indigo", "violet", "grey"];

    $scope.QuickDelete = QuickDelete;
    $scope.isLocal = false;
    $scope.isStatic = false;
    $scope.loadingBar = false;
    $scope.isTransparent = false;
    $scope.backButton = false;
    $scope.bOptionPopUp = false;
    $scope.isSelectedMode = false;
    $scope.HomePage = true;
    $scope.DetailPage = false;
    $scope.confirmationPopUpVisible = false;
    $scope.listItemChanged = false;
    $scope.groupId = "";

    $scope.profileData = [];
    $scope.checkResponse = [];
    $scope.optionsMenu = [{
        id: 'deleteItem',
        title: $scope.translation.WEBMOB_fhub2_common_delete
    }];
    $scope.optionsMenuHome = [{
        id: 'deleteList',
        title: $scope.translation.WEBMOB_fhub2_common_delete
    }];

    $scope.Device = {
        ShoppingList: {}
    };

    $scope.inputData = {
        groupId: "",
        category: decodeHtmlEntity($scope.translation.WEBMOB_fhub2_to_do_create_new_title),
        name: ""
    };

    $scope.dialogPopup = {
        show: false,
        dialogPopupTitle: '',
        dialogPopupText: '',
        button1Title: '',
        button1Handler: function () {
            toggleBottomPopUpClass(false);
            $scope.dialogPopup.show = false;
        },
        button2Enabled: false,
        button2Title: '',
        button2Handler: function () {
        }
    };

    $scope.currentScreen = TODOLIST_SCREEN.HOME;
    $scope.custpopuptextString = "";
    $scope.modifyList = [];
    $scope.events = {BACK_PRESSED: 'onBackPressed', SHOW_OPTION_POPUP: 'showOptionPopup'};
    $scope.eventQueue = [];
    {
        $scope.init = init;
        $scope.getAvatar = getAvatar;
        $scope.scrollListView = scrollListView;
        $scope.getProfileColor = getProfileColor;
        $scope.getProfileImage = getProfileImage;
        $scope.updateDeviceData = updateDeviceData;
        $scope.parseLcdSpec = parseLcdSpec;
        $scope.parseTodoListData = parseTodoListData;
        $scope.parseTodoItemData = parseTodoItemData;
        $scope.parseDeviceData = parseDeviceData;
        $scope.parseStaticData = parseStaticData;
        $scope.fillProfileData = fillProfileData;
        $scope.requestFailHandler = requestFailHandler;
        $scope.requestResponseHandler = requestResponseHandler;
        $scope.requestProgressHandler = requestProgressHandler;
        $scope.showConnectionFailurePopup = showConnectionFailurePopup;
        $scope.closeConnectionFailurePopup = closeConnectionFailurePopup;
        $scope.goToShopListHome = goToShopListHome;
        $scope.goToDetailPage = goToDetailPage;
        $scope.showDetailScreen = showDetailScreen;
        $scope.onBackPressed = onBackPressed;
        $scope.closeLoadingBar = closeLoadingBar;
        $scope.dismissLoadingBar = dismissLoadingBar;
        $scope.closeApp = closeApp;
        $scope.addShoppingListTitleCommand = addShoppingListTitleCommand;
        $scope.addShoppingListItemCommand = addShoppingListItemCommand;
        $scope.showDetailScreenForCreateList = showDetailScreenForCreateList;
        $scope.cancelButtonPressedFromMultiSelect = cancelButtonPressedFromMultiSelect;
        $scope.toggleSelectAllListCheckBox = toggleSelectAllListCheckBox;
        $scope.isChecked = isChecked;
        $scope.toggleCheckList = toggleCheckList;
        $scope.showOptionPopup = showOptionPopup;
        $scope.closeOptionPopup = closeOptionPopup;
        $scope.showConfirmationPopUp = showConfirmationPopUp;
        $scope.closeConfirmationPopUp = closeConfirmationPopUp;
        $scope.onCancelConfirmationPopUp = onCancelConfirmationPopUp;
        $scope.onOkConfirmationPopUp = onOkConfirmationPopUp;
        $scope.onCancelConfirmationAddEditPopUp = onCancelConfirmationAddEditPopUp;
        $scope.selectIndexFromOptionMenu = selectIndexFromOptionMenu;
        $scope.longPressOnItemFromHomePage = longPressOnItemFromHomePage;
        $scope.selectIndexFromMoreOptionMenu = selectIndexFromMoreOptionMenu;
        $scope.keyupHandler = keyupHandler;
        $scope.isEmpty = isEmpty;
        $scope.isCheckedItem = isCheckedItem;
        $scope.updateItemStatusCommand = updateItemStatusCommand;
        $scope.decodeHtmlEntity = decodeHtmlEntity;
        $scope.encodeEscape = encodeEscape;
        $scope.decodeUnescape = decodeUnescape;
        $scope.editShoppingListTitleCommand = editShoppingListTitleCommand;
        $scope.isFocused = isFocused;
        $scope.deleteToDoListCommand = deleteToDoListCommand;
        $scope.deleteToDoItemCommand = deleteToDoItemCommand;
        $scope.deleteToDoItemsCommand = deleteToDoItemsCommand;
        $scope.editShoppingListItemCommand = editShoppingListItemCommand;
        $scope.removeFocus = removeFocus;
        $scope.setSelectedItems = setSelectedItems;
        $scope.deleteSelectedItems = deleteSelectedItems;
        $scope.clearSelectedItems = clearSelectedItems;
        $scope.isCheckedItems = isCheckedItems;
        $scope.isAllCheckBoxSelected = isAllCheckBoxSelected;
        $scope.closeSelectedMode = closeSelectedMode;
        $scope.resetSelectedMode = resetSelectedMode;
        $scope.defaultListCount = defaultListCount;
        $scope.getTodoListCount = getTodoListCount;
        $scope.scrollListViewOnBackToHomePage = scrollListViewOnBackToHomePage;
        $scope.clearModifyList = clearModifyList;
        $scope.isAdded = isAdded;
        $scope.getModifyItem = getModifyItem;
        $scope.runEventQueue = runEventQueue;
        $scope.getImage = getImage;
        $scope.imageURL_Request = imageURL_Request;
        $scope.clearEventQueue = clearEventQueue;
    }

    $scope.initial_inputData = initial_inputData;
    function initial_inputData() {
        debugMessage('initial_inputData');
        $scope.inputData.groupId = "";
        $scope.inputData.category = decodeHtmlEntity($scope.translation.WEBMOB_fhub2_to_do_create_new_title);
        $scope.inputData.name = "";
    }

    $scope.isDefinedList = isDefinedList;
    function isDefinedList(groupId) {
        return (angular.isDefined(groupId) && angular.isDefined($scope.Device.ShoppingList[groupId]));
    }

    $scope.getTitle = function (groupId) {
        if (isDefinedList(groupId)) {
            return $scope.Device.ShoppingList[groupId].category;
        }
        else {
            return decodeHtmlEntity($scope.translation.WEBMOB_fhub2_to_do_create_new_title);
        }
    };

    $scope.orderByTodoItem = orderByTodoItem;
    function orderByTodoItem() {
        return ['+itemStatus', '-order', '+name'];
    }

    $scope.MAX_THUMBNAIL_LIMIT = 6;
    $scope.thumbNail_limitTo = thumbNail_limitTo;
    function thumbNail_limitTo(groupId) {
        if (isDefinedList(groupId) && angular.isDefined($scope.Device.ShoppingList[groupId].items)) {
            return ($scope.Device.ShoppingList[groupId].items.length <= $scope.MAX_THUMBNAIL_LIMIT)? $scope.MAX_THUMBNAIL_LIMIT : $scope.MAX_THUMBNAIL_LIMIT - 1;
        }
    }

    $scope.detail_view_scroll_height = function(groupId) {
        if (isDefinedList(groupId) && $scope.Device.ShoppingList[groupId].isDefault) {
            return {height: 'calc(100% - 6.25rem)'};
        }
        else {
            return {height: 'calc(100% - 3.75rem)'};
        }
    };

    function changeScreen() {
        hideAllScreens();
        switch ($scope.currentScreen) {
            case TODOLIST_SCREEN.HOME:
                $scope.HomePage = true;
                break;
            case TODOLIST_SCREEN.DETAIL_SCREEN:
                $scope.DetailPage = true;
                break;
            default:
                break;
        }
    }

    function hideAllScreens() {
        $scope.HomePage = false;
        $scope.DetailPage = false;
    }

    function init() {
        // Future purpose
    }

    function updateDeviceData(data) {
        SHPService.updateDeviceData($scope, data);
    }

    function parseLcdSpec(data) {
        console.log("parseLcdSpec::: ", data);
        if (angular.isDefined(data) && angular.isDefined(data["todo"])) {
            var todoSpec = data["todo"];
            $scope.MAX_LIST = (angular.isDefined(todoSpec["maxLists"]))? parseInt(todoSpec["maxLists"]) : $scope.MAX_LIST;
            $scope.MAX_LIST_ITEM = (angular.isDefined(todoSpec["maxItems"]))? parseInt(todoSpec["maxItems"]) : $scope.MAX_LIST_ITEM;
            $scope.MAX_CHARACTER_TITLE = (angular.isDefined(todoSpec["maxChar_list"]))? parseInt(todoSpec["maxChar_list"]) : $scope.MAX_CHARACTER_TITLE;
            $scope.MAX_CHARACTER_ITEM = (angular.isDefined(todoSpec["maxChar_item"]))? parseInt(todoSpec["maxChar_item"]) : $scope.MAX_CHARACTER_ITEM;
        }
    }

    function parseTodoListData(device) {
        if (angular.isUndefined(device["TodoList"])) {
            return;
        }

        device["TodoList"].forEach(function (deviceTodoList) {
            deviceTodoList.category = decodeUnescape(deviceTodoList.category); //deviceShoppingList.category;
            if (!angular.isDefined($scope.Device.ShoppingList[deviceTodoList.groupId])) {
                $scope.Device.ShoppingList[deviceTodoList.groupId] = {
                    userId: deviceTodoList.userId,
                    groupId: deviceTodoList.groupId,
                    category: deviceTodoList.category,
                    isDefault: deviceTodoList.isDefault,
                    order: deviceTodoList.order,
                    items: [],
                    isNewlyAdded: deviceTodoList.isNewlyAdded,
                    isTemp: false
                };
                debugMessage("parseDeviceData:: deviceShoppingList=" + JSON.stringify($scope.Device.ShoppingList[deviceTodoList.groupId]));
            } else {
                var tempList = angular.copy($scope.Device.ShoppingList[deviceTodoList.groupId]);
                tempList.groupId = deviceTodoList.groupId;
                tempList.category = deviceTodoList.category;
                tempList.isDefault = deviceTodoList.isDefault;
                tempList.isNewlyAdded = deviceTodoList.isNewlyAdded;
                tempList.order = deviceTodoList.order;
                tempList.userId = deviceTodoList.userId;
                tempList.isTemp = false;

                //delete temp list object to force ng-repeat to update due to order issue.
                if ($scope.Device.ShoppingList[deviceTodoList.groupId].isTemp)
                    delete $scope.Device.ShoppingList[deviceTodoList.groupId];

                $scope.Device.ShoppingList[deviceTodoList.groupId] = angular.copy(tempList);
            }
        });

    }

    function parseTodoItemData(device) {
        if (angular.isUndefined(device["Todo"])) {
            return;
        }

        device["Todo"].forEach(function (deviceTodoItem) {
            // console.log("deviceShoppingList ", deviceTodoItem);
            if (!angular.isDefined($scope.Device.ShoppingList[deviceTodoItem.groupId])) {
                $scope.Device.ShoppingList[deviceTodoItem.groupId] = {
                    userId: angular.isDefined($scope.userId)? $scope.userId : "",
                    groupId: deviceTodoItem.groupId,
                    category: decodeHtmlEntity($scope.translation.WEBMOB_fhub2_to_do_create_new_title),
                    isDefault: false,
                    order: timeStamp.getDateFormat(new Date(), 'yyyyMMddHHmmss sss', 'UTC').replace(" ", ""),
                    items: [],
                    isNewlyAdded: true,
                    isTemp: true
                };
            }
            if (angular.isDefined($scope.Device.ShoppingList[deviceTodoItem.groupId])) {
                deviceTodoItem.name = decodeUnescape(deviceTodoItem.name);

                var index = $scope.Device.ShoppingList[deviceTodoItem.groupId].items.map(function (item) {return item.id;}).indexOf(deviceTodoItem.id);

                if (index === -1) {
                    $scope.Device.ShoppingList[deviceTodoItem.groupId].items.push(deviceTodoItem);
                }
                else {
                    $scope.Device.ShoppingList[deviceTodoItem.groupId].items[index].groupId = deviceTodoItem.groupId;
                    $scope.Device.ShoppingList[deviceTodoItem.groupId].items[index].id = deviceTodoItem.id;
                    $scope.Device.ShoppingList[deviceTodoItem.groupId].items[index].name = deviceTodoItem.name;
                    $scope.Device.ShoppingList[deviceTodoItem.groupId].items[index].itemStatus = deviceTodoItem.itemStatus;
                    $scope.Device.ShoppingList[deviceTodoItem.groupId].items[index].inputDate = deviceTodoItem.inputDate;
                    $scope.Device.ShoppingList[deviceTodoItem.groupId].items[index].order = deviceTodoItem.order;
                    $scope.Device.ShoppingList[deviceTodoItem.groupId].items[index].isAdded = deviceTodoItem.isNewlyAdded;
                }
            }

            if ($scope.currentScreen === TODOLIST_SCREEN.DETAIL_SCREEN) {
                if ($scope.inputData.groupId === deviceTodoItem.groupId) {
                    if ($scope.isSelectedMode)
                        resetSelectedMode();
                    resizeTextArea(deviceTodoItem.id);
                    bindTouchEventForTextArea();
                }
            }
        });
    }

    function getAvatar(listUserId) {
        for (var i = 0; i < $scope.profileData.length; i++) {
            if ($scope.profileData[i].userId === listUserId) {
                return $scope.profileData[i].avatar;
            }
        }
    }

    function getProfileColor(listUserId) {
        for (var i = 0; i < $scope.profileData.length; i++) {
            if ($scope.profileData[i].userId === listUserId) {
                return $scope.profileData[i].profileColor;
            }
        }
    }

    function getProfileImage(listUserId) {
        var index = $scope.profileData.map(function (profile) {
            return profile.userId;
        }).indexOf(listUserId);
        if (index !== -1) {
            if ($scope.profileData[index].photo !== "" && getImage($scope.profileData[index].photo) !== "") {
                return getImage($scope.profileData[index].photo);
            }
            else {
                /**
                 * [avatar]
                 * character: 1~8, family: 9~16, animal: 17~24
                 * [color]
                 * 1: red, 2: orange, 3: yellow, 4: green, 5: blue, 6: indigo, 7: violet, (8: grey - deleted)
                 */
                var avatarIdx = parseInt(getAvatar(listUserId));
                var colorName = getProfileColor(listUserId);

                if (avatarIdx <= 8) {
                    return 'common/img/Character_ic/character_ic_0' + avatarIdx + '_' + colorName + '.png';
                }
                else if (avatarIdx >= 9 && avatarIdx <= 16) {
                    if (avatarIdx === 9)
                        return 'common/img/Character_ic/family/family_ic_0' + avatarIdx + '_' + colorName + '.png';
                    else
                        return 'common/img/Character_ic/family/family_ic_' + avatarIdx + '_' + colorName + '.png';
                }
                else if (avatarIdx >= 17 && avatarIdx <= 24) {
                    return 'common/img/Character_ic/animal/animal_ic_' + avatarIdx + '_' + colorName + '.png';
                }
                else    //Unknown
                return 'common/img/Character_ic/character_ic_unkown.png';
            }
        }
        return '';
    }

    function parseDeviceData(device) {
        if (angular.isDefined(device['service']) && device['service'] === 'Profile') {
            //Updated profile data.
            $scope.checkResponse.push(REQUEST.GET_PROFILE);
            SHPService.sendNativeCommand(REQUEST.GET_PROFILE, "", REQUEST.GET_PROFILE, false);
        }

        if (angular.isDefined(device["TodoList"])) {
            debugMessage("parseDeviceData:: device=" + JSON.stringify(device));
            if (device['event'] === 'Deleted') {
                device["TodoList"].forEach(function (list) {
                    if (angular.isDefined($scope.Device.ShoppingList) && angular.isDefined(list.groupId) && angular.isDefined($scope.Device.ShoppingList[list.groupId])) {
                        console.log("Parse Delete Todo::: list.groupId = " + list.groupId);
                        if ($scope.inputData.groupId === list.groupId) {
                            goToShopListHome();
                            $scope.closeConfirmationPopUp();
                        }
                        delete $scope.Device.ShoppingList[list.groupId];
                    }
                });

                if ($scope.currentScreen === TODOLIST_SCREEN.HOME && $scope.isSelectedMode) {
                    if (getTodoListCount()<=defaultListCount())
                        cancelButtonPressedFromMultiSelect();
                }
            }
            else if (device['event'] === 'Created' || device['event'] === 'Notified') {
                debugMessage("parseDeviceData:: (device['event'] === 'Created')");
                parseTodoListData(device);
            }

            if ($scope.currentScreen === TODOLIST_SCREEN.HOME && $scope.isSelectedMode) {
                resetSelectedMode();
            }
        }

        if (angular.isDefined(device["Todo"])) {
            if (device['event'] === 'Created' || device['event'] === 'Notified') {
                parseTodoItemData(device);
            }
            else if (device['event'] === 'Deleted') {
                device["Todo"].forEach(function (deviceTodoItem) {
                    if (angular.isDefined(deviceTodoItem.groupId) && angular.isDefined($scope.Device.ShoppingList[deviceTodoItem.groupId])) {
                        console.log("Parse Delete TodoItem::: list.id = " + deviceTodoItem.id);
                        for (var index = 0; index < $scope.Device.ShoppingList[deviceTodoItem.groupId].items.length; index++) {
                            if ($scope.Device.ShoppingList[deviceTodoItem.groupId].items[index].id === deviceTodoItem.id) {
                                $scope.Device.ShoppingList[deviceTodoItem.groupId].items.splice(index, 1);
                                break;
                            }
                        }

                        if ($scope.currentScreen === TODOLIST_SCREEN.DETAIL_SCREEN) {
                            if ($scope.inputData.groupId === deviceTodoItem.groupId) {
                                if ($scope.isSelectedMode) {
                                    if ($scope.Device.ShoppingList[deviceTodoItem.groupId].items.length === 0)
                                        onBackPressed();
                                    else
                                        resetSelectedMode();
                                }
                            }
                        }

                        //if list is created temporarily, remove list.
                        if ($scope.Device.ShoppingList[deviceTodoItem.groupId].isTemp && $scope.Device.ShoppingList[deviceTodoItem.groupId].items.length === 0) {
                            if ($scope.inputData.groupId === deviceTodoItem.groupId) {
                                goToShopListHome();
                                $scope.closeConfirmationPopUp();
                            }
                            delete $scope.Device.ShoppingList[deviceTodoItem.groupId];
                        }
                    }
                });
            }


        }
        console.log('parseDeviceData $scope.Device.ShoppingList ', $scope.Device.ShoppingList);
    }

    function parseStaticData() {
        // staticData.parseStaticData_FHub2();
        staticData.parseStaticData_FHub3();
    }

    function requestFailHandler(response) {
        if (response["status"] === STATUS_500 && (response["type"] === "requestResponse" || response["type"] === "requestFailed")) {
            $scope.checkResponse = [];
            $scope.loadingBar = false;
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_common_check_power_and_network, "");
        }
        if (response["status"] === 404 && response["type"] === "requestFailed") {
            console.log("Image Not Found - ", JSON.stringify(response) , response);
        }
    }

    function fillProfileData(profileList) {
        $scope.profileData = [];
        profileList["profileList"].forEach(function (value) {
            var profile = {
                familyId: value.familyId,
                screenName: decodeUnescape(value.screenName),
                profileColor: colorList[value.profileColor - 1],
                photo: value.photo,
                avatar: value.avatar,
                userId: value.userId
            };
            $scope.profileData.push(profile);
            imageURL_Request(profile.photo);
        });
        console.log("fillProfileData ", $scope.profileData);
    }

    function requestResponseHandler(response) {
        console.log("todo.js requestResponseHandler response ", response);

        if (response['requestToken'] === REQUEST.GET_IMAGE_LIST) {
            if (angular.isDefined(response["data"])) {
                imageRequest.parseNativeResponse(response["data"]);
            }
        }
        if (response['requestToken'] === REQUEST.ADD_TODO_LIST) {
            initialLaunch = false;
            $scope.init();
            $scope.parseDeviceData(response["data"]);
            dismissLoadingBar(REQUEST.ADD_TODO_LIST);
            SHPService.loadingFinished();
        }
        if (response['requestToken'] === REQUEST.GET_TODO_LIST) {
            initialLaunch = false;
            $scope.init();
            parseTodoListData(response["data"]);
            goToShopListHome();
            dismissLoadingBar(REQUEST.GET_TODO_LIST);
            SHPService.loadingFinished();
        }
        if (response['requestToken'] === REQUEST.GET_TODO) {
            initialLaunch = false;
            $scope.init();
            parseTodoItemData(response["data"]);
            dismissLoadingBar(REQUEST.GET_TODO);
            SHPService.loadingFinished();
        }
        if (response['requestToken'] === REQUEST.DELETE_TODO) {
            initialLaunch = false;
            $scope.init();
            $scope.parseDeviceData(response["data"]);
            dismissLoadingBar(REQUEST.DELETE_TODO);
            SHPService.loadingFinished();
        }
        if (response['requestToken'] === REQUEST.DELETE_TODO_LIST) {
            initialLaunch = false;
            $scope.init();
            $scope.parseDeviceData(response["data"]);
            dismissLoadingBar(REQUEST.DELETE_TODO_LIST);
            SHPService.loadingFinished();
        }
        if (response['requestToken'] === REQUEST.EDIT_TODO_LIST) {
            initialLaunch = false;
            $scope.init();
            $scope.parseDeviceData(response["data"]);
            dismissLoadingBar(REQUEST.EDIT_TODO_LIST);
            SHPService.loadingFinished();
        }
        if (response['requestToken'] === REQUEST.GET_PROFILE) {
            console.log(" Profile Data Recieved", response);
            if ($scope.profileData.length > 0) {
                $scope.profileData = [];
            }
            fillProfileData(response["data"]);
            dismissLoadingBar(REQUEST.GET_PROFILE);
            SHPService.loadingFinished();
        }
        else if (response['requestToken'] === REQUEST.EDIT_TODO) {
            $scope.parseDeviceData(response['data']);
            dismissLoadingBar(REQUEST.EDIT_TODO);
        }
        else if (response['requestToken'] === REQUEST.ADD_TODO) {
            $scope.parseDeviceData(response['data']);
            dismissLoadingBar(REQUEST.ADD_TODO);
        }
    }

    function requestProgressHandler(response) {

    }

    function showConnectionFailurePopup() {
        dismissLoadingBar('FAIL');
        $scope.dialogPopup.show = true;
        toggleBottomPopUpClass(true);
        $scope.dialogPopup.dialogPopupTitle = $scope.translation.WEBMOB_fhub2_common_connection_failure;
        $scope.dialogPopup.dialogPopupText = $scope.translation.WEBMOB_fhub2_common_check_power_and_network;
        $scope.dialogPopup.button1Title = $scope.translation.WEBMOB_fhub2_common_ok_capital;
        $scope.dialogPopup.button1Handler = function () {
            closeApp();
        };
    }

    function closeConnectionFailurePopup() {
        $scope.dialogPopup.show = false;
        toggleBottomPopUpClass(false);
    }

    function goToShopListHome() {
        initial_inputData();
        closeSelectedMode();
        clearModifyList();
        clearEventQueue();

        if (angular.isDefined($scope.groupId) && $scope.groupId !== "") {
            //Goto Detail Page from Dashboard.
            var groupId = $scope.groupId;
            $scope.groupId = "";
            showDetailScreen(groupId);
        }
        else {
            $scope.currentScreen = TODOLIST_SCREEN.HOME;
            changeScreen();
        }
    }

    function goToDetailPage() {
        $scope.currentScreen = TODOLIST_SCREEN.DETAIL_SCREEN;
        debugMessage('goToDetailPage - category: ' + $scope.inputData.groupId);
        $state.transitionTo('ToDoListDetailPage');
        changeScreen();
    }

    function showDetailScreenForCreateList() {
        if (isMaximum_TodoList()) {
            SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_to_do_add_list_max_lists.replace("#num#", $scope.MAX_LIST.toString()), "");
            return;
        }

        initial_inputData();
        closeSelectedMode();
        clearModifyList();
        $scope.inputData.category = createNewListTitle();

        // $scope.inputData.groupId = groupId = "20170522015858237";         //For demo test
        goToDetailPage();

        $timeout(function () {
            $("#addItem").focus();
        }, 300);
    }

    function showDetailScreen(groupId) {
        //prevent loop goToShopListHome()<->showDetailScreen()
        if (angular.isUndefined(groupId) || (angular.isDefined(groupId) && groupId === ""))
            return;

        if (angular.isUndefined($scope.Device.ShoppingList[groupId])) {
            debugMessage("showDetailScreen Undefined groupId = " + groupId);
            goToShopListHome();
            return;
        }
        else {
            debugMessage("showDetailScreen Defined groupId = " + groupId);
        }

        if ($scope.isSelectedMode) {
            return;
        }
        initial_inputData();
        closeSelectedMode();
        clearModifyList();
        clearEventQueue();
        $scope.inputData.groupId = groupId;

        goToDetailPage();
    }

    function onBackPressed() {
        debugMessage("onBackPressed");

        // if ($scope.modifyList.length !== 0 && ($scope.DetailPage && !$scope.isSelectedMode)) {
        //     $scope.eventQueue.push($scope.events.BACK_PRESSED);
        //     removeFocus();
        //     return;
        // } else {
            removeFocus();
        // }

        if ($scope.reNamePopup) {
            closeReNamePopup();
            return;
        }

        if ($scope.dialogPopup.show) {
            closeApp();
            return;
        }

        if ($scope.confirmationPopUpVisible) {
            closeConfirmationPopUp();
            return;
        }
        if ($scope.bOptionPopUp) {
            $scope.bOptionPopUp = false;
            return;
        }
        if ($scope.isSelectedMode && $scope.currentScreen === TODOLIST_SCREEN.DETAIL_SCREEN) {
            closeSelectedMode();
            return;
        }
        switch ($scope.currentScreen) {
            case TODOLIST_SCREEN.HOME:
                if ($scope.isSelectedMode) {
                    goToShopListHome();
                } else {
                    closeApp();
                }
                break;
            case TODOLIST_SCREEN.DETAIL_SCREEN:
                goToShopListHome();
                $scope.listItemChanged = false;
                //scrollListViewOnBackToHomePage();
                break;
            default:
                goToShopListHome();
                break;
        }
    }

    /**
     * @function
     * @private
     * @name closeLoadingBar
     * @description To close loading bar based on response
     */
    function closeLoadingBar() {
        $timeout(function () {
            $scope.checkResponse = [];
            $scope.loadingBar = false;
            $scope.isTransparent = false;
            SHPService.loadingFinished();
            runEventQueue();
        }, 0);
    }

    function dismissLoadingBar(value) {
        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            if ($scope.checkResponse.length === 0) {
                closeLoadingBar();
            }
            else {
                console.log($scope.checkResponse);
            }
        } else {
            if (value === 'FAIL') {
                $scope.checkResponse = [];
                $scope.loadingBar = false;
                $scope.isTransparent = false;
            }
        }
    }

    function runEventQueue() {
        while (angular.isDefined($scope.eventQueue) && $scope.eventQueue.length !== 0) {
            clearModifyList();
            var task = $scope.eventQueue.shift();
            switch (task) {
                case $scope.events.BACK_PRESSED:
                    onBackPressed();
                    break;
                case $scope.events.SHOW_OPTION_POPUP:
                    showOptionPopup();
                    break;
            }
        }
    }

    function clearEventQueue() {
        if (angular.isDefined($scope.eventQueue) && $scope.eventQueue.length !== 0)
            $scope.eventQueue = [];
    }

    function toggleBottomPopUpClass(popupName) {
        if (popupName) {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivIn";
            $scope.BottomPopupDivCls = "BottomPopupBGIn";
        } else {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivOut";
            $scope.BottomPopupDivCls = "BottomPopupBGOut";
        }
    }

    function closeApp() {
        SHPService.sendNativeCommand(REQUEST.CLOSE_WEB_APP, "", "");
    }

    $scope.$watch(function () {return document.body.clientHeight;}, function (newValue, oldValue) {
        console.log("watch:::View Size is changed = " + oldValue + " to " + newValue);
    }, true);

    function removeFocus() {
        debugMessage("removeFocus:::");
        document.activeElement.blur();
        SHPService.sendNativeCommand(REQUEST.CLOSE_KEYPAD, REQUEST.CLOSE_KEYPAD, "");
    }

    function getTodoListCount() {
        if (angular.isUndefined($scope.Device.ShoppingList))
            return 0;
        return (Object.keys($scope.Device.ShoppingList).length);
    }

    $scope.isMaximum_TodoList = isMaximum_TodoList;
    function isMaximum_TodoList() {
        return (Object.keys($scope.Device.ShoppingList).length >= $scope.MAX_LIST);
    }

    $scope.isMaximum_TodoList_item = isMaximum_TodoList_item;
    function isMaximum_TodoList_item(groupId, addItemCount) {
        if (angular.isDefined($scope.Device.ShoppingList[groupId]) && groupId !== '') {
            //$scope.Device.ShoppingList[groupId].length - 1 -> Todo index 0 is TodoList Info.
            return (($scope.Device.ShoppingList[groupId].items.length + addItemCount) > $scope.MAX_LIST_ITEM);
        }
        else
            return addItemCount > $scope.MAX_LIST_ITEM;
    }

    $scope.bindTouchEventForTextArea = bindTouchEventForTextArea;
    function bindTouchEventForTextArea() {
        if ($scope.isAppleDevice) {
            console.log('^_______________^',$('textarea'));
            $('textarea').bind({
                touchend: function (event) {
                    console.log("touchend = ", event);
                    event.preventDefault();
                }
            });
        }
    }

    $scope.$on('ngRepeatFinishedForItems', function () {
        console.log('ngRepeatFinishedForItems', $scope.inputData.groupId);
        if (angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId])) {
            $scope.Device.ShoppingList[$scope.inputData.groupId].items.forEach(function (item) {
                resizeTextArea(item.id);
            });
        }
        bindTouchEventForTextArea();
    });

    /** Starts Check For the modified input fields **/
    function clearModifyList() {
        $scope.modifyList = [];
    }

    function isAdded(item) {
        for (var i = 0; i < $scope.modifyList.length; i++) {
            if ($scope.modifyList[i].id === item.id) {
                return true;
            }
        }
        return false;
    }

    function addModifyItem(item) {
        // console.log("addModifyItem");
        if (!isAdded(item))
            $scope.modifyList.push(item);
    }

    function removeModifyItem(item) {
        $scope.modifyList.forEach(function (modifyItem, index) {
            if (modifyItem.id === item.id)
                $scope.modifyList.splice(index, 1);
        });
    }

    function getModifyItem(id) {
        for (var i = 0; i < $scope.modifyList.length; i++) {
            if ($scope.modifyList[i].id === id)
                return $scope.modifyList[i];
        }
        return undefined;
    }

    /** Ends Check For the modified input fields **/

    $scope.moveScroll = moveScroll;
    function moveScroll(elementId) {
        if (angular.isUndefined(elementId) || angular.isUndefined($('#' + elementId)) || window.navigator.platform === 'iPhone') {
            console.log("moveScroll::: isUndefined itemId = " + elementId);
            return;
        }
        console.log("moveScroll::: isDefined itemId = " + elementId);

        var position = 0;
        if (elementId.indexOf('list_') !== -1) {
            var initTopPosition = $('.scroll_area').offset().top;
            console.log('screen View Height = ' + document.body.clientHeight);
            console.log('initTopPosition = ' + initTopPosition);
            if (angular.isDefined($('#' + elementId).offset()) && angular.isDefined($('#' + elementId).offset().top)) {
                console.log("$('#'" + elementId + ").offset().top = " + $('#' + elementId).offset().top);
                console.log("scrollTop = " + ($('#' + elementId).offset().top - initTopPosition));
                position = $('#' + elementId).offset().top - initTopPosition;
                // position = initTopPosition;
                // position = $('#' + elementId).offset().top / 2;
            }
        }
        else {
            return;
        }

        $timeout(function () {
            $('body').animate({
                    scrollTop: position
                },
                'slow');
        }, 10);
    }

    $scope.checkElement = checkElement;
    function checkElement(element, maxCharacter) {
        if (angular.isDefined(element)) {
            var previewItem = getModifyItem(element.id);
            if (angular.isDefined(previewItem) && element.value.length > maxCharacter) {
                if (element.id === 'addItem')
                    $scope.inputData.name = element.value = previewItem.prevText;
                // else if (element.id.indexOf('list_') !== -1) {
                //     var itemId = element.id.split("_")[1];
                //     var index = $scope.Device.ShoppingList[$scope.inputData.groupId].items.map(function (item) {return item.id;}).indexOf(itemId);
                //     $scope.Device.ShoppingList[$scope.inputData.groupId][index] = element.value = previewItem.prevText;
                // }
                // else if (element.id === 'newlistTitleID')
                //     $scope.inputData.category = element.value = previewItem.prevText;

                SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_common_max_characters, "");
            }
        }
    }

    $scope.clearText = clearText;
    function clearText(element_id) {
        if ($scope.reNamePopup) {
            $scope.inputData.category = "";
        }
        else if ($scope.currentScreen === TODOLIST_SCREEN.DETAIL_SCREEN) {
            $scope.inputData.name = "";
        }

        $timeout(function () {
            if (angular.isDefined(element_id) && element_id !== null) {
                var element = $('#' + element_id);
                if (angular.isDefined(element) && element !== null) {
                    element.focus();
                }
            }
        }, 0);
    }

    $scope.changeHandler = changeHandler;
    function changeHandler(element_id ,ngModel, max_character) {
        console.log("changeHandler:::", element_id, ngModel, max_character);

        if (element_id.indexOf('list_') !== -1)
            resizeTextArea(element_id.split('list_')[1]);

        if (angular.isUndefined(ngModel) || (angular.isDefined(ngModel) && ngModel.length > max_character)) {
            removeFocus();
        }

        var previewItem = getModifyItem(element_id);
        if (angular.isDefined(previewItem) && ngModel.length <= max_character) {
            previewItem.prevText = ngModel;
        }
    }

    $scope.focusHandler = focusHandler;
    function focusHandler(event) {
        debugMessage("****focusHandler****");
        if ($scope.loadingBar || !$scope.DetailPage || $scope.isSelectedMode) {
            // document.getElementById(event.target.id).blur();
            console.log("focusHandler::: Remove Focused  id = " + event.target.id);
            removeFocus();
            return;
        }

        // debugMessage("****focusHandler::: data = " + event.target.value);
        // console.log(event);
        debugMessage("****focusHandler::: event.target.id = " + event.target.id);
        if (angular.isDefined(event.target.id) && event.target.id !== '' && !getModifyItem(event.target.id)) {
            var item = {
                id: event.target.id,
                value: angular.isDefined(event.target.value) ? event.target.value : "",
                prevText: angular.isDefined(event.target.value) ? event.target.value : ""
            };

            addModifyItem(item);
            moveScroll(event.target.id);

            if (event.target.id.indexOf('list_') !== -1 && $scope.isAppleDevice) {
                $timeout(function () {
                    var len = document.getElementById(event.target.id).value.length;
                    document.getElementById(event.target.id).setSelectionRange(len, len);
                }, 0);
            }
        }
        console.log($scope.modifyList);
        console.log("***************************");
    }

    $scope.blurHandler = blurHandler;
    function blurHandler(event, max_character, updateItem) {
        debugMessage("####blurHandler::: event.target.id = " + event.target.id + " / data = " + event.target.value + " / data = " + event.target.value.length);
        var previewItem = getModifyItem(event.target.id);
        event.stopPropagation();
        event.preventDefault();

        if ($scope.loadingBar) {
            if (angular.isDefined(previewItem))
                removeModifyItem(previewItem);
            if (angular.isDefined(event.target.id) && event.target.id === 'addItem') {
                event.target.value = "";
            }
            return;
        }

        if (angular.isDefined(event.target.value) && angular.isDefined(previewItem) && previewItem.id === event.target.id) {
            //Check Max Character
            if (previewItem.value !== event.target.value) {
                if (angular.isDefined(max_character) && event.target.value.length > max_character && (event.keyCode !== ENTER_KEYCODE && event.keyCode !== 8)) {
                    event.preventDefault();
                    $timeout(function () {
                        removeFocus();
                    }, 0);
                    console.log("blurHandler:::Check Max Character - prevTest = ", previewItem.prevText);
                    event.target.value = previewItem.prevText;
                    if (angular.isDefined(event.target.id)) {
                        if (angular.isDefined(updateItem) && event.target.id === 'list_' + updateItem.id) {
                            updateItem.name = event.target.value;
                            resizeTextArea(updateItem.id);
                        }
                        if (event.target.id === 'listTitle') {
                            $scope.inputData.category = event.target.value;
                        }
                        else if (event.target.id === 'addItem') { 
                            $scope.inputData.name = event.target.value;
                        }
                    }
                    SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_common_max_characters, "");
                }
            }

            if (previewItem.value !== event.target.value) {
                //Save contents(Edit Item)
                if (angular.isDefined(updateItem) && event.target.id === 'list_' + updateItem.id) {
                    if (isEmptyString(event.target.value)) {
                        //if all fields are empty, remove item.
                        deleteToDoItemCommand(updateItem);
                    }
                    else {
                        //Updated the item of list
                        editShoppingListItemCommand(updateItem);
                    }
                }
            }
            removeModifyItem(previewItem);
        }
        // console.log($scope.modifyList);
        console.log("#############################");
    }

    function resizeTextArea(id) {
        $(document).ready(function () {
            try {
                console.log("resizeTextArea::: id = ", id);
                var element = document.getElementById('list_' + id);
                var ele = $('#list_' + id);
                if (angular.isDefined(element) && angular.isDefined(ele)) {
                    console.log('resizeTextArea::: scrollHeight = ', element.scrollHeight, "scrollTop = ", element.scrollTop, "clientHeight = ", element.clientHeight, "offsetHeight = ", element.offsetHeight);
                    console.log('resizeTextArea::: scrollHeight - scrollTop = ', element.scrollHeight - element.scrollTop);
                    var wrap_scrollWidth = element.scrollWidth;
                    ele.addClass('nowrap');
                    var nowrap_clientWidth = element.scrollWidth;
                    ele.removeClass('nowrap');

                    console.log(nowrap_clientWidth, wrap_scrollWidth);
                    if (nowrap_clientWidth <= wrap_scrollWidth) {   //1 line
                        console.log('resizeTextArea::: min-height = ' + ele.css('min-height'));
                        element.style.height = ele.css('min-height');
                        console.log('resizeTextArea::: isMultiLine = ' + false);
                    }
                    else {
                        element.style.height = 'auto';
                        element.style.height = element.scrollHeight + 'px';
                        console.log('resizeTextArea::: isMultiLine = ' + true);
                    }
                }
                else {
                    // console.log('resizeTextArea::: Undefined id = ' + id);
                }
            } catch (err) {
                console.log('resizeTextArea::: id = ' + id, err);
            }
        });
    }

    function keyupHandler(event, max_character, type) {
        console.log("keyupHandler ("+ type +"):::", event.target.value, event.target.value.length, ' /keyCode: ' + event.keyCode);
        if (angular.isUndefined(event))
            return;

        if (event.target.id === 'addItem')
            $scope.inputData.name = event.target.value;
        else if (event.target.id === 'listTitle')
            $scope.inputData.category = event.target.value;
        else if (event.target.id.indexOf('list_') !== -1) {
            resizeTextArea(event.target.id.split('list_')[1]);
        }

        if (event.target.value.length > max_character && (event.keyCode !== ENTER_KEYCODE && event.keyCode !== 8)) {
            removeFocus();
        }

        var previewItem = getModifyItem(event.target.id);
        if (angular.isDefined(previewItem) && event.target.value.length <= max_character && (event.keyCode !== ENTER_KEYCODE && event.keyCode !== 8)) {
            previewItem.prevText = event.target.value;
        }

        if (event.keyCode === ENTER_KEYCODE) {
            event.target.value = event.target.value.replace(/\n/g, '').trim();
            removeFocus();

            if(event.target.id === 'addItem' && !isEmptyString($scope.inputData.name))
                addShoppingListItemCommand();
        }
    }

    function addShoppingListTitleCommand(groupId, category, sendPush) {
        if (angular.isUndefined(groupId) || groupId === "")
            return;

        console.log('addShoppingListTitleCommand::: category= ' + category);
        if (angular.isUndefined(category) || category.trim() === "")
            category = createNewListTitle();
        else if (category.trim().length > $scope.MAX_CHARACTER_TITLE)
            category = category.trim().substr(0, $scope.MAX_CHARACTER_TITLE);
        else
            category = category.trim();

        var payload = {
            "TodoList": [
                {
                    groupId: groupId,
                    category: encodeEscape(category),
                    isNewlyAdded: true,
                    isDefault: false,
                    userId: angular.isDefined($scope.userId)? $scope.userId : "",
                    familyId: "",
                    order: groupId
                }
            ],
            sendPush : (angular.isDefined(sendPush) && sendPush !== null)? sendPush : true
        };

        console.log("TodoList payload ", payload);
        $scope.isTransparent = true;        //for Transparent dim screen.
        $scope.checkResponse.push(REQUEST.ADD_TODO_LIST);
        SHPService.sendNativeCommand(REQUEST.ADD_TODO_LIST, payload, REQUEST.ADD_TODO_LIST);
    }

    function addShoppingListItemCommand() {
        console.log("addShoppingListItemCommand ");
        removeFocus();
        checkElement($('#addItem')[0], $scope.MAX_CHARACTER_ITEM);
        if ($scope.inputData.name.trim().length === 0)
            return;

        if (angular.isUndefined($scope.inputData.groupId) || $scope.inputData.groupId === "") {
            $scope.inputData.groupId = timeStamp.getDateFormat(new Date(), 'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");
            addShoppingListTitleCommand($scope.inputData.groupId, $scope.inputData.category, false);
        }

        if (angular.isDefined($scope.inputData.groupId) && $scope.inputData.groupId !== "") {
            if (angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId]) && isMaximum_TodoList_item($scope.inputData.groupId, 1)) {
                removeFocus();
                SHPService.sendNativeCommand(REQUEST.SHOW_TOAST, $scope.translation.WEBMOB_fhub2_shopping_list_add_max_items.replace("#num#", $scope.MAX_LIST_ITEM.toString()), "");
                return;
            }

            //prevented that id is duplicated with groupId.
            var currentLocalDate = new Date();
            currentLocalDate.setTime(currentLocalDate.getTime() + 1);
            var id = timeStamp.getDateFormat(currentLocalDate, 'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");


            if ($scope.inputData.name.trim().length > $scope.MAX_CHARACTER_ITEM)
                $scope.inputData.name = $scope.inputData.name.trim().substr(0, $scope.MAX_CHARACTER_ITEM);
            else
                $scope.inputData.name = $scope.inputData.name.trim();

            var payload = {
                "Todo": [
                    {
                        "groupId": $scope.inputData.groupId,
                        "id": id,
                        "name": encodeEscape($scope.inputData.name),
                        "itemStatus": "1",
                        "inputDate": timeStamp.getDateFormat(new Date(), 'yyyy-MM-ddTHH:mm:ss', 'UTC'),
                        "order": timeStamp.getDateFormat(new Date(), 'yyyyMMddHHmmss sss', 'UTC').replace(" ", ""),
                        "isNewlyAdded": true
                    }
                ]
            };

            console.log("Todo payload ", payload);
            $scope.isTransparent = true;        //for Transparent dim screen.
            $scope.checkResponse.push(REQUEST.ADD_TODO);
            SHPService.sendNativeCommand(REQUEST.ADD_TODO, payload, REQUEST.ADD_TODO);

            $scope.inputData.name = "";
        }
    }

    function editShoppingListTitleCommand(groupId, editCategory) {
        var list = $scope.Device.ShoppingList[groupId];
        if (angular.isUndefined(list))
            return;

        if (angular.isUndefined(editCategory) || editCategory.trim() === "")
            editCategory = createNewListTitle();
        else if (editCategory.trim().length > $scope.MAX_CHARACTER_TITLE)
            editCategory = editCategory.trim().substr(0, $scope.MAX_CHARACTER_TITLE);
        else
            editCategory = editCategory.trim();

        var payload = {
            "TodoList": [
                {
                    "category": encodeEscape(editCategory),
                    "groupId": list.groupId,
                    "isDefault": list.isDefault,
                    "userId": list.userId,
                    "order": list.order,
                    "isNewlyAdded": list.isNewlyAdded
                }
            ]
        };

        // Request for itemsStatus to be updated on Edit page
        $scope.isTransparent = true;        //for Transparent dim screen.
        $scope.checkResponse.push(REQUEST.EDIT_TODO_LIST);
        SHPService.sendNativeCommand(REQUEST.EDIT_TODO_LIST, payload, REQUEST.EDIT_TODO_LIST);
        closeReNamePopup();
    }

    function editShoppingListItemCommand(item) {
        if (angular.isUndefined(item))
            return;

        console.log("editShoppingListItemCommand::: item.id = " + item.id);
        if (item.name.trim().length > $scope.MAX_CHARACTER_ITEM)
            item.name = item.name.trim().substr(0, $scope.MAX_CHARACTER_ITEM);
        else
            item.name = item.name.trim();

        var payload = {
            "Todo": [
                {
                    "groupId": item.groupId,
                    "id": item.id,
                    "name": encodeEscape(item.name),
                    "itemStatus": item.itemStatus,
                    "inputDate": timeStamp.getDateFormat(new Date(),'yyyy-MM-ddTHH:mm:ss', 'UTC'),
                    "order": item.order,
                    "isNewlyAdded": item.isNewlyAdded

                }
            ]
        };

        console.log("editShoppingListTitleCommand:::" + JSON.stringify(payload));
        // Request for itemsStatus to be updated on Edit page
        $scope.isTransparent = true;        //for Transparent dim screen.
        $scope.checkResponse.push(REQUEST.EDIT_TODO);
        SHPService.sendNativeCommand(REQUEST.EDIT_TODO, payload, REQUEST.EDIT_TODO);
    }

    function isCheckedItem(item) {
        if (item.itemStatus.toString() === "1")
            return false;
        else if (item.itemStatus.toString() === "2")
            return true;
        else
            return false;
    }

    function updateItemStatusCommand(item) {
        if (angular.isUndefined(item))
            return;

        console.log("updateItemStatusCommand::: itemStatus = " + item.itemStatus);
        var payload = {
            "Todo": [
                {
                    "groupId": item.groupId,
                    "id": item.id,
                    "name": encodeEscape(item.name),
                    "itemStatus": isCheckedItem(item) ? "1" : "2",   //change check status(1: unchecked, 2: checked)
                    "inputDate": item.inputDate,
                    "order": timeStamp.getDateFormat(new Date(), 'yyyyMMddHHmmss sss', 'UTC').replace(" ", ""),
                    "isNewlyAdded": item.isNewlyAdded

                }
            ]
        };

        // Request for itemsStatus to be updated on Edit page
        $scope.isTransparent = true;        //for Transparent dim screen.
        $scope.checkResponse.push(REQUEST.EDIT_TODO);
        SHPService.sendNativeCommand(REQUEST.EDIT_TODO, payload, REQUEST.EDIT_TODO);
    }

    function deleteToDoListCommand() {
        var TodoList_payload = "/foodmanager/todolist/?groupId=";
        var TodoItem_payload = "/foodmanager/todo/?id=";

        var listsId = "";
        var itemsId = "";
        $scope.selectedItems.forEach(function (deleteList) {
            if (angular.isDefined(deleteList.groupId) && deleteList.groupId !== '') {
                listsId += deleteList.groupId + ",";

                if (angular.isDefined($scope.Device.ShoppingList[deleteList.groupId]) &&
                    angular.isDefined($scope.Device.ShoppingList[deleteList.groupId].items)) {
                    var listData = $scope.Device.ShoppingList[deleteList.groupId];
                    for (var itemIdx = 0; itemIdx < listData.items.length; itemIdx++) {
                        if (angular.isDefined(listData.items[itemIdx].id) && listData.items[itemIdx].id !== '')
                            itemsId += listData.items[itemIdx].id + ",";
                    }
                }
            }
        });

        if (itemsId !== "") {
            $scope.checkResponse.push(REQUEST.DELETE_TODO);
            // console.log("DeleteTodoItem = " + TodoItem_payload + itemsId.slice(0, -1));
            SHPService.sendNativeCommand(REQUEST.DELETE_TODO, TodoItem_payload + itemsId.slice(0, -1) + '&sendPush=false', REQUEST.DELETE_TODO);
        }

        if (listsId !== "") {
            $scope.checkResponse.push(REQUEST.DELETE_TODO_LIST);
            // console.log("DeleteTodoList = " + TodoList_payload + listsId.slice(0, -1));
            SHPService.sendNativeCommand(REQUEST.DELETE_TODO_LIST, TodoList_payload + listsId.slice(0, -1) + '&sendPush=true', REQUEST.DELETE_TODO_LIST);
        }

        closeConfirmationPopUp();
        goToShopListHome();
    }

    function deleteToDoItemCommand(item) {
        if (angular.isDefined(item.id) && item.id !== '') {
            var TodoItem_payload = "/foodmanager/todo/?id=" + item.id;

            $scope.isTransparent = true;        //for Transparent dim screen.
            $scope.checkResponse.push(REQUEST.DELETE_TODO);
            console.log("delete todolist items ", TodoItem_payload);
            SHPService.sendNativeCommand(REQUEST.DELETE_TODO, TodoItem_payload + '&sendPush=true', REQUEST.DELETE_TODO);
        }
    }

    function deleteToDoItemsCommand() {
        var TodoItem_payload = "/foodmanager/todo/?id=";
        var itemsId = "";
        $scope.selectedItems.forEach(function (deleteItem) {
            if (angular.isDefined(deleteItem.id) && deleteItem.id !== '')
                itemsId += deleteItem.id + ",";
        });

        if (itemsId !== "") {
            $scope.checkResponse.push(REQUEST.DELETE_TODO);
            console.log("delete todolist items ", TodoItem_payload);
            SHPService.sendNativeCommand(REQUEST.DELETE_TODO, TodoItem_payload + itemsId.slice(0, -1) + '&sendPush=true', REQUEST.DELETE_TODO);
        }

        closeConfirmationPopUp();
        closeSelectedMode();
        showDetailScreen($scope.inputData.groupId);
    }

    function cancelButtonPressedFromMultiSelect() {
        goToShopListHome();
    }

    function createNewListTitle() {
        return decodeHtmlEntity($scope.translation.WEBMOB_fhub2_to_do_create_new_title);
    }

    $scope.isEmptyString = isEmptyString;
    function isEmptyString(str) {
        if (!angular.isDefined(str) || angular.isUndefined(str))
            return true;
        //debugMessage('isEmptyString:::isEmptyString = ' + str + " / return = " + str.trim() === '');
        // console.log('isEmptyString:::isEmptyString = ' + str + " / result = " + str.trim() === '');
        return str.trim() === '';
    }

    function isEmpty(obj) {
        return Object.keys(obj).length === 0;
    }

    $scope.isScreenScrollable = isScreenScrollable;
    function isScreenScrollable() {
        try {
            if ($scope.loadingBar || $scope.bOptionPopUp || $scope.dialogPopup.show ||
                $scope.confirmationPopUpVisible) {
                return false;
            }
            else {
                return true;
            }
        } catch(err) {
            debugMessage("[ERR]isScreenScrollable:::", err);
            return true;
        }
    }

    function closeOptionPopup() {
        $scope.bOptionPopUp = false;
    }

    function showOptionPopup() {
        // if ($scope.modifyList.length !== 0) {
        //     $scope.eventQueue.push($scope.events.SHOW_OPTION_POPUP);
            removeFocus();
        //     return;
        // }

        $scope.bOptionPopUp = true;
    }

    $scope.reNamePopup = false;
    $scope.showReNamePopup = showReNamePopup;
    $scope.closeReNamePopup = closeReNamePopup;
    $scope.saveListTitle = saveListTitle;

    function showReNamePopup(groupId) {
        if (isDefinedList(groupId) && $scope.Device.ShoppingList[groupId].isDefault)
            return;
        $scope.reNamePopup = true;
        $scope.inputData.category = $scope.getTitle(groupId);

        $timeout(function () {
            console.log('showReNamePopup:::listTitle-focus, select');
            $("#listTitle").focus();
            document.getElementById('listTitle').setSelectionRange(0, $scope.inputData.category.length);
        }, 0);
    }
    function closeReNamePopup() {
        removeFocus();
        $scope.reNamePopup = false;
    }

    function saveListTitle(groupId, category) {
        if (angular.isUndefined(groupId) || groupId === null || groupId === "") {
            $scope.inputData.groupId = groupId = timeStamp.getDateFormat(new Date(), 'yyyyMMddHHmmss sss', 'UTC').replace(" ", "");
            addShoppingListTitleCommand(groupId, category, true);
        }
        else {
            editShoppingListTitleCommand(groupId, category);
        }
        closeReNamePopup();
    }

    function closeConfirmationPopUp() {
        $scope.confirmationPopUpVisible = false;
    }

    function showConfirmationPopUp() {
        $scope.confirmationPopUpVisible = true;
        //$scope.custpopuptextString = "";
    }

    function onCancelConfirmationPopUp() {
        closeConfirmationPopUp();
    }

    function onOkConfirmationPopUp() {
        closeConfirmationPopUp();
    }

    function onCancelConfirmationAddEditPopUp() {
        closeConfirmationPopUp();
    }

    function longPressOnItemFromHomePage(items, optionMenuindex) {
        selectIndexFromOptionMenu(items, optionMenuindex, true);
    }

    function selectIndexFromOptionMenu(selectOption, item) {
        var checkForDefaultList = true;
        switch (selectOption) {
            case 'deleteList':
                if(angular.isDefined(item) && !item.isDefault){
                    checkForDefaultList = false;
                }
            case 'deleteItem' :
                $scope.inputData.name = "";
                if ($scope.currentScreen === TODOLIST_SCREEN.DETAIL_SCREEN) {
                    if (isToDoItemEmpty($scope.inputData.groupId)) {
                        return;
                    }
                    // toggleCheckList($scope.Device.ShoppingList[key]);
                    if (angular.isDefined(item))
                        setSelectedItems(item);
                    $scope.isSelectedMode = true;
                }
                else if ($scope.currentScreen === TODOLIST_SCREEN.HOME) {
                    if (getTodoListCount() <= defaultListCount()) {
                        return;
                    }
                    if (angular.isDefined(item) && angular.isDefined(item.isDefault) && item.isDefault === false)
                        setSelectedItems(item);
                    $scope.isSelectedMode = true;
                    if (checkForDefaultList) {
                        scrollListView();
                    }
                }
                break;
            default:
                break;
        }

        removeFocus();
        clearModifyList();
        closeOptionPopup();
    }

    function selectIndexFromMoreOptionMenu(optionMenuindex) {
        switch (optionMenuindex) {
            case 'deleteListItems':
                $scope.custpopuptextString = "";
                if ($scope.selectedItems.length > 1) {
                    $scope.custpopuptextString = $scope.translation.WEBMOB_fhub2_to_do_delete_items_popup_msg.replace('#num#', $scope.selectedItems.length.toString());
                } else {
                    $scope.custpopuptextString = $scope.translation.WEBMOB_fhub2_to_do_delete_item_popup_msg;
                }
                showConfirmationPopUp();
                //deleteToDoListCommand();
                break;
            case 'deleteList':
                $scope.custpopuptextString = "";
                if ($scope.selectedItems.length > 1) {
                    $scope.custpopuptextString = $scope.translation.WEBMOB_fhub2_to_do_delete_lists_popup_msg.replace('#num#', $scope.selectedItems.length.toString());
                } else {
                    $scope.custpopuptextString = $scope.translation.WEBMOB_fhub2_to_do_delete_list_popup_msg;
                }
                showConfirmationPopUp();
                //deleteToDoListCommand();
                break;
            default:
                break;
        }
        closeOptionPopup();
    }


    /*
     CheckBox Function for Delete
     */
    $scope.isSelectedMode = false;
    $scope.selectedItems = [];

    function closeSelectedMode() {
        $scope.isSelectedMode = false;
        $scope.currentSelectedMode = "";
        $scope.selectedMode_option = false;
        clearSelectedItems();
        removeFocus();
    }

    function resetSelectedMode() {
        closeConfirmationPopUp();
        clearSelectedItems();
    }

    function setSelectedItems(item) {
        debugMessage("setSelectedItems:::" + JSON.stringify(item));
        if (!isChecked(item))
            $scope.selectedItems.push(item);
    }

    function deleteSelectedItems(item) {
        debugMessage("deleteSelectedItems:::");
        $scope.selectedItems.forEach(function (selectedItem, index) {
            if (angular.isDefined(selectedItem) && angular.isDefined(item)) {
                if ($scope.currentScreen === TODOLIST_SCREEN.HOME &&
                    angular.isDefined(selectedItem.groupId) && angular.isDefined(item.groupId) &&
                    selectedItem.groupId === item.groupId) {
                    //selectMode of shoppingList
                    $scope.selectedItems.splice(index, 1);
                    // console.log("unChecking");
                }
                else if ($scope.currentScreen !== TODOLIST_SCREEN.HOME &&
                    angular.isDefined(selectedItem.id) && angular.isDefined(item.id) &&
                    selectedItem.id === item.id) {
                    //selectMode of items
                    $scope.selectedItems.splice(index, 1);
                    // console.log("unChecking");
                }
            }
        });
    }

    function clearSelectedItems() {
        debugMessage("clearSelectedItems:::");
        $scope.selectedItems = [];
    }

    function isCheckedItems() {
        // debugMessage("isCheckedItems:::");
        return ($scope.selectedItems.length > 0);
    }

    function toggleCheckList(item) {
        debugMessage("toggleCheckList:::");
        if (!isChecked(item))
            setSelectedItems(item);
        else
            deleteSelectedItems(item);
        isAllCheckBoxSelected();
    }

    function isChecked(item) {
        // debugMessage("isChecked:::" + JSON.stringify(item));
        for (var index = 0; index < $scope.selectedItems.length; index++) {
            var selectedItem = $scope.selectedItems[index];
            if (angular.isDefined(selectedItem) && angular.isDefined(item)) {
                if ($scope.currentScreen === TODOLIST_SCREEN.HOME &&
                    angular.isDefined(selectedItem.groupId) && angular.isDefined(item.groupId) &&
                    selectedItem.groupId === item.groupId) {
                    //selectMode of shoppingList
                    // debugMessage("isChecked:::" + selectedItem.groupId + " === " + item.groupId + ", "+(selectedItem.groupId === item.groupId));
                    return true;
                }
                else if ($scope.currentScreen !== TODOLIST_SCREEN.HOME &&
                    angular.isDefined(selectedItem.id) && angular.isDefined(item.id) &&
                    selectedItem.id === item.id) {
                    //selectMode of items
                    // debugMessage("isChecked:::" + selectedItem.id + " === " + item.id + ", " + (selectedItem.id === item.id));
                    return true;
                }
            }
        }

        return false;
    }

    $scope.checkBox = {isAll: false};
    function toggleSelectAllListCheckBox() {
        debugMessage("toggleSelectAllListCheckBox:::");
        if ($scope.checkBox.isAll)
            clearSelectedItems();
        else {
            if ($scope.currentScreen === TODOLIST_SCREEN.HOME) {
                $.each($scope.Device.ShoppingList, function (groupId, list) {
                    if (!list.isDefault)
                        setSelectedItems(list);
                });
            }
            else if ($scope.currentScreen !== TODOLIST_SCREEN.HOME) {
                $scope.Device.ShoppingList[$scope.inputData.groupId].items.forEach(function (item) {
                    setSelectedItems(item);
                });
            }
        }
        isAllCheckBoxSelected();
    }

    function isAllCheckBoxSelected() {
        if (!$scope.isSelectedMode)
            return false;
        // debugMessage("isAllCheckBoxSelected:::");
        if ($scope.currentScreen === TODOLIST_SCREEN.HOME && $scope.selectedItems.length === Object.keys($scope.Device.ShoppingList).length - defaultListCount()) {
            // debugMessage("checkBox.isAll = " + true + " / " + $scope.selectedItems.length + " / " + Object.keys($scope.Device.ShoppingList).length);
            $scope.checkBox.isAll = true;
            return true;
        }
        else if ($scope.currentScreen !== TODOLIST_SCREEN.HOME &&
            angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId]) && angular.isDefined($scope.Device.ShoppingList[$scope.inputData.groupId].items) &&
            $scope.selectedItems.length === $scope.Device.ShoppingList[$scope.inputData.groupId].items.length) {
            // debugMessage("checkBox.isAll = " + true + " / " + $scope.selectedItems.length + " / " + $scope.Device.ShoppingList[$scope.inputData.groupId].length);
            $scope.checkBox.isAll = true;
            return true;
        }
        else {
            // debugMessage("isAllCheckBoxSelected:::checkBox.isAll = " + false + " " + $scope.selectedItems.length);
            $scope.checkBox.isAll = false;
            return false;
        }
    }

    function defaultListCount() {
        var count = 0;
        $.each($scope.Device.ShoppingList, function (groupId, list) {
            if (list.isDefault)
                count++;
        });
        return count;
    }

    function isFocused(item) {
        // console.log('$("#list_'+item.id+'").is(":focus") : ' + $('#list_'+item.id).is(':focus'));
        return $('#list_' + item.id).is(':focus');
    }

    $scope.isToDoItemEmpty = isToDoItemEmpty;
    function isToDoItemEmpty(id) {
        if (angular.isDefined($scope.Device.ShoppingList[id]) && angular.isDefined($scope.Device.ShoppingList[id].items)) {
            if ($scope.Device.ShoppingList[id].items.length === 0)
                return true;
            else
                return false;
        }
        return true;
    }

    function encodeEscape(str) {
        if (angular.isDefined(str) && str !== "") {
            str = str.replace(/\n/g, "")
                .replace(/\r/g, "")
                .replace(/\t/g, "")
                .replace(/\b/g, "")
                .replace(/\f/g, "");
            return encodeURIComponent(str);
        }
        return "";
    }

    function decodeHtmlEntity(html) {
        var txt = document.createElement("textarea");
        txt.innerHTML = html;
        return txt.value.trim();
    }

    function decodeUnescape(str) {
        if (angular.isDefined(str) && str.length > 0 && str.trim() !== "") {
            try {
                str = decodeURIComponent(str);
                return decodeHtmlEntity(str);
            }
            catch (err) {
                console.log("In decodeUnescape Error::: str = " + str);
                console.log("err = " + JSON.stringify(err));
                return decodeHtmlEntity(str);
            }
        }
        return "";
    }

    function scrollListView() {
        console.log("scrollListView");
        var initTopPosition = $('.thumbnail_container_inline_block').offset().top;
        $('.content_div').animate({
                scrollTop: $(".no-opacity").offset().top - initTopPosition
            },
            'slow');
    }

    function scrollListViewOnBackToHomePage() {
        var tempPageScrollHeight = getTodoListCount() * 960;
        $('.content_div').animate({
                scrollTop: $('.thumbnail_container_inline_block').offset().top + tempPageScrollHeight
            },
            'slow');
    }

    function getImage (key) {
        if (angular.isDefined(imageCache) && angular.isDefined(imageCache.get(key))) {
            return imageCache.get(key);
        }
        return "";
    }

    function imageURL_Request (imageURL) {
        imageRequest.nativeRequest(imageURL);
    }
});

app.directive('endRepeatItems', ['$timeout', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit('ngRepeatFinishedForItems');
                });
            }
        }
    }
}]);
