/**
 * Created by jji.yeon on 2018-02-02.
 * Refer to Emart API ver 1.2.6 Document
 */
app.service('EmartAPIService', ['$http', '$timeout', 'timeStamp', 'imageCache', 'imageRequest', function ($http, $timeout, timeStamp, imageCache, imageRequest) {
    var servers = ["DEV", "STG", "QA", "PRD"];
    var sel_Server = servers[3];
    var benefitGrp1_url = "http://static.ssgcdn.com/ui/app/comm/benefit/#type#.png";
    var benefitGrp2_obanjang_url = "http://static.ssgcdn.com/ui/app/6001/icon/o_#type#.png";
    var benefitGrp2_url = "http://static.ssgcdn.com/ui/app/6001/icon/#type#.png";

    this.parseEmartResult = parseEmartResult;
    function parseEmartResult(responseData) {
        var data = responseData['data'];
        if (angular.isUndefined(data) || data === null)
            return;

        if (angular.isDefined(data['query']) && data['query'] !== null && data['query'] !== '') {
            //delete the saved item to save new info
            removeLocalStorageData(data['query']);
        }

        if (angular.isDefined(data['itemList']) && data['itemList'] !== null) {
            data['itemList'].forEach(function (item) {
                if (angular.isDefined(item.itemId) && item.itemId !== null && item.itemId !== '') {
                    setLocalStorageData(item.itemId, JSON.stringify(item));
                }
            });
        }
    }

    this.getBenefitGrp_img_url = function (groupNo, type) {
        if (angular.isDefined(type) && type !== null && type !== "" &&
            angular.isDefined(groupNo) && groupNo !== null && groupNo !== "") {
            var url = "";
            if (groupNo === '1') {
                url = benefitGrp1_url.replace('#type#', type);
            }
            else if (groupNo === '2') {
                url = benefitGrp2_url.replace('#type#', type);
            }
            else if (groupNo === '2_obanjang') {
                url = benefitGrp2_obanjang_url.replace('#type#', type);
            }

            return url;
        }

        return "";
    };

    this.getEmartItem = function (itemId) {
        var item = getLocalStorageData(itemId);
        if (angular.isDefined(item) && item !== null && item !== '') {
            item = JSON.parse(item);
        }
        return item;
    };

    this.setServer = function (server) {
        if (angular.isDefined(server) && (server === "DEV" || server === "STG" || server === "QA" || server === "PRD"))
            sel_Server = server;
        else
            sel_Server = "PRD";
    };

    this.EmartSearchRequest = function (query) {
        if (angular.isUndefined(query) || query === null || query === "")
            return;

        var url = "";
        switch (sel_Server) {
            case servers[0]: //DEV
                url = 'http://dev-m.apps.ssg.com';
                break;
            case servers[1]: //STG
                url = 'http://stg-m.apps.ssg.com';
                break;
            case servers[2]: //QA
                url = 'http://qa-m.apps.ssg.com';
                break;
            case servers[3]: //PRD
                url = 'http://m.apps.ssg.com';
                break;
            default:
                url = 'http://dev-m.apps.ssg.com';
                break;
        }
        var search_parameter = '/api/refrigerator/search/datas.ssg';
        var ts_value = timeStamp.getDateFormat(new Date(), 'yyyyMMddHHmmss');
        var cookie = "MOBIL_APP_NO=41;APP_INF=N|HH_FS";

        var request = {
            method: 'POST',
            url: url + search_parameter,
            contentType: "application/json",
            headers: {
            },
            params: {
                "ckwhere": "app_41"
            },
            data: {
                "common":{
                    "ts": ts_value,
                    "mobil_app_no": "41",
                    "apl_ver":"1.0.0",
                    "os_cd":"30"
                },
                "params":{
                    "apiVersion": "1.0.0",
                    "siteNo": "6001",
                    // "target": "mobile_item",
                    "target": "mobile",
                    "query": query
                }
            }
        };

        console.log("request::::" + JSON.stringify(request));
        console.log("request::::", request);

        $http(request).then(function successCallback(response) {
            console.log("successCallback::::" + JSON.stringify(response));
            console.log("successCallback::::", response);
            parseEmartResult(response.data);
        }, function errorCallback(response) {
            console.log("errorCallback::::" + JSON.stringify(response));
            console.log("errorCallback::::", response);
        });
    };
}]);