var LANG;
var isAppleDevice = false;
if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
    LANG = navigator.userLanguage || navigator.language;
    isAppleDevice = true;
} else {
    LANG = navigator.userAgent;
}
var isDBDownloadedJS = false;
var isCallFromReset = 0;
var energyResetDone = false;
var debugMode = true;
var initialLaunch = false;
var longPressTimer = null;
var userId;
function debugMessage(message) {
    if (debugMode) {
        console.log(message + " called from " + arguments.callee.caller.name);
    }
}
function iPhoneVersion() {
  var iHeight = window.screen.height;
  var iWidth = window.screen.width;
  if (iWidth === 320 && iHeight === 480) {
    return "4";
  }
  else if (iWidth === 375 && iHeight === 667) {
    return "6";
  }
  else if (iWidth === 414 && iHeight === 736) {
    return "6+";
  }
  else if (iWidth === 320 && iHeight === 568) {
    return "5";
  }
  else if (iHeight <= 480) {
    return "2-3";
  }
  return 'none';
}
angular.element(document).ready(function () {
    debugMessage("angular.element(document).ready*");
    setTimeout(function () {
        var scope = angular.element(document.getElementById("bodyTag")).scope();
        if (!!scope) {
            scope.switchON = 'I';
            scope.switchOff = 'O';
            if (LANG.toUpperCase().indexOf('EN') !== -1) {
                scope.switchON = 'ON';
                scope.switchOff = 'OFF';
            }
        }
    }, 1000);
});

//app.config(['$httpProvider', function ($httpProvider) {
//        $httpProvider.defaults.useXDomain = true;
//        delete $httpProvider.defaults.headers.common['X-Requested-With'];
//    }
//]);

app.constant('STCONST', {
    APP_NAME: 'SmartThings',
    GET: "GET",
    PUT: "PUT",
    POST: "POST",
    DELETE: "DELETE",
    RUNONNATIVE: "RUNONNATIVE",
    MAX_TIME_INTERVAL: 20000,
    MIN_TIME_INTERVAL: 1000,
    GET_DEVICES: "getDevices",
    STATUS_200: 200,
    STATUS_201: 201,
    STATUS_204: 204,
    STATUS_99000: 99000,
    STATUS_MINUS1: -1,
    STATUS_401: 401,
    STATUS_500: 500
});

app.constant('REQUEST', {
    CLOSE_WEB_APP: "closeWebApp",
    SHOW_TOAST: "showToast",
    CLOSE_KEYPAD: "endEditing",
    GET_CATEGORY_DB : "getCategoryDB",
    SEARCH_FOR_FOOD : "searchForFood",
    GOTO_CAMERA : "gotoCamera",
    GOTO_GALLERY : "gotoGallery",
    GOTO_STORE_SETTINGS : "gotoStoreSettings",
    SCAN_BARCODE : "SCAN_BARCODE",
    GET_FOOD_LIST : "getFoodlist",
    ADD_FOOD_LIST : "addFoodlist",
    EDIT_FOOD_LIST : "editFoodlist",
    DELETE_FOOD_LIST : "deleteFoodlist",
    GET_GLAZE_INFO : "getGlazeinfo",
    GET_MEMO: "getMemo",
    ADD_MEMO: "addMemo",
    GOTO_MEMO: "gotoMemo",
    DELETE_MEMO: "deleteMemo",
    GET_SHOPPING_LIST : "getShoppinglist",
    ADD_SHOPPING_LIST : "addShoppinglist",
    EDIT_SHOPPING_LIST : "editShoppinglist",
    DELETE_SHOPPING_LIST : "deleteShoppinglist",
    GET_PROFILE : "getProfile",
    GET_TODO_LIST : "getTodolist",
    ADD_TODO_LIST : "addTodolist",
    EDIT_TODO_LIST : "editTodolist",
    DELETE_TODO_LIST : "deleteTodolist",
    GET_TODO : "getTodo",
    ADD_TODO : "addTodo",
    EDIT_TODO : "editTodo",
    DELETE_TODO : "deleteTodo",
    CAL_REQUEST : "getCalendarsForFamily",
    PROFILE_REQUEST : "getProfile",
    GET_IMAGE_LIST : "getImagelist",
    GET_STORE_LIST: "getStoreList",
    FIND_DEALS: "findDeals",
    GET_WEEKLY_DEALS : "getWeeklyDeals",
    ADD_WEEKLY_DEALS: "addWeeklyDeals",
    DELETE_WEEKLY_DEALS: "deleteWeeklyDeals"
});

app.service("SHPService", function (STCONST, REQUEST) {
    var stopVar, initialTime, timeDiff, secondRequestFailed, isFacRac = false, isRange = false, isWallOvenCooktop = false, isOven = false;
    var stopVarArray = [];
    var scope = angular.element(document.getElementById("bodyTag")).scope();
    var _that = this;

    scope.isDBDownloaded = false;
    this.getDevice = function ($scope) {
        debugMessage("getDevice");
        // $scope.checkResponse.push(STCONST.GET_DEVICES);
        // this.sendSHPCommand(STCONST.GET, "/" + $scope.peerId + "/devices/0");
    };

    this.getFoodList = function ($scope) {
        debugMessage("getFoodList*");
        $scope.checkResponse.push(REQUEST.GET_GLAZE_INFO);
        this.sendNativeCommand(REQUEST.GET_GLAZE_INFO, {"pullServer":true}, REQUEST.GET_GLAZE_INFO);

        $scope.checkResponse.push(REQUEST.GET_CATEGORY_DB);
        this.sendNativeCommand(REQUEST.GET_CATEGORY_DB, "", REQUEST.GET_CATEGORY_DB, false);
    };

    this.getShoppingList = function ($scope) {
        debugMessage("getShoppingList*");
        $scope.checkResponse.push(REQUEST.GET_CATEGORY_DB);
        $scope.checkResponse.push(REQUEST.GET_GLAZE_INFO);
        $scope.checkResponse.push(REQUEST.GET_SHOPPING_LIST);
        $scope.checkResponse.push(REQUEST.GET_FOOD_LIST);

        this.sendNativeCommand(REQUEST.GET_CATEGORY_DB, "", REQUEST.GET_CATEGORY_DB, false);
        this.sendNativeCommand(REQUEST.GET_GLAZE_INFO, {"pullServer":false}, REQUEST.GET_GLAZE_INFO);
        this.sendNativeCommand(REQUEST.GET_SHOPPING_LIST, "", REQUEST.GET_SHOPPING_LIST, false);
        this.sendNativeCommand(REQUEST.GET_FOOD_LIST, "", REQUEST.GET_FOOD_LIST, false);

    };

    this.getTodoList = function ($scope) {
        debugMessage("getTodoList*");
        $scope.checkResponse.push(REQUEST.GET_PROFILE);
        $scope.checkResponse.push(REQUEST.GET_TODO_LIST);
        $scope.checkResponse.push(REQUEST.GET_TODO);
        
        this.sendNativeCommand(REQUEST.GET_PROFILE, "", REQUEST.GET_PROFILE, false);
        this.sendNativeCommand(REQUEST.GET_TODO_LIST, "", REQUEST.GET_TODO_LIST, false);
        this.sendNativeCommand(REQUEST.GET_TODO, "", REQUEST.GET_TODO, false);

    };
    
    this.getCalendarList = function ($scope) {
//        debugMessage("getCalendarList*");
            console.log("***********", $scope.profileData.length);
            if($scope.profileData.length === 0) {
                $scope.checkResponse.push(REQUEST.PROFILE_REQUEST);
                this.sendNativeCommand("getProfile", null, REQUEST.PROFILE_REQUEST);
           }
    };

    this.getDevices = function ($scope) {
        debugMessage("getDevices");
        // $scope.checkResponse.push(STCONST.GET_DEVICES);
        // this.sendSHPCommand(STCONST.GET, "/" + $scope.peerId + "/devices");
    };

    this.updateDeviceData = function ($scope, data) {
        debugMessage("updateDeviceData*");
        scope = $scope; //Lokesh -> sometimes scope is undefined in SHPService. So, specifically catching scope here. Please don't remove this statement. Checking for undefined would have bigger cost, so avoiding that.

        data = data.replace(/\\n/g, "\\n")
                .replace(/\\/g, '&#92;')
                .replace(/\\"/g, '&#34;')
                .replace(/\\'/g, '&#39;')
                .replace(/\\&/g, '&#38;')
                .replace(/\\%/g, '&#37;')
                .replace(/\\r/g, "\\r")
                .replace(/\\t/g, "\\t")
                .replace(/\\b/g, "\\b")
                .replace(/\\f/g, "\\f");
        // remove non-printable and other non-valid JSON chars
        data = data.replace(/[\u0000-\u0019]+/g, "");

        try {
            if (data.indexOf("getImagelist") !== -1 || data.indexOf("gotoCamera") !== -1 || data.indexOf("gotoGallery") !== -1)
                console.log('Response[ImageList] ::: ', JSON.parse(data));
            else
                console.log('Response ::: ' + data);

            var response = JSON.parse(data);
        }
        catch(err) {
            console.log("ParseError:::" + data);
            console.log(err);
        }

        //console.log(JSON.stringify(response));
        if (response["type"] === "progress" && ($scope.isShopping || $scope.isFoodReminder || $scope.isTodo)) {
            //Reset initialTime for delay loading Time
            initialTime = new Date();
            $scope.requestProgressHandler(response);
            return;
        }
        else if (response["type"] === "requestResponse") {
            if (angular.isDefined(response["status"]) && response["status"] === STCONST.STATUS_99000) {
                showConnectionFailurePopup();
            }

            if (response["status"] === STCONST.STATUS_500 && ($scope.isShopping || $scope.isFoodReminder || $scope.isTodo || $scope.isCalendarApp)) {
                $scope.requestFailHandler(response);
            }

            if((response["status"] === STCONST.STATUS_200 || response["status"] === STCONST.STATUS_201 || response["status"] === STCONST.STATUS_204) && $scope.isCalendarApp) {
                console.log(" app.js requestResponseHandler response ", response);
                $scope.requestResponseHandler(response);
                return;
            }

            if ((response["status"] === STCONST.STATUS_200 || response["status"] === STCONST.STATUS_201 || response["status"] === STCONST.STATUS_204)) {
                $scope.requestResponseHandler(response);
                return;
            }

        }

        // Notification handling
        else if (response["type"] === "notification") {

            if (angular.isDefined(response["data"])) {

                if (response["data"] === "backPressed") {
                    //if loding bar visible, don't handle back key
                    if (!!!$scope.loadingBar) {
                        $scope.onBackPressed();
                    }
                    return;
                }

                $scope.parseDeviceData(response["data"]);
            }
        }
        else if (response["type"] === "initial") {
            initialLaunch = true;
            $scope.userId = response["userId"];
            var localStorage_userId = getLocalStorageData('userId');
            if (angular.isDefined(localStorage_userId) && localStorage_userId !== null && localStorage_userId !== "") {
                if (localStorage_userId !== $scope.userId) {
                    clearLocalStorageData();        //if user is changed, clear all the saved local data.
                    setLocalStorageData("userId", $scope.userId);
                }
            }
            if (angular.isDefined(response["countryCode"])) {
                $scope.countryCode = response["countryCode"].toString().toUpperCase();
            }
            if (angular.isDefined(response["lcdSpec"])) {
                $scope.lcdSpec = response["lcdSpec"];
                if (angular.isDefined($scope.parseLcdSpec)) {
                    $scope.parseLcdSpec($scope.lcdSpec["applications"]);
                }
            }
            $scope.dateTimeFormat = response["dateTimeFormat"];
            $scope.dateFormat = response["dateFormat"];
            $scope.timeFormat = response["timeFormat"];
            if (angular.isDefined(response["groupId"])) {
                $scope.groupId = response["groupId"];
            }
            if (angular.isDefined(response["errorCode"])) {
                $scope.demoErrorCode = response["errorCode"];
            }
            if (angular.isDefined(response["platform"]) && angular.isDefined(response["OSVersion"])) {
                if ((response["platform"] === "Android" && response["OSVersion"] > 20) || (response["platform"] === "iOS" && response["OSVersion"] > 8)) {
                    $scope.isAnimSupport = true;
                } else {
                    $scope.isAnimSupport = false;
                }
                // If platform is Android, OS version is >= 21, app version 2.0 then show status bar
                // If platform is iOS, app version 2.0 then show status bar
                if (angular.isDefined(response["appVersion"]) && response["appVersion"] === "2.0") {
                    if (response["platform"] === "Android") {
                       if (response["OSVersion"] >= 21) {
                           $scope.isAppV2 = true;
                       }
                    } else {
                        $scope.isAppV2 = true;
                    }
                }
            }
            if (!!response["demoMode"]) {
                $scope.isStatic = true;
                $scope.parseStaticData();
            } else {
                this.callGetDevice($scope);
            }

        }
        else if (response["type"] === "requestFailed") {
            $scope.requestFailHandler(response);
        } else if (response["type"] === "requestAccepted") {
            if (angular.isDefined(response["isSuccess"])) {
                $scope.parseDeviceData(response);
            } else if ($scope.isFoodReminder || $scope.isShopping || $scope.isTodo || $scope.isCalendarApp) {
                return;
            } else {
                //DO Nothing
            }

        } else if (response["type"] === "requestDenied") {
            //debugMessage("request Denied!!!!!!!!!!");
            if (response["error"] === "ENERGY_DB_DOES_NOT_EXIST") {
                $scope.fetchDBfromDevice();
            } else {
                $scope.requestFailHandler(response);
            }
        }
        else if (response["type"] === "connectionerror") {
            showConnectionFailurePopup();
        } else {
            // Nothing
        }

        this.loadingFinished();
        secondRequestFailed = false;
    };

    this.callGetDevice = function ($scope) {
        debugMessage("callGetDevice");
        var locationUri = window.location.href;
        if (locationUri.indexOf('food_reminder') !== -1) {
            $scope.isFoodReminder = true;
            this.getFoodList($scope);

        } else if ((locationUri).indexOf("shopping") !== -1) {
            $scope.isShopping = true;
            this.getShoppingList($scope);

        } else if ((locationUri).indexOf("todo") !== -1) {
            $scope.isTodo = true;
            this.getTodoList($scope);
        } else if ((locationUri).indexOf("calendar") !== -1) {
            $scope.isCalendarApp = true;
            console.log("<- app callGetDevice ->");
            this.getCalendarList($scope);
        } else {
            //debugMessage("Get device called initial");
            this.getDevice($scope);
        }
    };

    this.getSHPData = function (device_type) {
        debugMessage("getSHPData");
        var deviceResponseRef = '{"Device":{"Alarms":[],"Doors":[{"id":"0","name":"Freezer","openState":"Close"},{"id":"1","name":"Fridge","openState":"Close"},{"id":"2","name":"Midroom","openState":"Close"}],"Fridge":{"filterState":"2","rapidFreezing":"On","rapidFridge":"On"},"InformationLink":{"href":"/devices/0/information"},"Mode":{"modes":["CV_TTYPE_COOL", "CHEFMODE_OFF"],"supportedModes":["CV_COOL","CV_CHILL","CV_SOFT_FREEZER","CV_FREEZER", "CHEFMODE_ON", "CHEFMODE_OFF"]},"Temperatures":[{"current":-20.0,"desired":-18.0,"id":"0","name":"Freezer","unit":"Celsius"},{"current":2.0,"desired":1.0,"id":"1","name":"Fridge","unit":"Celsius"}],"connected":true,"description":"15K_REF_LCD_T9000","id":"0","name":"Refrigerator","resources":["Information","Temperatures","Doors","Fridge","Mode","Alarms"],"type":"Refrigerator","uuid":"54880EAF-A437-0000-0000-000000000000"}}';
        if (device_type === JSON.parse(deviceResponseRef)["Device"].type) {
            return deviceResponseRef;
        }
    };

    this.sendSHPCommand = function (type, param1, param2, isLoading, fallBackTime) {
        ///*
        debugMessage("sendSHPCommand*");
        //console.log("payload = " + param1);;
        scope.loadingBar = isLoading === false ? false : true;  //Lokesh 04Nov15_0347 -> default value should be true. if parameter not sent or not boolean or true, assign true.
        scope.currentSHPCommand = param1;

        //debugMessage("param1::"+param1+":::param2:::"+param2);
        initialTime = new Date();
        var _that_ = this;
        var duration = fallBackTime || STCONST.MAX_TIME_INTERVAL;

        if (type === STCONST.PUT) {
            nativeInterface.putDataOnResourceUrl(param1, param2);
        } else if (type === STCONST.GET) {
            nativeInterface.getResourceUrl(param1);
        } else if (type === STCONST.POST) {
            nativeInterface.postDataOnResourceUrl(param1, param2);
        } else if (type === STCONST.DELETE) {
            nativeInterface.deleteResourceUrl(param1);
        } else if (type === STCONST.RUNONNATIVE) {
            nativeInterface.runOnNative(param1, param2);
        }
        else {//SONAR ISSUE
            //NULL
        }

        stopVar = setInterval(function () {
            timeDiff = new Date() - initialTime;
            //console.log("timeDiff: " + timeDiff + " duration: " + duration);
            if (timeDiff > duration) {
                scope.loadingBar = false;
                if (!secondRequestFailed) {
                    secondRequestFailed = true;
                    _that_.clearStopVarArray();
                    if (_that_ !== null) {
                        scope.checkResponse = [];
                        if (scope.isFoodReminder) {
                            if ((scope.currentSHPCommand).indexOf("/files/camera_") !== -1) {
                                scope.getGlazeImages();
                            } else {
                                initialLaunch = true;
                                _that_.getFoodList(scope);
                            }
                        } else if (scope.isShopping) {
                            if ((scope.currentSHPCommand).indexOf("/files/camera_") !== -1) {
                                scope.getGlazeImages();
                            } else {
                                initialLaunch = true;
                                _that_.getShoppingList(scope);
                            }                                                                                    
                        } else if (scope.isTodo) {
                                initialLaunch = true;
                                _that_.getTodoList(scope);
                        } else if (scope.isCalendarApp) {
                                initialLaunch = true;
                                _that_.getCalendarList(scope);
                        } else {
                            debugMessage("in the get Device 20 sec");
                            _that_.getDevice(scope);
                        }
                    }
                } else if (secondRequestFailed) {
                    //debugMessage("In the second request true");
                    scope.$apply(function () {
                        //debugMessage("in the connection failure pop-up 20 sec");
                        showConnectionFailurePopup();
                    });
                }
                else {//SONAR ISSUE
                    //NULL
                }
                _that_ = null;
            }
        }, STCONST.MIN_TIME_INTERVAL);  //Lokesh 16Nov15_1412 -> if fallback time is sent, use that. Otherwise use default time.
        stopVarArray.push(stopVar);
        //*/
    };

    this.isNativeComponent = function (type) {
        if (type === REQUEST.CLOSE_WEB_APP)
            return true;
        else if (type === REQUEST.SHOW_TOAST)
            return true;
        else if (type === REQUEST.CLOSE_KEYPAD)
            return true;
        else
            return false;
    };

    this.sendNativeCommand = function (type, param1, requestToken, isLoading) {
        debugMessage("sendNativeCommand*");
        if (angular.isUndefined(isLoading))
            isLoading = true;

        if (typeof(param1) === 'object')
            param1 = JSON.stringify(param1);
        console.log("type = " + type + " / payload = " + param1 + " / requestToken: " + requestToken);
        console.log("scope.isStatic " + scope.isStatic + " / type = " + type );
        if (scope.isStatic)
            return;

        console.log("scope.loadingBar: " + scope.loadingBar);   //Lokesh 04Nov15_0347 -> default value should be true. if parameter not sent or not boolean or true, assign true.
        initialTime = new Date();
        if (!this.isNativeComponent(type) && isLoading !== false)
            this.loadingStarted();
        nativeInterface.runOnNative(type, param1, requestToken);
    };

    this.clearStopVarArray = function () {
        debugMessage("clearStopVarArray*");
        clearInterval(stopVar);
        stopVarArray.forEach(function (value) {
            clearInterval(value);
        });
    };

    function showConnectionFailurePopup() {
        debugMessage("showConnectionFailurePopup");
        scope.showConnectionFailurePopup();
        _that.clearStopVarArray();
    }

    this.loadingStarted = function () {
        console.log("loadingStarted");
        scope.loadingBar = true;
        // scope.loadingBar = isLoading === false ? false : true;
        var _that_ = this;
        var durationMultiplier = (scope.isCalendarApp)?3:2;
        var duration = STCONST.MAX_TIME_INTERVAL * durationMultiplier;

        stopVar = setInterval(function () {
            timeDiff = new Date() - initialTime;
            console.log("timeDiff: " + timeDiff + " duration: " + duration);
            if (timeDiff > duration) {
                scope.loadingBar = false;
                debugMessage("in the get Device 40 sec");
                _that_.clearStopVarArray();
                try {
                    _that_.sendNativeCommand(REQUEST.SHOW_TOAST, scope.translation.WEBMOB_fhub2_common_check_power_and_network, "");
                    scope.closeLoadingBar();
                } catch (err) {
                    console.log(err);
                    setTimeout(function () {
                        scope.checkResponse = [];
                        scope.loadingBar = false;
                    }, 0);
                }

                _that_ = null;
            }
        }, STCONST.MIN_TIME_INTERVAL);  //Lokesh 16Nov15_1412 -> if fallback time is sent, use that. Otherwise use default time.
        stopVarArray.push(stopVar);
    };

    this.loadingFinished = function () {
        debugMessage("loadingFinished*");
        if (!scope.loadingBar) { // No loading bar means request handled properly. So, clear array.
            _that.clearStopVarArray();
        }
    };
});

// call back from native
function nativeCallback(response) {
    debugMessage("nativeCallback*");
    // console.log('Response ::: ' + data);

    setTimeout(function () {
        var scope = angular.element(document.getElementById("bodyTag")).scope();
        if (!!scope) {
            scope.$apply(function () {
                scope.updateDeviceData(response);
            });
        }
    }, 0);
}

//ST Functions
var ST_URL = window.location.host;
var nowURL = "graph.api.smartthings.com";
var _stImageUrl = "";
function setBaseFont() {
    debugMessage("setBaseFont");
    var cWidth;
    cWidth = window.screen.availWidth;
    if(cWidth === 0 || cWidth === undefined) {
       cWidth = document.body.clientWidth; 
    }
    /*if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
        cWidth = window.screen.availWidth;
    } else {
        cWidth = document.body.clientWidth;
    } */
    var baseFontSize = (80 * cWidth) / 1440;
    document.getElementById("htmlTag").style.fontSize = baseFontSize + "px";
}

function getLocalStorageData(item) {
    if (typeof (Storage) !== "undefined") {
        return localStorage.getItem(item);
    } else {
        // Sorry! No Web Storage support..
    }
}

function setLocalStorageData(item, value) {
    if (typeof (Storage) !== "undefined") {
        localStorage.setItem(item, value);
    } else {
        // Sorry! No Web Storage support..
    }
}

function removeLocalStorageData(item) {
    if (typeof (Storage) !== "undefined") {
        localStorage.removeItem(item);
    } else {
        // Sorry! No Web Storage support..
    }
}

function clearLocalStorageData() {
    if (typeof (Storage) !== "undefined") {
        localStorage.clear();
    } else {
        // Sorry! No Web Storage support..
    }
}

app.directive('resizeText', ['$window', 'UtilityService', function ($window, UtilityService) {
        return {
            restrict: 'A',
            scope: {
                rtTargetPct: '@', //available space in percent.
                rtTargetPx: '@', //available space in pixels. 
                rtFontClass: '@',
                rtMultilineCls: '@',
                rtSinglelineCls: '@',
                rtDisable: '@',
                rtDisableCls: '@',
                model: '=ngModel',
                rtSetWidth: '@',
                rtApplyMarginTop: '@',
                rtTest: '@',
                rtAuto: '@'
            },
            link: function (scope, element, attrs) {
                debugMessage("resizeText:link");
                var elem = element[0];
                //watch value to change
                scope.$watch('model', setCls);
                attrs.$observe('rtDisable', disableText);
                scope.$watch(function() {
                    return elem.innerHTML;
                }, setCls);
                
                function setCls() {
                    if(elem.innerHTML === "") {
                        return;
                    }                    
                    var availSize,
                            oldWidth,
                            targetPct = scope.rtTargetPct,
                            targetPx = scope.rtTargetPx,
                            style = elem.style,
                            fontClass = scope.rtFontClass,
                            singleLineClass = scope.rtSinglelineCls,
                            multiLineClass = scope.rtMultilineCls,
                            calcWidth,
                            fontSize,
                            deviceWidth = Math.max($window.innerWidth, screen.width),
                            defaultElemWidth = Math.ceil(0.6 * deviceWidth),
                            applyMarginTop = scope.rtApplyMarginTop === 'false' ? false : true;
                    
                    //remove multiline class, if already there.
                    element.removeClass(multiLineClass);
                    
                    /**
                     * @author: Lokesh Sharma
                     * @date_time: 29-Dec-2015_1117
                     * @description We have added margin top to counter an issue 
                     * whose description is provided below in this function. One 
                     * side effect has been observed of that fix. The side effect 
                     * is: The marginTop is set permanenty and is of highest priority,
                     * because its inline style. When the text is changed and is 
                     * of higher / lower width, this marginTop must not be applied.
                     * Instead a new margin as per class added, should be applied.
                     * To nullify previously added margin, we are removing 
                     * singleLineClass if added earlier and removing marginTop
                     * explicitly. The singleLineClass will be added again, so 
                     * that the marginTop will be applied from this class only.
                     */
                    element.removeClass(singleLineClass);
                    style.marginTop = "";
                    style.width = "";
                    
                    //add single line class, if not there.
                    element.addClass(singleLineClass);
                    $window.getComputedStyle(elem); //used to allow browser to apply provided style.
                    
                    //get element's current width.
                    calcWidth = Math.ceil(parseFloat(style.width));
                    oldWidth = style.width;
                    if (!!!calcWidth) {
                        calcWidth = 0;
                    }

                    //is target % provided?
                    if (!!targetPct) {
                        // space available in %. convert it to pixels.
                        availSize = Math.ceil(targetPct * deviceWidth);
                        logIt("availSize = " + availSize);
                    } else if (!!targetPx) {
                        availSize = calcWidth || defaultElemWidth; //fail safe

                        if (targetPx.indexOf("rem") > -1) {
                            fontSize = parseFloat(document.getElementById("htmlTag").style.fontSize);
                            targetPx = parseFloat(targetPx);

                            if (!!targetPx) {
                                availSize = Math.ceil(targetPx * fontSize);
                            }
                        } else if (targetPx.indexOf("px") > -1) {
                            targetPx = parseInt(targetPx, 10);

                            if (!!targetPx) {
                                availSize = targetPx;
                            }
                        } else {    //handle for SONAR.
                            //NULL
                        }
                    } else {
                        //proper available size in pix
                        //Otherwise, assume 60% space is available.
                        availSize = calcWidth || defaultElemWidth;
                    }

                    //assing auto value, so that actual width can be calculated.
                    if(scope.rtAuto &&  !UtilityService.parseBoolean(scope.rtAuto)) {
                        //style.width = 'auto';
                    } else {
                        style.width = 'auto';
                    }

                    //Add font class only when font is not available already.
                    if (!!!style.font && !!fontClass && elem.className.indexOf(fontClass) < 0) {
                        //font class provided
                        elem.className += " " + fontClass;
                    }

                    /**
                     * Lokesh 16Dec15_1401 -> SetTimout is causing problem. 
                     * Cause :- Whenever there are more than 1 resize-text directives 
                     *          used. The below function is called after a delay 
                     *          because of SetTimeout(). The time, below function 
                     *          is called (after the delay), the value of calcWidth 
                     *          variable is overridden by further calls for initialization 
                     *          of resize-text directive. For ex:- resize-text is 
                     *          used for text 'AAAAAAA...' and 'BBBBBB....'. The 
                     *          directive is called for 'AAAAAAA...', so the 'calcWidth'
                     *          is supposed to carry calculated width for 'AAAAAAA...'. 
                     *          But, because of timeout, initialization of resize-text 
                     *          for 'BBBBBB....' is started and therefore 'calcWidth'
                     *          will carry calcualted width of 'BBBBBB....' instead 
                     *          of 'AAAAAAA...' (as inteded because the setTimeout() 
                     *          was called from initialization of 'AAAAAAA...'). 
                     *          This is causing issues.
                     * Solution :- Committed the SetTimeout() and let the control flow go ahead.
                     */
                    //                  setTimeout(function () {
                    //if text width is more than available width
                    
                    if (elem.clientWidth > (calcWidth || availSize)) {//for text only case
                        // remove previously added single line class.
                        element.removeClass(singleLineClass);

                        //add multiline class
                        element.addClass(multiLineClass);

                        /**
                         * @author Lokesh Sharma
                         * @date 24Dec15_1518 
                         * @description The font size in single line class is 
                         * higher than that of multiline class (Usually 100: 75 
                         * ratio). The text whose width was higher than threshold, 
                         * when single line class was applied, has just come 
                         * under the threshold after applying multiline class gives
                         * unpleasant UI. To tackle such situation, we again 
                         * calculate width of text after applying multiline class.
                         * If the width is under bounds, then we apply a margin 
                         * to bring the text in the middle of the (parent) container.
                         */
                        var compStyle = $window.getComputedStyle(elem);
                        
                        /**
                         * author Lokesh Sharma
                         * @date 04Jan16_1634
                         * @description Using '<' symbol because width 
                         * should be at least 1 pixel lesser to fit in same line.
                         */           
                        
                        if(applyMarginTop && (parseInt(compStyle.width) < (calcWidth || availSize))) {
                            var parentStyle = $window.getComputedStyle(elem.parentElement);
                            elem.style.marginTop = (parseInt(parentStyle.height) - parseInt(compStyle.fontSize)) / 2;
                        }
                        //re-assign width.
                        if(!!scope.rtSetWidth && !UtilityService.parseBoolean(scope.rtSetWidth)) {
                           style.width = oldWidth || '';
                        } else {
                           style.width = (calcWidth || availSize);
                        }
                        
                    } else {
                            //if width-set flag is false, re-assign width if available, otherwise leave it blank.
                            if(!!scope.rtSetWidth && !UtilityService.parseBoolean(scope.rtSetWidth)) {
                                style.width = oldWidth || '';
                            }

                        element.removeClass(multiLineClass);
                        element.addClass(singleLineClass);
                    }
                    //                }, 200);
                }
                
                function logIt(log) {
                    if(scope.rtTest) {
                        console.log("text = " + elem.innerHTML + " && log = " + log);
                    }
                }
                //enable /disable text.
                function disableText() {
                    if (UtilityService.parseBoolean(scope.rtDisable)) {
                        element.addClass(scope.rtDisableCls);
                    } else {
                        element.removeClass(scope.rtDisableCls);
                    }
                }
            } //close link function.
        }; //close return object.
}]); //close directive.

app.directive('rtFixedWidth', ['$window', 'UtilityService', function ($window, UtilityService) {
        return {
            restrict: 'A',
            scope: {
                rtMultilineCls: '@',
                rtSinglelineCls: '@',
                rtDisable: '@',
                rtDisableCls: '@',
                model: '=ngModel',
                rtChangeFontSize: '@',
                rtMinFontSize:'@',   //should be same as what is given in multi line class.
                rtMaxWidth: '@'
            },
            link: function (scope, element, attrs) {
                debugMessage("rtFixedWidth:link");
                var elem = element[0];
                //watch value to change
                scope.$watch('model', setCls);
                attrs.$observe('rtDisable', disableText);
                scope.$watch(function() {
                    return elem.innerHTML;
                }, setCls);
                
                function setCls() {
                    if(elem.innerHTML === "") {
                        return;
                    }
                    var style = elem.style,
                            fontClass = scope.rtFontClass,
                            singleLineClass = scope.rtSinglelineCls,
                            multiLineClass = scope.rtMultilineCls,
                            fontSize = parseFloat(document.getElementById("htmlTag").style.fontSize),
                            changeFontSize = scope.rtChangeFontSize === 'false' ? false : true,
                            compStyle,
                            minFont = scope.rtMinFontSize && Math.ceil(parseFloat(scope.rtMinFontSize) * fontSize),
                            maxWidth = scope.rtMaxWidth && Math.floor(parseFloat(scope.rtMaxWidth) * fontSize);
                    
                    //remove classes, if already there.
                    element.removeClass(multiLineClass);
                    element.removeClass(singleLineClass);
                    
                    //remove font size applied, if any.
                    elem.style.fontSize = "";
                    
                    //remove pseudo styles.
                    removeAddOnStyles();
                    
                    //add single line class, if not there.
                    element.addClass(singleLineClass);

                    //add pseudo styles for calculations.
                    style.overflow = "hidden";
                    style.whiteSpace = 'nowrap';

                    //Add font class only when font is not available already.
                    if (!!!style.font && !!fontClass && elem.className.indexOf(fontClass) < 0) {
                        //font class provided
                        elem.className += " " + fontClass;
                    }

                    maxWidth = maxWidth || elem.clientWidth;
                    if (elem.scrollWidth > maxWidth) {//for text only case
                       var currFontSize;
                       
                       if(changeFontSize && minFont) { //minFont should not be 0.
                            compStyle = $window.getComputedStyle(elem);
                            do {
                                compStyle = $window.getComputedStyle(elem);
                                currFontSize = parseInt(compStyle.fontSize) - 1;
                                elem.style.fontSize = currFontSize + "px";                            
                            } while((elem.scrollWidth > elem.clientWidth) && (currFontSize > minFont))
                        }
                       
                       if(elem.scrollWidth > maxWidth) {
                            //remove font size.
                            elem.style.fontSize = "";    
                            
                            // remove previously added single line class.
                            element.removeClass(singleLineClass);

                            //add multiline class
                            element.addClass(multiLineClass);
                       }
                    } 
                    //remove pseudo styles.
                    removeAddOnStyles();
                }
                
                function removeAddOnStyles() {
                    elem.style.overflow = "";
                    elem.style.whiteSpace = "";
                }
                                
                //enable /disable text.
                function disableText() {
                    if (UtilityService.parseBoolean(scope.rtDisable)) {
                        element.addClass(scope.rtDisableCls);
                    } else {
                        element.removeClass(scope.rtDisableCls);
                    }
                }
            } //close link function.
        }; //close return object.
    }]); //close directive.

app.directive('resizeBtn', ['$window', function () {
        return {
            restrict: 'A',
            scope: {
                rbMultilineCls: '@',
                rbSinglelineCls: '@',
                rbCharCnt: '@',
                rbText: '@'
            },
            link: function (scope, element, attr) {
                debugMessage("resizeBtn:link");
                //observe value for change
                attr.$observe('rbText', setCls);
                element.addClass("Regular");
                function setCls() {
                    var charCnt = parseInt(scope.rbCharCnt),
                            text = scope.rbText,
                            singleLineCls = scope.rbSinglelineCls,
                            multiLineCls = scope.rbMultilineCls;

                    if (charCnt < text.length) {
                        element.removeClass(singleLineCls);
                        element.addClass(multiLineCls);
                    } else {
                        element.removeClass(multiLineCls);
                        element.addClass(singleLineCls);
                    }
                }
            } //close link function.
        }; //close return object.
    }]); //close directive.

app.directive("switchOnOff", ['$timeout', 'UtilityService', function ($timeout, UtilityService) {
        return {
            restrict: 'AE',
            scope: {
                stOnText: '@',
                stOffText: '@',
                stDataOnText: '=',
                stDataOffText: '=',
                stTextDisabledCls: '@',
                stBgDisabledCls: '@',
                stEnabled: '=',
                model: '@',
                control: '='
            },
            template: '<div class="switch"> \
                            <div class="toggle-switch draw-round off-state">	 \
                                <div class="toggle-state"> \
                                    <div class="cir"></div> \
                                    <span class="off-txt"></span> \
                                </div>	\
                            </div> \
                        </div>',
            link: function (scope, element, attrs) {
                debugMessage("switchOnOff:link");
                var util = UtilityService,
                        clickAction = attrs.ngClick,
                        txtDisabledCls = scope.stTextDisabledCls,
                        bgDisabledCls = scope.stBgDisabledCls,
                        elem = element[0],
                        elemSpan = angular.element(elem.querySelector('.toggle-state span')),
                        elemCirc = angular.element(elem.querySelector('.cir')),
                        elemTS = angular.element(elem.querySelector('.toggle-state')),
                        elemSW = angular.element(elem.querySelector('.toggle-switch')),
                        txtOn,
                        txtOff,
                        defaultBoolean,
                        currentVal;
                init();
                elemSpan.addClass("Regular");
                attrs.$set('control', {
                    reInit: function () {
                        reInit();
                    }
                });

                attrs.$observe('stOnText', function () {
                    init();
                });
                attrs.$observe('stOffText', function () {
                    init();
                });

                scope.$watch('stEnabled', toggleDisableClasses);

                attrs.$observe('model', function (newValue) {
                    reInit(newValue);
                });

                //add click event.
                element.bind('click', function () {
                    if (isSTDisabled()) {
                        return;
                    }
                    util.showElem(elemCirc);
                    elemCirc.addClass('cir-scale');
                    switchOpt();
                    //call default ng-click if any.
                    if (!!clickAction) {
                        scope.$eval(clickAction);
                    }
                });

                function reInit(newVal) {
                    defaultBoolean = newVal;
                    initializeSwitch();
                }

                function init() {
                    txtOn = scope.stOnText || scope.stDataOnText;
                    txtOff = scope.stOffText || scope.stDataOffText;
                    defaultBoolean = scope.model;

                    initializeSwitch();
                }

                function initializeSwitch() {
                    currentVal = !util.parseBoolean(defaultBoolean);
                    switchOpt(true);

                    if (isSTDisabled()) {
                        toggleDisableClasses();
                    }
                }

                function switchOpt(skipDisabled) {
                    if (!!!skipDisabled && isSTDisabled()) {
                        //if element is disabled. Don't do anything.
                        return;
                    }

                    if (currentVal) {
                        elemSW.removeClass('on-state');
                        elemSW.addClass('off-state');

                        textOn();
                    } else {
                        elemSW.removeClass('off-state');
                        elemSW.addClass('on-state');

                        textOff();
                    }
                }

                function textOn() {

                    $timeout(function () {
                        elemSpan.html(txtOff);

                        elemSpan.removeClass('on-txt');
                        elemSpan.removeClass('on-txt-anim');
                        elemSpan.addClass('off-txt');
                        elemSpan.addClass('off-txt-anim');

                        $timeout(function () {
                            elemTS.removeClass('color-ch-on');
                            elemTS.addClass('color-ch-off');

                            //Lokesh 21Oct15_1022 -> The code is giving further bugs. Hence, commented for time being.
//                            $timeout(function() {
//                                //remove animation classes after animation is done.
//                                removeAnimClasses();
//                            }, 1000);
                            if (isSTDisabled()) {
                                toggleDisableClasses();
                            }
                        }, 200);
                        util.hideElem(elemCirc);
                    }, 500);
                }

                function textOff() {
                    $timeout(function () {
                        elemSpan.html(txtOn);

                        elemSpan.removeClass('off-txt');
                        elemSpan.removeClass('off-txt-anim');
                        elemSpan.addClass('on-txt');
                        elemSpan.addClass('on-txt-anim');

                        $timeout(function () {
                            elemTS.removeClass("color-ch-off");
                            elemTS.addClass("color-ch-on");

                            //Lokesh 21Oct15_1022 -> The code is giving further bugs. Hence, commented for time being.
//                             $timeout(function() {
//                                 //remove animation classes after animation is done.
//                                removeAnimClasses();
//                            }, 1000);
                            if (isSTDisabled()) {
                                toggleDisableClasses();
                            }
                        }, 200);
                        util.hideElem(elemCirc);
                    }, 500);
                }

                function isSTDisabled() {
                    return (angular.isDefined(scope.stEnabled) && !scope.stEnabled);
                }

                function toggleDisableClasses() {
                    if (isSTDisabled()) {
                        elemTS.removeClass('color-ch-on');
                        elemTS.removeClass('color-ch-off');
                        elemTS.addClass(bgDisabledCls);
                        elemSpan.addClass(txtDisabledCls);
                    } else {
                        elemTS.removeClass(bgDisabledCls);
                        elemSpan.removeClass(txtDisabledCls);

                        if (elemSpan.html() === txtOn) {
                            elemTS.addClass('color-ch-on');
                        } else {
                            elemTS.addClass('color-ch-off');
                        }
                    }
                }

                //remove animation related classes.
                function removeAnimClasses() {
                    if (elemTS.hasClass('color-ch-on')) {
                        elemTS.addClass('color-ch-on-bg');
                    } else {
                        elemTS.removeClass('color-ch-on-bg');
                    }
                    elemTS.removeClass('color-ch-on');
                    elemSpan.removeClass('on-txt-anim');
                    elemTS.removeClass('color-ch-off');
                    elemSpan.removeClass('off-txt-anim');
                }
            }   //close link function.
        };  //close return object.
    }]);    //close directive.

app.service("UtilityService", utilityService);

function utilityService() {
    debugMessage("utilityService");
    var _this = this;

    var isAnimRunning = false,
            scope = angular.element(document.getElementById("bodyTag")).scope();

    /*************utilities declaration starts here ************************/
    _this.getTextWidth = getTextWidth;
    _this.toggleAnimClass = toggleAnimClass;
    _this.toggleOnOffClass = toggleOnOffClass;
    _this.changePopUpClass = changePopUpClass;
    _this.isAnimating = isAnimating;
    _this.addCSSClass = addCSSClass;
    _this.removeCSSClass = removeCSSClass;
    _this.showElem = showElem;
    _this.hideElem = hideElem;
    _this.toggleCSSClass = toggleCSSClass;
    _this.parseBoolean = parseBoolean;
    _this.findKeyByValue = findKeyByValue;
    _this.isEventSupported = isEventSupported;
    _this.dismissLoadingBar = dismissLoadingBar;
    _this.toggleBottomPopUpClass = toggleBottomPopUpClass;
    _this.appendZero = appendZero;
    _this.getScope = getScope;
    _this.pad = pad;
    /*************utilities declaration ends here **************************/

    //function definitions start here

    /**
     * Uses canvas.measureText to compute and return the width of the given text of given font in pixels.
     * 
     * @param {String} text The text to be rendered.
     * @param {String} font The css font descriptor that text is to be rendered with (e.g. "bold 14px verdana").
     * 
     * @see http://stackoverflow.com/questions/118241/calculate-text-width-with-javascript/21015393#21015393
     */
    function getTextWidth(text) {
        debugMessage("getTextWidth");
        // re-use canvas object for better performance
        var canvas = getTextWidth.canvas || (getTextWidth.canvas = document.createElement("canvas"));
        var context = canvas.getContext("2d");
        canvas.style.font = "inherit";
        context.font = canvas.style.font;
        var metrics = context.measureText(text);
        return metrics.width;
    }

    function pad(num, width, padChar) {
        debugMessage("pad");
        padChar = padChar || '0';   //default pad character is '0'
        num = num + ''; //convert to string
        return num.length >= width ? num : new Array(width - num.length + 1).join(padChar) + num;
    }

    function parseBoolean(value) {
        debugMessage("parseBoolean");
        value = value + ""; //avoids failure b'coz of real boolean passed.
        return (typeof value === "undefined") ?
                false :
                // trim using jQuery.trim()'s source 
                value.replace(/^\s+|\s+$/g, "").toLowerCase() === "true";
    }
    // Toggle class for body
    function toggleAnimClass(scope) {
        debugMessage("toggleAnimClass");
        scope = scope || getScope();
        //change classes.
        if (scope.containSubCl === "containSub") {
            scope.containSubCl = "";
        } else {
            scope.containSubCl = "containSub";
        }
    }

    function toggleOnOffClass(scope) {
        debugMessage("toggleOnOffClass");
        scope = scope || getScope();
        if ((scope.toggleOnOff === "switch") || (scope.toggleOnOff === "switch switch-mm")) {
            scope.toggleOnOff = "switch switch-m";
        } else {
            scope.toggleOnOff = "switch switch-mm";
        }

    }

    // Toggle class for Mode drop down
    function changePopUpClass(scope) {
        debugMessage("changePopUpClass");
        scope = scope || getScope();
        if (scope.showModeSelectionPopup) {
            scope.ModeSelectionPopupDivCls = "ModeSelectionPopupDiv";
        } else {
            scope.ModeSelectionPopupDivCls = "ModeSelectionPopOutDiv";
        }
    }

    function isAnimating() {
        debugMessage("isAnimating");
        return isAnimRunning;
    }

    function addCSSClass(elem, className) {
        debugMessage("addCSSClass");
        //if class not already there, then only add it.
        if (elem.className.indexOf(className) < 0) {
            elem.className += " " + className;
        }
    }

    function removeCSSClass(elem, className) {
        debugMessage("removeCSSClass");
        if (elem.className.indexOf(className) > -1) {
            elem.className = elem.className.replace(className, '');
        }
    }

    function showElem(elem) {
        debugMessage("showElem");
        elem.css('display', 'block');
    }

    function hideElem(elem) {
        debugMessage("hideElem");
        elem.css('display', 'none');
    }

    function toggleCSSClass(elem, className) {
        debugMessage("toggleCSSClass");
        if (elem.className.indexOf(className) < 0) {
            addCSSClass(elem, className);
        } else {
            removeCSSClass(elem, className);
        }
    }

    function findKeyByValue(obj, value) {
        debugMessage("findKeyByValue");
        for (var prop in obj) {
            if (obj.hasOwnProperty(prop)) {
                if (obj[prop] === value)   //== used explicitly. So, don't change it.
                    return prop;
            }
        }
    }

    //courtesy to Kangax
    //Detects if an event is supported on the target browser.
    function isEventSupported(eventName) {
        debugMessage("isEventSupported");
        var TAGNAMES = {
            'select': 'input',
            'change': 'input',
            'submit': 'form',
            'reset': 'form',
            'error': 'img',
            'load': 'img',
            'abort': 'img'
        };
        var el = document.createElement(TAGNAMES[eventName] || 'div');
        eventName = 'on' + eventName;
        var isSupported = (eventName in el);
        if (!isSupported) {
            el.setAttribute(eventName, 'return;');
            isSupported = typeof el[eventName] === 'function';   //leave === as it is. This is needed.
        }
        el = null;
        return isSupported;
    }

    function dismissLoadingBar(value, parentScope) {
        debugMessage("dismissLoadingBar");
        var localScope = parentScope || getScope();

        if (localScope.checkResponse.length === 0) {
            localScope.loadingBar = false;
            return;
        }

        if (!!localScope && !!localScope.checkResponse && localScope.checkResponse.indexOf(value) !== -1) {
            localScope.checkResponse.splice(localScope.checkResponse.indexOf(value), 1);
            if (localScope.checkResponse.length === 0) {
                localScope.loadingBar = false;
            }
        }
    }

    function toggleBottomPopUpClass(popupName, parentScope) {
        debugMessage("toggleBottomPopUpClass");
        var localScope = parentScope || getScope();

        //debugMessage("  " + scope.BottomPopupDimBackgroundDiv);
        if (popupName) {
            localScope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivIn";
            localScope.BottomPopupDivCls = "BottomPopupBGIn";
        } else {
            localScope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivOut";
            localScope.BottomPopupDivCls = "BottomPopupBGOut";
        }
    }

    function appendZero(value) {
        debugMessage("appendZero");
        return (value < 10 ? '0' : '') + value;
    }

    function getScope() {
        debugMessage("getScope");
        //first assign new value, then only return it. This assignment will be used later.
        scope = scope || angular.element(document.getElementById("bodyTag")).scope();
        return scope;
    }
}

function maxLengthCheck(object, maxLength) {
    var maxLen = maxLength || object.maxLength;
    var scope  =  angular.element(document.getElementById("bodyTag")).scope();
    if (object.value.length > maxLen) {
        object.value = object.value.slice(0, maxLen);
        scope.showToast();
        object.blur();
    }
}

var firstBy = function () {
    debugMessage("firstBy*");
    function n(n, t) {
        if ("function" !== typeof n) {
            var r = n;
            n = function (n, t) {
                return n[r] < t[r] ? -1 : n[r] > t[r] ? 1 : 0
            }
        }
        return-1 === t ? function (t, r) {
            return-n(t, r)
        } : n
    }
    function t(t, u) {
        return t = n(t, u), t.thenBy = r, t
    }
    function r(r, u) {
        var f = this;
        return r = n(r, u), t(function (n, t) {
            return f(n, t) || r(n, t)
        })
    }
    return t
}();

app.directive("bouncyScroll", ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            scope: {
                innerWrapper: '@',
            },
            link: function (scope, element, attrs) {
                debugMessage("bouncyScroll:link");
                $(element).fancy_scroll({
                    innerWrapper: scope.innerWrapper,
                    animation: "bounce",
                    bounceDistance: 200,
                    animDuration: "0.2s",
                    animEasing: "cubic-bezier(0.175, 0.885, 0.420, 1.310)"
                });
            }
        }
    }]);

app.directive("keypadTouch", ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            scope: {
                ktFocus: '@',
            },
            link: function (scope, element, attrs) {
                debugMessage("keypadTouch:link");
                var f = function (event) {
                    $timeout(function () { // angular way, setTimeout is OK
                        input[0].focus();
                        event.preventDefault();
                    })
                };
                var mobile = false;
                element.on('click', function (event) {
                    if (mobile)
                        return;
                    f(event);
                });

                element.on('touchstart', function (event) {
                    mobile = true;
                    f(event);
                });

                element.on('touchend', function (event) {
                    event.preventDefault();
                    event.stopPropagation();
                });
            }
        };
    }]);

app.directive("ngTouchstart", function () {
    return {
        controller: ["$scope", "$element", function ($scope, $element) {
                debugMessage("ngTouchstart");
                $element.bind("touchstart", onTouchStart);
                function onTouchStart(event) {
                    var method = $element.attr("ng-touchstart");
                    $scope.$event = event;
                    $scope.$apply(method);
                }

            }]
    };
});

app.directive("ngTouchmove", function () {
    return {
        controller: ["$scope", "$element", function ($scope, $element) {
                debugMessage("ngTouchmove");
                $element.bind("touchstart", onTouchStart);
                function onTouchStart(event) {
                    event.preventDefault();
                    $element.bind("touchmove", onTouchMove);
                    $element.bind("touchend", onTouchEnd);
                }
                function onTouchMove(event) {
                    var method = $element.attr("ng-touchmove");
                    $scope.$event = event;
                    $scope.$apply(method);
                }
                function onTouchEnd(event) {
                    event.preventDefault();
                    $element.unbind("touchmove", onTouchMove);
                    $element.unbind("touchend", onTouchEnd);
                }

            }]
    };
});

app.directive("ngTouchend", function () {
    return {
        controller: ["$scope", "$element", function ($scope, $element) {
                debugMessage("ngTouchend");
                $element.bind("touchend", onTouchEnd);
                function onTouchEnd(event) {
                    var method = $element.attr("ng-touchend");
                    $scope.$event = event;
                    $scope.$apply(method);
                }

            }]
    };
});

app.directive('myFocus', function ($timeout) {
    return function (scope, element, attrs) {
        debugMessage("myFocus");
        attrs.$observe('myFocus', function () {
            if (scope.$eval(attrs.myFocus)) {
                // Element needs to be visible to focus
                $timeout(function () {
                    element[0].focus();
                });
            }
        });
    };
});

app.directive('onLongPress', function ($timeout) {
    return {
        restrict: 'A',
        link: function ($scope, $elm, $attrs) {
            debugMessage("onLongPress:link");
            var duration = $attrs.longPressDuration || 100;
            $elm.bind('touchstart', function () {
                $scope.longPress = true;
                
                if(longPressTimer) {
                    $timeout.cancel(longPressTimer);
                }
                longPressTimer = $timeout(function () {
                    if ($scope.longPress) {
                        $scope.$apply(function () {
                            $scope.$eval($attrs.onLongPress);
                        });
                    }
                }, duration);
            });

            $elm.bind('touchmove', function () {
                $scope.longPress = false;

                if ($attrs.onTouchMove) {
                    $scope.$apply(function () {
                        $scope.$eval($attrs.onTouchMove);
                    });
                }
            });

            $elm.bind('touchend', function () {
                $scope.longPress = false;
                if ($attrs.onTouchEnd) {
                    $scope.$apply(function () {
                        $scope.$eval($attrs.onTouchEnd);
                    });
                }
            });
            $elm.bind('touchleave', function () {
                $scope.longPress = false;
                if ($attrs.onTouchEnd) {
                    $scope.$apply(function () {
                        $scope.$eval($attrs.onTouchEnd);
                    });
                }
            });
            $elm.bind('touchcancel', function () {
                $scope.longPress = false;
                if ($attrs.onTouchEnd) {
                    $scope.$apply(function () {
                        $scope.$eval($attrs.onTouchEnd);
                    });
                }
            });
            $elm.bind('touchenter', function () {
                $scope.longPress = false;
                if ($attrs.onTouchEnd) {
                    $scope.$apply(function () {
                        $scope.$eval($attrs.onTouchEnd);
                    });
                }
            });
        }
    };
});

 app.directive('stHold', function ($timeout, UtilityService) {
    return {
        restrict: 'A',
        link: function ($scope, $elm, $attrs) {
            debugMessage("stHold:link");
            var mouseEvts = {
                //'mousedown': touchStartFun,
                //'mouseenter': touchStartFun,
                'touchstart': touchStartFun,
                //'mouseup': touchEndFun,
                'touchend': touchEndFun,
                //'mouseleave': touchEndFun,
                'touchleave': touchEndFun,
                'touchcancel': touchEndFun,
                //'mousemove': touchMoveFun,
                'touchmove': touchMoveFun,
                //'mouseover': touchStartFun,
                //'mouseout': touchMoveFun
            },
            evnt, stRelease = $attrs.stRelease, timer;
            for (evnt in mouseEvts) {
                if (mouseEvts.hasOwnProperty(evnt) &&
                        UtilityService.isEventSupported(evnt)) {
                    $elm.bind(evnt, mouseEvts[evnt]);
                }
            }
            function touchStartFun() {
                touchEndFun();
                if (!!$scope.longPress) {
                    return;
                }
                $scope.longPress = true;
                // Set a timeout for 450 ms for a long press and Start Long Press
                timer = $timeout(function () {
                    if ($scope.longPress) {
                        // applyFun touchend event
                        applyFun($attrs.stHold);
                    }
                }, 450);
            }
            function touchEndFun() {
                // Prevent the Long Press event if timer is already applied and touch-end called
                if (!!timer) {
                    $timeout.cancel(timer);
                }
                $scope.longPress = false;
                //  apply touch-end
                if (stRelease) {
                    applyFun(stRelease);
                }
            }
            function touchMoveFun(evt) {
                // apply touch-end if user moves out from area with press state 
                if (evt.touches !== undefined && evt.touches.length !== undefined) {
                    if ($elm[0] !== document.elementFromPoint(evt.touches[evt.touches.length - 1].clientX, evt.touches[evt.touches.length - 1].clientY)) {
                        $scope.longPress = false;
                        applyFun(stRelease);
                    }
                }
            }
            function applyFun(fun) {
                $scope.$apply(evalFun(fun));
            }
            function evalFun(fun) {
                $scope.$eval(fun);
            }
        }
    };
});

app.directive('onlyNumber', function () {
    return {
        require: 'ngModel',
        link: function (scope, element, attr, ngModelCtrl) {
            debugMessage("onlyNumber:link");
            function fromUser() {
                var text = ngModelCtrl.$viewValue;
                var isNum = false;
                if (!!attr.type && (attr.type === 'number' || attr.type === 'tel')) {
                    text = text + "";
                    isNum = true;
                }
                var transformedInput = text.replace(/[^0-9]/g, '');
                if (text === "") {
                    transformedInput = "";
                }
                if (transformedInput !== text || text === "") {
                    ngModelCtrl.$setViewValue(transformedInput);
                    ngModelCtrl.$render();
                }
                transformedInput = isNum ? parseInt(transformedInput) : transformedInput;
                return transformedInput;  // or return Number(transformedInput)
            }

            element.bind('keyup', fromUser);
            //ngModelCtrl.$parsers.push(fromUser);
        }
    };
});

app.directive('ngClick', function ($timeout) {
    return {
        restrict: 'A',
        link: function ($scope, element, $attrs) {
            // debugMessage("ngClick:link*");
            var timer;
            element.bind('click', clickFunction);

            function clickFunction(e) {
                //console.log("" + MATERIAL_DESIGN.LIST_ANIMATION_TIME);
                e.stopImmediatePropagation();// avoide parent click function
                // apply click function click event
                $scope.$eval($attrs.ngClick);
                $scope.$apply();
            }
        }
    };
});
