/**
 * Created by jji.yeon on 2017-10-28.
 */

app.filter('orderShoppingListBy', function () {
    return function (items, field, field2, reverse, list) {
        // debugMessage('orderShoppingListBy::: field = ' + field + ", field2 = " + field2);
        var filtered = [];
        angular.forEach(items, function (item) {
            filtered.push(item);
        });
        filtered.sort(function (a, b) {
            if (a[field] && b[field])
                return (a[field2] > b[field2]) ? 1 : -1;
            else if (a[field])
                return -1;
            else if (b[field])
                return 1;
            else {
                return (a[field2] > b[field2]) ? 1 : -1;
            }
        });

        if (reverse) {
            filtered.reverse();
        }
        var tempObj = {};
        filtered.forEach(function (val) {
            //http://stackoverflow.com/questions/3186770/chrome-re-ordering-object-keys-if-numerics-is-that-normal-expected
            tempObj[val.groupId] = val;  // used for home page list to show in sorted order based on a hack - groupId appended with " "
        });
        setTimeout(function () {
            //angular.copy(tempObj, list)
            //Commented angular.copy and instead using jquery.extend method to deep copy object, as sometimes angular.copy is not working properly
            //https://github.com/angular/angular.js/issues/10304
            //https://github.com/angular/angular.js/issues/11099
            list = jQuery.extend(true, {}, tempObj);
        }, 200);
        return tempObj;
    };
});

app.filter('orderItemBy', function() {
    return function(items, field, field2, reverse, list) {
        // debugMessage('orderItemBy::: field = '+ field + ", field2 = " + field2);
        var filtered = [];
        angular.forEach(items, function(item) {
            filtered.push(item);
        });

        //Order by RecipeName, id
        filtered.sort(function (a, b) {
            if (a[field] === b[field])
                return (a[field2] > b[field2]) ? -1 : 1;
            else if (a[field] > b[field])
                return -1;
            else if (a[field] < b[field])
                return 1;
            else {
                return (a[field2] > b[field2]) ? -1 : 1;
            }
        });

        //Check the started RecipeName position of Items
        var chkRecipe = "";
        var recipeStartPos = [];
        angular.forEach(filtered, function(item, index) {
            if (item[field] !== "" && item[field] !== chkRecipe) {
                recipeStartPos.push(index);
                chkRecipe = item[field];
                item['subTitle'] = true;
            }
            else if (item[field] === "") {
                recipeStartPos.push(index);
                item['subTitle'] = false;
            }
            else {
                item['subTitle'] = false;
            }
        });

        //re-order by recipe group and no recipe items.
        recipeStartPos.sort(function (a, b) {
            return (filtered[a][field2] > filtered[b][field2]) ? -1 : 1;
        });

        //create new array according to reordered recipeStartPos
        var filtered2 = [];
        angular.forEach(recipeStartPos, function(startIndex) {
            var recipeName = filtered[startIndex][field];
            var index = startIndex;

            if (angular.isDefined(recipeName) && recipeName !== "") {
                while (angular.isDefined(filtered[index]) && filtered[index][field] === recipeName) {
                    filtered2.push(filtered[index]);
                    index++;
                }
            }
            else {
                filtered2.push(filtered[index]);
            }
        });


        if (reverse) {
            filtered2.reverse();
        }
        setTimeout(function(){
            //angular.copy(tempObj, list)
            //Commented angular.copy and instead using jquery.extend method to deep copy object, as sometimes angular.copy is not working properly
            //https://github.com/angular/angular.js/issues/10304
            //https://github.com/angular/angular.js/issues/11099
            list = jQuery.extend(true, {}, filtered2);
        }, 200);
        return filtered2;
    };
});

app.filter('reverse', function () {
    return function (items) {
        if (!angular.isDefined(items))
            return false;
        return items.slice().reverse();
    };
});