/**
 * Created by jji.yeon on 2017-10-28.
 */

app.service('timeStamp', ['$timeout', '$filter', function ($timeout, $filter) {
    var scope = angular.element(document.getElementById("bodyTag")).scope();
    
    this.convertDate = function (inputDate) {
        if (angular.isUndefined(inputDate) || inputDate === "")
            return "";

        if (typeof(inputDate) === 'string') {
            var yr = parseInt(inputDate.split("T")[0].split("-")[0].substr(0, 4));
            var mon = parseInt(inputDate.split("T")[0].split("-")[1].substr(0, 2));
            var dt = parseInt(inputDate.split("T")[0].split("-")[2].substr(0, 2));

            if (angular.isDefined(inputDate.split("T")[1])) {
                var hour = parseInt(inputDate.split("T")[1].split(":")[0].substr(0, 2));
                var min = parseInt(inputDate.split("T")[1].split(":")[1].substr(0, 2));
                var sec = parseInt(inputDate.split("T")[1].split(":")[2].substr(0, 2));
            }
            else {
                hour = min = sec = 0;
            }

            //changed UTC time to Local Time.
            var outputDate = new Date(Date.UTC(yr, mon-1, dt, hour, min, sec));
            return outputDate;
        }
        else if (typeof(inputDate) === 'object')
            return inputDate;
    };

    //yyyyMMddHHmmss sss = id format
    //yyyy-MM-ddTHH:mm:ss = time format of payload
    //dateFormat rule: Refer to https://docs.angularjs.org/api/ng/filter/date
    this.getDateFormat = function (date, dateFormat, timezone) {
        //Checking the valid date.
        if (!angular.isDefined(date) || !(date instanceof Date && !isNaN(date.valueOf())))
            return "";

        //Checking the valid format.
        if (!angular.isDefined(dateFormat) || dateFormat === '')
            dateFormat = 'MMM d, yyyy, h:mm a';     //Default Format

        //Checking the valid timezone.
        if (angular.isDefined(timezone) || timezone !== '')
            return $filter('date')(date, dateFormat, timezone);
        else
            return $filter('date')(date, dateFormat);
    };

    this.displayDate = function (date, dateFormat) {
        if (!angular.isDefined(dateFormat) || dateFormat === "")
            dateFormat = 'MMM dd, yyyy';        //default format
        if (!angular.isDefined(date) || date === "")
            date = new Date();

        //Convert language
        try {
            var result = $filter('date')(date, dateFormat);
            if (dateFormat === scope.dateTimeFormat || dateFormat === scope.dateFormat || dateFormat === scope.timeFormat) {
                if (dateFormat.indexOf('MMM') !== -1) {
                    switch (date.getMonth()) {
                        case 0:
                            result = result.replace('Jan', scope.translation.WEBMOB_fhub2_common_abbr_january);
                            break;
                        case 1:
                            result = result.replace('Feb', scope.translation.WEBMOB_fhub2_common_abbr_february);
                            break;
                        case 2:
                            result = result.replace('Mar', scope.translation.WEBMOB_fhub2_common_abbr_march);
                            break;
                        case 3:
                            result = result.replace('Apr', scope.translation.WEBMOB_fhub2_common_abbr_april);
                            break;
                        case 4:
                            result = result.replace('May', scope.translation.WEBMOB_fhub2_common_abbr_may);
                            break;
                        case 5:
                            result = result.replace('Jun', scope.translation.WEBMOB_fhub2_common_abbr_june);
                            break;
                        case 6:
                            result = result.replace('Jul', scope.translation.WEBMOB_fhub2_common_abbr_july);
                            break;
                        case 7:
                            result = result.replace('Aug', scope.translation.WEBMOB_fhub2_common_abbr_august);
                            break;
                        case 8:
                            result = result.replace('Sep', scope.translation.WEBMOB_fhub2_common_abbr_september);
                            break;
                        case 9:
                            result = result.replace('Oct', scope.translation.WEBMOB_fhub2_common_abbr_october);
                            break;
                        case 10:
                            result = result.replace('Nov', scope.translation.WEBMOB_fhub2_common_abbr_november);
                            break;
                        case 11:
                            result = result.replace("Dec", scope.translation.WEBMOB_fhub2_common_abbr_december);
                            break;
                    }
                }

                if (dateFormat.indexOf('a') !== -1) {
                    result = result.replace("AM", scope.translation.WEBMOB_fhub2_common_am_capital);
                    result = result.replace("PM", scope.translation.WEBMOB_fhub2_common_pm_capital);
                }
            }
        }
        catch (error) {
            // console.log(error);
        }

        return result;
    }

}]);